package HOSTAgent;
#  $Name:  $ 
#  $Id: HOSTAgent.nu,v 1.1 2001/03/15 21:34:31 ccadieux Exp $
use PDM::Thresholds;
use Agent;
use Carp;
use vars qw($AUTOLOAD);
use System;

sub isSelectable {0}
sub revision {'$Revision: 1.1 $'}

@ISA = ('Agent');

sub new {
  my($self) = Agent->new();

  bless ($self, 'HOSTAgent');
  return $self;
}
sub DESTROY {}

sub RUN {
  my($agent,$ras_flag) = @_;
  my($showrev, $backup, $report);
  my($pdm) = $agent->{pdm};
  my($log_err, $lines);
  $DB::single = 1;
  Timelapse->start(ref($agent));

  if ($pdm->isXdays('readPatch', 1)) { # runs once a day

    $showrev = $agent->showrev();
    $backup  = $agent->backup();

    $report = {showrev => $showrev, backup_config => $backup};

    $agent->addIdentification($report);

    $id = {  accessName  => System->hostid(),
              deviceName  => System->hostid(),
              active      => "Y",
              logFile     => $logfile,
              name        => 'Host',
              category    => Report::CAT_HOST,
              ip          => System->hostname(),
           };

    $pdm->saveReport(Report->new($id, $report , undef));
  }

  my($err, $cache1, %ENC, @HBA, %MPX);

  $err = T3Agent->readT3IB($cache1, \%ENC, \@HBA, \%MPX, 1);
  $report = {mpxio => \%MPX, 'id.ipno' => System->get_ipno() };

  $agent->addIdentification($report);

  $id = {  accessName  => System->hostid(),
              deviceName  => System->hostid(),
              active      => "Y",
              logFile     => $logfile,
              name        => 'Host',
              category    => Report::CAT_MPXIO,
              ip          => System->hostname(),
           };

  $pdm->saveReport(Report->new($id, $report , undef));
 
  Timelapse->stop(ref($agent));
}

sub backup {
  my($agent) = @_;
  my($out);
  return {} if (Util->findMaster() ) ;

  open(O, System->get_home() . "/DATA/rasagent.conf");
  while ($l = <O>) {
     $out .= " " . $l;
  }
  close($out);
  return $out;
}

sub showrev {
  my($agent) = @_;
  my($patch, $ob, $req, $inc, $pack);
  my %R ;

  my ($err, $com) = Util->run_command("/usr/bin/showrev -p", "test", 100);

  foreach $l (@$com) {
     if ($l =~ /Patch: (.+) Obsoletes: (.*) Requires: (.*) Incompatibles: (.*) Packages: (.*)/) {
       $patch = $1;
       $ob    = $2;
       $req   = $3;
       $inc   = $4;
       $pack  = $5;
       $pack =~ s/ //g;
       $req  =~ s/ //g;
       $R{"patch.$patch"} = "$ob|$req|$inc|$pack";
     }
  }
 
  my ($err, $com) = Util->run_command("/usr/bin/pkginfo -l", "test", 100);
  my($sys, $pk, $name, $vers, $install);

  foreach $l (@$com) {
     my(@a) = split(/:  /, $l, 2);
     $a[0] = Util->ltrim($a[0]);

     if ($a[0] eq "PKGINST") {
        $pk = $a[1];

     } elsif ($a[0] eq "NAME") {
        $name = $a[1];

     } elsif ($a[0] eq "CATEGORY") {
        $sys = $a[1];

     } elsif ($a[0] eq "VERSION") {
        $vers = $a[1];

     } elsif ($a[0] eq "INSTDATE") {
        $install = $a[1];
        $R{"package.$pk"} = "$sys|$vers|$install|";    # $name";
     }
  }
  return \%R;
}
  
1;
