package SANAgent;

#  $Name:  $
#  $Id: SANAgent.pm,v 1.14 2001/08/23 00:24:21 ccadieux Exp $
use Agent;
use PDM;
use PDM::Modules;
use Carp;
use vars qw($AUTOLOAD);
use Report;
use strict;
use Debug;
use base 'Agent';
use vars qw( %RAID);
use Data::Dumper;

sub isSelectable {"SAN"}

sub revision {'$Revision: 1.14 $'}

sub new {
  my($self) = Agent->new();

  bless ($self, 'SANAgent');
  return $self;
}
sub DESTROY {}

sub RUN {
  my($agent, $ras_flag) = @_;
  my($mod, @mods, $x, @writes, @reads, $report);
  my($a5, $t3, $sw, $sum, @fc, $l);

  my($cache) = 0;
  my($pdm) = $agent->{pdm};

  my($renv) = $agent->{renv};
  $report = {};

  $DB::single=1;

  if (!$agent->category_selected() || 
      !$agent->category_selected("topo") ) {
     Debug->print2("Skipping " . ref($agent)  . ".");
     return;
  }
  if (0) {
  if (!Util->findMaster()) {  # on the master, store historical switch info
     if ($pdm->isXdays('readSwitchCounters', 1)) {
        $sw = SWITCHAgent->FCCounters({ cache => $cache});
        my $d1 = Util->today();
        my $D =  System->get_home() . "/DATA/tmp/SWC";
        mkdir $D, 0777 if (!-d $D);
        open(O, ">$D/" . substr($d1,3,2));
        print O Dumper($sw);
        close(O);
     }
  }
  }
    
  my($logfile)   = $agent->{renv}->{logfile};

  return if (!-r $logfile);
  Timelapse->start(ref($agent));

  my($log_err, $lines) = $agent->read_log_file($logfile,'NEW');
  my $skip;
  my $fc_type;
  my $powercycle;
  for ($x=0; $x<= $#$lines; $x++ ){
    $l = $lines->[$x];

    if ($l =~ /(scsi parity error)/) {
      push(@writes, $l);

    } elsif ($l =~ /Copyright .+ Sun Microsystems/) {
      $powercycle = 1;
      Debug->print2("Skipping SAN module, reason: Power-Cycle");
      return;

    } elsif ($l =~ /SCSI transport failed/) {
      push(@reads, $l);

    } elsif ($l =~ /OFFLINE/) {
      Timelapse->stop(ref($agent));
      Debug->print2("Skipping SAN module, reason: $l");
      return;

    } elsif ($l =~ /ONLINE/) {
      $skip = 1;
    }

  }
#  push(@reads, "TEST MESSAGE");

  FC->clearCache();
  if ($#reads >= 0 || $#writes >= 0) {
     Debug->print2("SAN:". ($#reads+1) . " READ and " . ($#writes+1) . " WRITES");
     $fc_type = "CRC";
     $skip = 0;
  } elsif (PDM->isXhours('fcic_counters', 1)) {
     $skip = 0;
     $fc_type = "ITW";

  } elsif (!$skip)  {
     Timelapse->stop(ref($agent));
     return;
  }
  $report->{"reads"} = \@reads;
  $report->{"writes"} = \@writes;
  my(@list);
  Debug->print1("-> SANAgent: Extracting Counters");

  $a5 = A5KAgent->FCCounters({ cache => $cache});
  $report->{FC_a5k} = $a5;

  $t3 = T3Agent->FCCounters( { cache => $cache});
  $report->{FC_t3} = $t3;

  $sw = SWITCHAgent->FCCounters({ cache => $cache}) if (!$sw);
  $report->{FC_switch} = $sw;

  my($id) = {  accessName  => "san",
           deviceName  => "san",
           name        => "san",
           category    => Report::CAT_SAN,
           ip          => "",
           };

  $pdm->saveReport( Report->new($id, $report , undef) , {skip_health => $skip} );
  Timelapse->stop(ref($agent));
}


# SANAgent->run_command
#
sub clear_cache {
 my($class) = @_;

}


sub run_command {
  my($class, $com, $ext, $arg, $save) = @_;
  my(@out, $err, $l, $ix);
  my($file);
  my($TMP) = System->get_home() ."/DATA/tmp";

  $file = "$com$ext";
  $ix = index($file, " ");
  $file = substr($file,$ix+1);
  $file =~ s/ /_/g;

  if ($save && -f "$TMP/luxdisc.$file" ) {
     open(W, "$TMP/luxdisc.$file");
     while ($l = <W>) {
       chop($l);
       push(@out, $l);
     }
     close(W);
     return("", \@out);
  }
  print "Running $com $arg in file ($file) ...\n" if (Debug->level() > 2);
  my($com1) = "$com $arg 2>$TMP/luxdisc.err";

  open(O, "$com1|");
  while ($l = <O>) {
    chop($l);
    push(@out, $l);
  }
  close(O);

  open(W, ">$TMP/luxdisc.$file");
  print W join("\n", @out);
  close(W);

  open(ERR, "$TMP/luxdisc.err");
  while ($l = <ERR>) {
    $err .= $l;
  }
  close(ERR);
  Debug->print0("Error: $err on $com") if ($err);

  return($err, \@out);
}



1;



