package STOOLS4Agent;
#  $Name:  $ 
#  $Id: STOOLS4Agent.pm,v 1.1 2001/03/01 16:17:01 ccadieux Exp $

use Agent;
use Debug;
use Carp;
use vars qw($AUTOLOAD);
use Report;
use strict;
use PDM::Thresholds;
use base 'Agent';

sub isSelectable {"STools4"}
sub revision {'$Revision: 1.1 $'}

sub new {
  my($self) = Agent->new();

  bless ($self, 'STOOLS4Agent');
  return $self;
}
sub DESTROY {}



sub RUN {
  my($agent,$ras_flag) = @_;
  my(%DONE, $HBA, $logfile, $r, @results);
  my($xml, @lux_dif, $dif, $ev, $found);
  my($log_err, $TH, $lines);
  my(%DONE, $report, $device, $wwn, $id, $x, $l, $connect_errs);
  my($renv) = $agent->{renv}; 
  my($pdm) = $agent->{pdm};
  if (!$agent->category_selected) {
     Debug->print2("Skipping " . ref($agent)  . ".");
     return;
  }

  Timelapse->start(ref($agent));

  my($today) = Util->today("YMDH");

  my($logfile)   = $renv->{st4logfile} . "/activity.log";

  $DB::single=1;
  if (-f $logfile) {
    ($log_err, $lines) = $agent->read_log_file($logfile,'NEW');
    Debug->err('CANNOT_READ', $logfile) if ($log_err);
  } else {
    return;
  }
  my(%Rep) = ();
  $agent->addIdentification(\%Rep);
  $report = \%Rep;

  $id = {     accessName  => "ST4-" . System->hostid(),
              deviceName  => "ST4-" . System->hostid(),
              name        => "ST4",
              category    => Report::CAT_ST4,
              ip          => "",
           };

  if ($#$lines >= 0) {
     $pdm->saveReport(Report->new($id, $report , $lines));
  } 
  Timelapse->stop(ref($agent));
}

1;

