package BerkCache;
#  $Name:  $ 
#  $Id: BerkCache.pm,v 1.2 2000/11/12 20:03:24 ccadieux Exp $

use BerkeleyDB;
#
# $cache = BerkCache::new({ file => "berk"});
#  relative file name will go in /tmp
# $SIG{'INT'} = 'die';
# $SIG{'TERM'} = 'die';
# Catch signals to avoid deadlocks
# sub die { local($sig) = @_; $dead = 1}
# $val = $cache->get($key);
# $cache->set($key,"$$");


$ERR = "";
@caches = ();

sub new {
  my($t) = @_;
  my($env, $db, %H); 

  if ($t->{file} eq "") {
    $ERR = "File must be specified!";
    return undef;
  }
  
  bless($t,'BerkCache');

  $env = new BerkeleyDB::Env
              -Home  => "/tmp",
#              -Flags => DB_CREATE| DB_INIT_TXN| DB_INIT_LOCK| DB_INIT_MPOOL;
              -Flags => DB_CREATE| DB_INIT_LOCK| DB_INIT_MPOOL;

  if (!($db = tie %H, "BerkeleyDB::Hash",
                -Filename => $t->{file},
                -Flags    => DB_CREATE,
                -Env      => $env)) {
     $ERR = "Cannot open file $filename: $! $BerkeleyDB::Error";
     return undef;
  }
  
  push(@caches, $t);
  $t->{db}   = $db;
  $t->{env}  = $env;
  $t->{hash} = \%H;
  return $t;
}

sub close {
  foreach $x (@caches) {
    $h = $x->{hash};
    untie %$h;
  }
  print "caches untied!\n";
}

sub get {
  my($t,$key) = @_;
  my($h) = $t->{hash};
  return $h->{$key};
}

sub set {
  my($t,$key,$value) = @_;
  my($tx);
  my($db) = $t->{db};
  my($env) = $t->{env};

#  $txn = $env->txn_begin() ;
  $db->db_put($key, $value);
#  $txn->txn_commit();
  $db->db_sync();

}


1;
