package Debug;
#  $Name:  $ 
#  $Id: Debug.pm,v 1.15 2001/08/24 00:01:09 ccadieux Exp $

use System;

my %Errors = (

  CANNOT_WRITE_PIDFILE => "Cannot write to PIDfile: %s, installation problem, aborting!",
  CREATING_PIDFILE     => "Creating PIDfile and proceeding..",
  HOURS_PASSED         => "%s hours passed since last reset, will reset every %s hours.",
  PROCESSING           => "Processing %s",
  IP_NOT_FOUND         => "%s IP not found in config file!",
  MAIL_FAILED          => "Warning: Cannot complete mailing of errors to %s",
  MAILING_BYTES        => "Mailing %s bytes to %s",
  NOTHING_TO_EMAIL     => "Nothing to Email",
  REMOVING_PID         => "Removing PID file.",
  CONNECTING_T300      => "Connecting to t300: %s, %s, %s",
  READING_MESSAGE_FILE => "Reading message file: %s",
  READ_X_LINES         => "Read %s lines, saved %s t300 log lines, %s A5000 log lines.",
  FAILING_TO_KILL      => "Failing to kill processes (%s, %s)!",
  RASAGENT_STILL_RUNNING=>"rasagent still running, looks hung, trying to kill..",
  RASAGENT_RUNNING     => "rasagent %s is still running... Exiting!",
  REMOVING_PIDFILE     => "Removing PIDfile..",
  WRONG_PROGRAM        => "The wrong program (%s) is still running , trying to kill it.." ,
  CANNOT_READ          => "Cannot read %s !",
  CANNOT_EXECUTE       => "Cannot execute mail program: %s !",
  ENCRYPT_BUG          => "problem with encrypt: %s ",
  CRON_CONFLICT        => "%s",
  SUCCESSFUL_PING      => "Succesful ping %s",
  PING_MASTER_FAILED   => "Cannot ping master rasagent at IP: %s",
  TRANSFER_MASTER_FAILED=> "Cannot transfer to master rasagent at IP: %s: %s",
  CANNOT_TELNET        => "Cannot TELNET to %s",
  NO_HBA               => "No HBA(s) detected",
  MULTIPLE_HBAS        => "Multiple types of HBA(s) Detected.",
  DATA_PING_PROBLEM    => "Problem with PING %s",
  TELNET_IS_NOW_DOWN   => "Telnet is not accessible anymore, was before",
  TELNET_IS_BACK       => "Telnet was down, is now accessible",
  DATAPING_IS_NOW_DOWN => "Data-Ping is not accessible anymore, was before",
  DATAPING_IS_BACK     => "Data-Ping was down, is now accessible",
  SDT                  => "Scheduled Down Time at %s",
  SDT_ERROR            => "SDT Format Error: %s",
  WRITE_HASH_FAILED    => "Failed to write back to cache file %s: %s",
  ERR_MOD_DIR          => "Error reading Modules directory: %s",
  SDT_MODULE           => "%s: Scheduled Down Time at %s",
  RUN_MISSING          => "'run' method missing in module: %s",
  SEND_MASTER          => "Transfering %s bytes to MASTER %s",
  TIMELAPSE_SET        => "Failed on util->set_hb",
  TEXT                 => "%s",
  FC                   => "%s",
  ERROR                => "ERR %s",
  CANNOT_READ          => "Cannot read file: %s",
  CANNOT_HTTP          => "Cannot connect with HTTP to %s",
  NO_RAID_MGR          => "%s: Raid Manager not installed",
  SEND_MASTER_FAILED   => "Sending to Master failed: %s %s",
  CANNOT_WRITE         => "Cannot write file: %s",
  NO_CONFIG_FILE       => "Cannot get confg file from master %s",
  CANNOT_RUN           => "Cannot execute program: %s : %s!",
  LUXADM_ERR           => "Luxadm error: %s",
  INVALID_SOURCE       => "The source code is invalid!",
  INVALID_ED           => "Invalid Event Document",
  HTTP_ERROR           => "HTTP_ER %s",
  NO_SW                => "Cannot open Threshold file: %s %s",
  NO_DEVICE_MAP        => "Cannot access DeviceState.map: %s",
  CIM_ERR              => "CIM_ER %s",
  LOAD_MODULE          => "Error loading: %s",
  SCHEMA               => "Schema: %s",
  SANBOX               => "Sanbox %s",
  PING                 => "PING %s",
  SAF                  => "SAF %s",
  NETCONNECT           => "NETConnect %s",
  UUCP                 => "%s",
  CHECKSUM             => "CKS %s",
  SNMP                 => "%s",
  DISCMAN              => "%s",
  SRS                  => "%s",
  );

@SYSTEM_ERRORS = ();

sub warning {
  my($debug, $line, $var1, $var2, $var3, $var4 ) = @_;

  $debug->err_war("WRN", $line, $var1, $var2, $var3, $var4);
}


sub err {
  my($debug, $line, $var1, $var2, $var3, $var4 ) = @_;

  $debug->err_war("ERR", $line, $var1, $var2, $var3, $var4);
}

sub err_war {
  my($debug, $type, $line, $var1, $var2, $var3, $var4 ) = @_;

  $ERROR_LOGFILE = System->get_home . "/log/errors.log";
  if (!$Errors{$line}) {
    print STDERR "Unknown error Code: $line\n";
  } else {
    $o = sprintf($Errors{$line}, $var1, $var2, $var3, $var4);
    Debug->truncate($ERROR_LOGFILE, 2);
    $dt1 = &datetime . " $type ";
    if (open(O,">>$ERROR_LOGFILE")) {
       print O "$dt1 $o\n";
       close(O);
       print STDERR "  ***$type: $o\n";
       Util->string2file($o, "last_sys_error");
    } else {
       print STDERR "  Cannot write to log file $ERROR_LOGFILE!\n";
    }
    push(@SYSTEM_ERRORS, $dt1 . $o);
  }
}

$LEVEL          = 0;

sub dump {
  my($class, $file, $obj, $recurse) = @_;
  my($o, $i);
  require Data::Dumper;
  return if ($LEVEL < 1);
  if (!open(O, ">" . System->get_home . "/DATA/dump/$file")) {
     Debug->err(CANNOT_WRITE => "dump/$file");
  } else {
    print O "-----------------------\nFILE: $file\n-----------------------\n";
    if ($recurse) {
      $Data::Dumper::Indent = 1;
      $o = Data::Dumper::Dumper($obj);
      print O "FILE: $file \n$o\n";
    } else {
      my($curr) = "";
      foreach $x (sort keys %$obj) {
          my($y) = index($x, ".");
          if (substr($x, 0, $y) ne $curr) {
            print O "\n" if ($curr);
            $curr = substr($x, 0, $y) ;
          }
          my($pat) = "%-35s = %s\n";
          print O sprintf($pat, $x,$obj->{$x});
      }
    }
    close(O);
  }
}

sub level {
  my($class, $level) = @_;
  $LEVEL = $level if (defined($level));
  return $LEVEL;
}

sub new {
  my($class, $env) = @_;  
  my($debug) =  {};
  $LEVEL                = $env->{debug_flag};

  bless ($debug , $class);
}

sub datetime {
  my(@date) = localtime(time); $date[4]++; $date[5] += 1900;
  sprintf("%2.2d-%2.2d-%d %2.2d:%2.2d:%2.2d",
           $date[4],$date[3],$date[5],$date[2],$date[1],$date[0]);
}

sub truncate {
  my($debug, $file, $max) = @_;
  $max = 2 if (!$max);
  $size = (stat($file))[7];
  if ($size > $max * 100000) {
     rename $file, $file . ".2";
  }
}



# returns a string 
sub get_system_errors {
  my($debug) = @_;
  my($l, $out);
  if ($#SYSTEM_ERRORS >= 0) {
    return " " . join("\n ", @SYSTEM_ERRORS);
  } else {
    return undef;
  }
}

sub log {
  my($class, $line) = @_;
  open(O, ">>/tmp/ras.log"); print O $line . "\n"; close(O);
}

sub snapshot {
  my($class, $line) = @_;
  return if (Debug->level() <= 2);
  open(O, ">>"  . System->get_home() . "/DATA/snapshot.log"); 
  print O $line . "\n"; 
  close(O);
}

# indented in log file
sub snapshot1 {
  my($class, $line) = @_;
  return if (Debug->level() <= 2);
  open(O, ">>"  . System->get_home() . "/DATA/snapshot.log"); 
  $line =~ s/\n/\n  /g;
  print O $line . "\n"; 
  close(O);
}

# print debugging info

sub print {
  my($debug, $line, $var1, $var2, $var3, $var4) = @_;
  my($o);
  if (!$Errors{$line}) {
    print STDERR "  Unknown error Code: $line\n";
  } else {
    $o = $line . " " . sprintf($Errors{$line}, $var1, $var2, $var3, $var4);
    print STDERR "  $o\n" if ($LEVEL);
  }
}

sub print0 {
  my($debug, $line) = @_;
  if ($0 =~ /rasagent/) {
    print STDERR "  $line\n" 
  } else {
    print "$line<br>";
  }
}

# print debugging info
sub print1 {
  my($debug, $line) = @_;
  print STDERR "  $line\n" if ($LEVEL > 0);
}

sub print2 {
  my($debug, $line) = @_;

  if ($LEVEL > 1) {
    if ($0 =~ /rasagent/) {
      print STDERR "  $line\n" 
    } else {
      print "$line<br>";
    }
  }
}
sub print3 {
  my($debug, $line) = @_;
  if ($LEVEL > 2) {
    if ($0 =~ /rasagent/) {
      print STDERR "  $line\n" 
    } else {
      print "$line<br>";
    }
  }
}

sub dot2 {
  my($debug) = @_;
  print STDERR "." if ($LEVEL > 1);
}

1;



__END__

=head1 NAME

Debug.pm - Debug static class


=head3 SYNOPSIS

 use Debug;


=head3 DESCRIPTION

This module handles data-dump, printing to the logfiles and validated 
error and warnings.


=head3 METHODS

=over 4

=item dump(<file>, <object> , <recurse_flag>);

Will dump any  data-structure (hash and array ref) to a file.
with recurse_flag=1, it will use data-dumper, otherwise , it will
assume a one level deep hash-ref.

=item level();

Sets the debugging level: 0,1,2. 2 has the most debugging.

=item truncate(<file>, <Megs>);

Will truncate a file to a maximum size.

=item warning(<ERROR_CODE>, <arg1>, <arg2>, <arg3>);

Writes to HOME/log/errors.log a valid warning.Will also print the error
to STDERR.

=item error(<ERROR_CODE>, <arg1>, <arg2>, <arg3>);

Writes to HOME/log/errors.log a valid error. Will also print the error
to STDERR.

=item get_system_errors();

returns a ARRAYREF to all generated errors and warnings. Used to
create events.

=item print(<line>, $arg, $arg2);

Will print to STDERR a valid error if LEVEL > 0;

=item print1($text)

Will print to STDERR any text if LEVEL > 0;

=item print2($text)

Will print to STDERR any text if LEVEL > 1;


=back 4

=head3 SEE ALSO




=head3 AUTHOR

 Christian Cadieux (ccadieux@central.sun)



=head3 COPYRIGHT

Copyright (c) 2000 Sun Microsystems

=cut
