package Event;
#  $Name:  $ 
#  $Id: Event.pm,v 1.2 2000/11/12 20:03:26 ccadieux Exp $

use Util;
use System;

########################################################################
# OLD STUFF
########################################################################

%TYPES = (
#      code     desc                              prio   xml_name       device/host
       C  => ['Device Configuration Information', 2, 'device_config', 'd'],
       S  => ['Device State Information',         1, 'device_state',  'd'],
       L1  => ['Message-Log Errors',              1, 'error_log',     'd'],
       L2  => ['Message-Log Warnings',            2, 'warning_log',   'd'],
       L3  => ['Message-Log Information',         3, 'notice_log',    'd'],
       x  => ['Connect Errors',                   1, 'device_error',  'd'],
       s  => ['Device statistics',                3, 'device_stats',  'd'], # but weekly
       y  => ['System Configurations',            3, 'host_config',   'h'],
       h  => ['Host disk_inquiry',                2, 'host_disk_inq', 'h'],
       p  => ['Host Data Ping',                   1, 'host_data_ping', 'h'],
       e  => ['System Errors',                    1, 'system_error',  'h'],
     rsL2 => ['RAS-Server Message-Log Warnings',  2, 'ras_server_warning_log','h'],
      );


sub get_types {
  return \%TYPES;
}

sub get_category {
  my($obj, $code) = @_;
  return $TYPES{$code}[3];
}

sub get_xml_name {
  my($obj, $code) = @_;
  return $TYPES{$code}[2];
}

sub get_description {
  my($obj, $code) = @_;
  return $TYPES{$code}[0];
}

sub get_code {
  my($obj, $xml_name) = @_;
  foreach $x (keys %TYPES) {
    if ($TYPES{$x}[2] eq $xml_name) {
       return $x;
    }
  }
  return undef;
}

sub get_description2 {
  my($obj, $xml_name) = @_;
  foreach $x (keys %TYPES) {
    if ($TYPES{$x}[2] eq $xml_name) {
       return $TYPES{$x}[0];
    }
  }
  return undef;
}



sub get_priority {
  my($obj, $code) = @_;
  return $TYPES{$code}[1];
}

#
# is_new is true if the mode is 'n' and it's not a LOG_event
#
sub is_new {
  my($obj, $e) = @_;
  my($event_type, $mode, $et);
  
  $ix = index($$e, "\n");
  return 0 if ($ix < 0);

  my($head) = substr($$e, 0, $ix);
  $head =~ /event_type=\"(\w+)\"\s+modes=\"(\w+)\"/;
  $event_type = $1;
  $mode = $2;
  $et = Event->get_code($event_type);

  if ($mode eq "n" && substr($et,0,1) ne "L") {  
     return  1;
  }
  return 0; # LOG_event are never new.
}


sub print_el {
  my($class, $el, $space) = @_;
  my($elem, $atts, $out, $cnt, $first);
  $first = 1;
  $out = $space . sprintf("%-10s: ", $el->{elem_type});

  foreach $k (sort keys %$el) {
     next if ($k eq "elem_type");
     $out .= "\n$space" . " " x 12  if ($cnt % 3 == 0 && !$first);
     $val = $el->{$k};
     if ($k =~ /WWN/) {
         $val =~ s/0000000000/0/g;
     }
     if ($val) {
        $out .= "$k='$val', ";
        $cnt++; $first =0;
     }
  }
  $out .= "\n";
  return $out;
}

sub print_err {
  my($class, $el, $space) = @_;
  my($elem, $atts, $out, $cnt, $first);
  $first = 1;
  $out = $space . sprintf("%-8s: ", $el->{line_type});

  foreach $k (sort keys %$el) {
     next if ($k eq "line_type");
     $out .= "\n$space" . " " x 12  if ($cnt % 3 == 0 && !$first);
     $out .= "$k='$el->{$k}', ";
     $cnt++; $first =0;
  }
  $out .= "\n";
  return $out;
}

  
  

1;
