package FC;
use Util;
use System;


@Counters = ('LINK', 'SIG', 'SEQ', 'CRC', 'SYNC', 'TXW', 'INF', 'OUTF');
@Description = ('Link Failures', 
                'Signal Loss', 
                'Invalid Sequence', 
                'Invalid CRC', 
                'Sync Loss', 
                'Invalid Transaction Words',  
                'In Frames', 'Out Frames'
              );
$APPLET = 
  "code=\"RasGraph2.class\" codebase=\"/Chart2\" archive=\"rasapplet.jar\" ";



sub LINK {0}
sub SIG  {1}
sub SEQ  {2}
sub CRC  {3}
sub SYNC {4}
sub TXW  {5}
sub INF  {6}
sub OUTF {7}

#
# clears /DATA/tmp/luxadm.*
#
sub clearCache {
  my($class) = @_;
  my($dir) =  System->get_home() . "/DATA/tmp/";
  opendir(O, $dir);
  my(@files) = readdir(O);
  closedir(O);
  foreach my $f (@files) {
    if (substr($f, 0, 8) eq "luxdisc.")  {
       unlink "$dir/$f";
    }
  }
}


sub run_command {
  my($class, $com, $ext, $arg, $save, $to) = @_;
  my(@out, $err, $l, $ix);
  my($file);
  my($TMP) = System->get_home() ."/DATA/tmp";
  $to = 60 if (!$to);

  $file = "$com$ext";
  $ix = index($file, " ");
  $file = substr($file,$ix+1);
  $file =~ s/ /_/g;

  if ($save && -f "$TMP/luxdisc.$file" ) {
     open(W, "$TMP/luxdisc.$file");
     while ($l = <W>) {
       chop($l);
       push(@out, $l);
     }
     close(W);
     return("", \@out);
  }
  print "Running $com $arg in file ($file) ...\n" if (Debug->level() > 2);
  my($com1) = "$com $arg 2>$TMP/luxdisc.err";

  eval {
    local $SIG{ALRM} = sub { die "alarm\n" };
    alarm $to;
    if (open(O, "$com1|")) {
      while ($l = <O>) {
         chop($l);
         push(@out, $l);
      }
      close(O);
    }
  };
  alarm 0;
  if ($@ eq "alarm\n") {
       Util->killCommand($com, $to);
       return ("Timeout", []);
  }
  
  open(W, ">$TMP/luxdisc.$file");
  print W join("\n", @out);
  close(W);

  open(ERR, "$TMP/luxdisc.err");
  while ($l = <ERR>) {
    $err .= $l;
  }
  close(ERR);
  Debug->print0("Error: $err on $com") if ($err);

  return($err, \@out);
}


1;

