package Fibre::Rules;

use Util;
use System;
use FibreStat;
use Data::Dumper;
use BK2;
use Time::JulianDay;
use Agent;

#lnk fail    sync loss   signal loss   sequence err   invalid word   CRC

sub run {
  my($q) = @_;
  print "<body bgcolor=#F0F0F0><center>";    
  print "&nbsp;"; 
  print "<table border=1 cellspacing=0 width=90% bgcolor=white>
 <form><input type=hidden name=GO value=Fibre::Rules::run>
 <tr bgcolor=#666699><td colspan=2><font color=white><b>Rule Exerciser
    </td>

 <tr><td colspan=2>This program will look for new Fibre-related entries in /var/adm/messages,
  then read all counters, find counters that went up since the last run and call the appropriate
  rules. Rules will fire when all conditions and thresholds are met.</td> 
 <tr> 
     <td width=20%>&nbsp;<b>Clear Cache: <input type=checkbox name=clear></td>
     <td>&nbsp;<b>Run :<input type=submit name=ACTION value=RUN></td>
  </table>
  </form>
  ";
  return if ($q->{ACTION} ne "RUN");

  my(@reads, @writes);
  print "</center><pre>";
  $logfile = "/var/adm/messages";
  Debug->level(0);
  %Agent::LOGFILES = ();

  PDM->dumpCache();
  ($log_err, $lines) = Agent->read_log_file($logfile,'NEW');
  PDM->writeCacheObject("read_log_file");

  print "Found " . ($#$lines+1) . " lines in messages ";

  for ($x=0; $x<= $#$lines; $x++ ){
    $l = $lines->[$x];
    if ($l =~ /(scsi parity error)/ || $l =~ /scsi: .*WARNING/) {
      push(@writes, $l);
    } elsif ($l =~ /SCSI transport failed/) {
      push(@reads, $l);
    }
  }

  if ($#reads >= 0 || $#writes >= 0) {
     print  ($#reads+1) . " READ and " . ($#writes+1) . " WRITES";
  } else {
#      return;
  }
  print "<br>";
  my($renv, $devs, $hosts,$notifs) = $main::PDM_ConfigFile->read;

  $date = &today();  # MMDDHH:MM:SS
  $cache = $q->{clear}? 2:0;
  ($a5k, $summ) = FibreStat::a5k_luxdisc($q,{cache => 0, report => 0, cache => $cache});

  ($t3, $summ) = FibreStat::t3_luxdisc($q,{cache => 0, report => 0, debug => 1, cache => $cache});


  $NEW{info}{date} = $date;
  for ($x=0; $x <= $#$a5k; $x++) {
      if (substr($a5k->[$x],0,1) eq "#") {
        my(@b) = split(/=/, substr($a5k->[$x],1));
        $NEW{info}{"hba_a$b[0]"} = $b[1];
      } else {
        @a = split(/\t/, $a5k->[$x]);
        $NEW{value}{$a[0]} = $a5k->[$x];  
      }
  }

  for ($x=0; $x <= $#$t3; $x++) {
      if (substr($t3->[$x],0,1) eq "#") {
        my(@b) = split(/=/, substr($t3->[$x],1));
        $NEW{info}{"hba_t$b[0]"} = $b[1];
      } else {
        @a = split(/\t/, $t3->[$x]);
        $NEW{value}{$a[0]} = $t3->[$x];  
      }
  }

  my($x0, $summ); 
  @switch = ();
  foreach my $d (@$devs) {
     if ($d->{type} eq "switch") {
        ($x0, $summ) = 
             FibreStat::sw_luxdisc($q,{ip    => $d->{ip}, 
                                   cache => 0, 
                                    name => $d->{name}});
         for ($x = 0; $x <= $#$x0; $x++) {
             @a = split(/\t/, $x0->[$x]);
             $NEW{value}{$a[0]} = $x0->[$x]; 
         }
     }
  }
  
  my($VAR1);
#
# '1|b1|r08|a'
# '|switch-b|p01|s'
#  key \t link \t signal \t seq \t crc \t sync \t word 
#

  my($F) = System->get_home() . "/DATA/Counters";
  @rules = Fibre::Rules->load_rules();

  my($th) = PDM::Thresholds->new;
  $th->init;

 
  if (open(O, $F)) {
     @x = <O>;
     close(O);
     eval "@x";
     # compare $NEW and $VAR1;
     $new = $NEW{value};
     $old = $VAR1->{value};
     $found = 0;

     TO->readTopo(System->hostname());

     foreach $k (sort keys %$new) {
        @o1 = split(/\t/, $old->{$k});
        @n1 = split(/\t/, $new->{$k});
        $o_crc = $o1[4];
        $n_crc = $n1[4];
        if ($n_crc > $o_crc) {
           $found++;
           print "CRC went up by " . ($n_crc - $o_crc) . " in $k <br>";
           foreach $r (@rules) {
              $ix = rindex($r, "::");
              $rulename = substr($r, $ix);
              print "<table border=0 bgcolor=white width=100%>".
                    "<tr><td><b>Trying rule $rulename</b></table>";
              next if ($r->category() ne "CRC") ;
              ($error, $event) = $r->run($th, $n_crc - $o_crc, $k, $NEW{info}, 
                                         \@reads, \@writes);
              print $event if ($event);
           }
        }
     }
     if (!$found) { print "<b>Found nothing!<br>"}
  } else {
     print "Initializing Counters database!<br>";
  }
  $th->serialize;
  if (open(O, ">$F")) {
    print O Dumper(\%NEW);
    close(O);
  } else {
    print "failed to open $F: $!<br>";
  }
}


# MMDDHH:MM:SS
sub today {
  my($this) = @_;

  my(@date) = localtime(time);
  $date[4]++; $date[5] += 1900;

  sprintf("%2.2d%2.2d%2.2d%2.2d%2.2d",
    $date[4],$date[3], $date[2], $date[1], $date[0]);
}


sub load_rules {

  my(@R);
  my($DIR) = System->get_home() . "/lib/Fibre/Rules";
  opendir(D, $DIR);

  @rules = readdir(D); closedir(D);
  foreach $rulefile (sort @rules) {
     next if ($rulefile !~ /\.pm/) ;

     $rulename = substr($rulefile, 0, -3);
     eval "require \"Fibre/Rules/$rulename.pm\"";
     $r = "Fibre::Rules::$rulename";
     push(@R, $r);
  }
  return @R;
}
  
sub log {
  my($class, $rule, $node1, $node2, $title, $reads, $writes) = @_;
  my($info);
  return if (!$node1 || !$node2);
  $log = System->get_home() . "/DATA/CountersLog";
  $date = &today();

  open(O,  ">>$log");
  my($cnt) = 0;
  foreach my $l (@$reads) {
     $info .= "  $l\n";
     last if ($cnt++ > 10);
  }

  $cnt = 0;
  foreach my $l (@$writes) {
     $info .= "  $l\n";
     last if ($cnt++ > 10);
  }

  print O "$date\t$rule\t$node1\t$node2\t$title\n$info";
  close(O);
}

#
# 
#
sub a5kIsFirst {
  my($class, $hb , $a5, $port_type) = @_;
  
  my($port2, $linkno, $ses_info);
  my($a5_info)  = $a5->{info};
  my($a5_name)  = $a5_info->{name};
  my($is_first) = 0;

  if ($a5_info->{ses_A} =~ /$hb/) {
       $ses_info = $a5->{ses_info}[0];
       $linkno= 0; 
       $portab = "A";
  }
  if ($a5_info->{ses_B} =~ /$hb/) {
       $ses_info = $a5->{ses_info}[1];
       $linkno= 1;
       $portab = "B";
  }

# IB-A  has 2 ports Port-0 and Port-1
# IB-B  has 2 ports Port-0 and Port-1

  $gb = Util->deserialize("GBICS");

  $port2 = $gb->{"$a5_name:$portab"};

  if ($port2 == 0 && ($port_type eq "f")) {
    $is_first = 1; # front

  } elsif ($port2 == 1 && ($port_type eq "r")) {
    $is_first = 1; # rear

  } else {
    return undef;
  }
  return $linkno;
}


#
#  will find if the target device from /var/adm is the last disk 
#  of the a5k, the ses# is known.
#
sub a5kTargetIsLast {
  my($class, $reads, $writes, $a5, $ses_no) = @_;
  my($wwn, $disk_wwn);
  my($disks) = $a5->{disk_info};
  my(@wwns) = ();

  my($portab) = ($ses_no == 0) ? "A" : "B"; # N/U

  my($sess) = $a5->{ses_info};
  my($a5_name) = $a5->{info}{name};
  my($ses_info) = $sess->[$ses_no];

  $gb = Util->deserialize("GBICS");

  $port2 = $gb->{"$a5_name:$portab"};

  print "$a5_name: portWWN = $ses_info->{PortWWN} board=$portab, port=$port2<br>";

  foreach $l (@$reads) {
      if ($l =~ /\@w([0-9abcdef]+)/) {
        push(@wwns,$1);
      }
  }
  foreach $l (@$writes) {
      if ($l =~ /\@w([0-9abcdef]+)/) {
        push(@wwns,$1);
      }
  }
  my($fire) = 0;
  my($disk);
  my($target_disk) = undef;

  foreach $disk (keys %$disks) {
      $disk_wwn = substr($disks->{$disk}{NodeWWN}, 2) ;
      foreach $wwn (@wwns) {
         if (substr($wwn,2) eq $disk_wwn && substr($disk,1) eq "10" ) {
             if ( (($port2 == 0) && substr($disk,0,1) eq "r") ||
                  (($port2 == 1) && substr($disk,0,1) eq "f") ) {
                 print "found disk = $disk ($wwn)<br>";
                 $target_disk = $disk;
                 $fire = 1;
                 last;
             }
         }
      }
      last if ($fire);
  }
  return $target_disk;
}

1;
