package Fibre::Rules::Rule2;
use TObjects;
use Data::Dumper;

# WRITE
sub description {
  return "ISL Port CRC error in switch";
}


sub category {
  return "CRC";

}

sub run {
  my($class, $th, $count, $key, $info, $reads, $writes) = @_;

  my($hba, $name, $port, $type) = split(/\|/, $key);

  return(undef,undef) if ($type ne "s"); # Switch

  $port = substr($port,1) + 0;
 
  $sw_no = $TO::NamesH->{"s:$name"};
  
  $sw = $TO::Switches->[$sw_no];
  
  $info = $sw->{info};

  $port_info = $sw->{port_info};
  
  $port_type = ($port_info->[$port]{RegisterName} =~ /-sp\d\(/ ) ? "s" : "X";

  return if ($port_type ne "s"); # ISL port

  $links = $sw->{port};
  $link  = $links->[$port];

  my($ltype, $sw_no2, $port2) = split(/:/, $link);

  if ($ltype ne "s") { # not a switch to switch 
     return ("Error: Must botb be switches", undef);
  }
  print "   <b><font color=red>Rule 2 fired</font></b>\n";

  $sw2 = $TO::Switches->[$sw_no2];
  $info2 = $sw2->{info};

  $o = Dumper($hba);

  print "   <b>Origin Point</b>: ISL port $port on switch: $info->{name} at $info->{ip}\n";
  print "   <b>Destination Point</b>: ISL port $port2 on switch: $info2->{name} at $info2->{ip}\n";

  Fibre::Rules::log(2, $info->{name} . ":" . $port, 
                       $info2->{name} . ":" . $port2,
                      "", $reads, $writes);


  return (undef, "");
}


1;


