package Fibre::Rules::Rule3;
use TObjects;
use Data::Dumper;

# WRITE
sub description {
  return "Single target device CRC error (tape or T3 or A3500FC device)";
}

sub category {
  return "CRC";
}

sub run {
  my($class, $th, $count, $key, $info, $reads, $writes) = @_;

  my($hba, $name, $port, $type) = split(/\|/, $key);
print "$hba,$name,$port,$type<br>";

  return (undef,undef) if ($type ne "3" && $type ne "t"); # single target devices

  $port = substr($port,1) + 0;

 
  if ($type eq "t") {
 
    $t3_no = $TO::NamesH->{"t:$name"};

    print "is a t3 , name=$name, no=$t3_no\n";

    $t3 = $TO::Storages->[$t3_no];
  
    $info = $t3->{info};

    print "name = $info->{name}<br>";
 
    $links = $t3->{ses};  # ses are the controllers
    $link  = $links->[0];

    my($ltype, $hno, $pno) = split(/:/, $link);
print "ltype=$ltype, name=$name,<br>";
    if ($ltype eq "h" || $ltype eq "s") {      # connected to a host, dport
        my($level, $cnt, $desc, $mins) =
              $th->test("counters","rule3","$name" , 1);

print "level=$level<br>";
        if ( $level eq "E") { # error level threshold fired
           print "   <b><font color=red>Rule 3 fired</font></b>\n";
           if (ltype eq "h") {        # host
              $host = $TO::Hosts->[$hno];
              $hbas = $host->{port_info};
              $hba  = $hbas->[$pno];
              $o = Dumper($hba);
              print "   <b>Origin Point</b>: Hba $pno on $host->{info}{name}</b><pre>\n " .
                  substr($o, 7) . "<br>";
              print "   <b>Destination Point</b>: T3 $info->{name} \n";

              Fibre::Rules->log(3, 
                      "$host->{info}{name}:$pno",
                      "t:$name:0",
                      "Hba or T3", $reads, $writes);

           } elsif ($ltype eq "s") {  # switch
              $sw = $TO::Switches->[$hno];
              $sw_info = $sw->{info};
              print "   <b>Origin Point</b>: Dport $pno on Switch $sw_info->{name}</b><pre>\n";
              print "   <b>Destination Point</b>: T3 $info->{name} at $ip\n";

              Fibre::Rules->log(3, 
                      "$sw_info->{name}:$pno",
                      "t:$name:0",
                      "Dport or T3", $reads, $writes);

           }
        }
   
     } else {
        return ("t3 should be connected to a host or switch : ltype=$ltype",undef);
     }
  } 

  return (undef, "");
}


1;


