package Fibre::Rules::Rule6;
use TObjects;
use Data::Dumper;

# READ
sub description {
  return "dPort CRC error in switch and target is LAST one or single target";
}
# last is r10 using interface A
# last is f10 using interface B
# scsi: [ID 107833 kern.warning] WARNING: /pci@6,2000/pci@2/SUNW,qlc@4 /fp@0,0/ssd@w220000203722c4bd,0 (ssd251):


sub category {
  return "CRC";
}

sub run {
  my($class, $th, $count, $key, $info, $reads, $writes) = @_;

  print "number or read messages=$#$reads, Writes=$#$writes<br>";

  my($hba, $name, $port, $type) = split(/\|/, $key);
  return(undef,undef) if ($type ne "s");

  $port = substr($port,1) + 0;

#  TO->readTopo("intruder");  
 
  $sw_no = $TO::NamesH->{"s:$name"};
  
  $sw = $TO::Switches->[$sw_no];
  
  $info = $sw->{info};

#  print "name = $info->{name}<br>";
 
  $port_info = $sw->{port_info};
  
  $port_type = ($port_info->[$port]{RegisterName} =~ /-ip\d\(/) ? "i" : "d";

  print "port $port type =$port_type<br>";

  return (undef,undef) if ($port_type ne "d"); 

  $links = $sw->{port};
  $link  = $links->[$port]; # where is the port going

  my($ltype, $hno, $pno) = split(/:/, $link);

  print "ses# = $pno<br>";

  if ($ltype eq "h") { 
     return ("Error: dport is pointing to a host", undef);
  }
  $fire = 0;
  $a5 = $TO::Storages->[$hno];
  $a5_info = $a5->{info};
  $target_name= $a5_info->{name};

  if ($ltype eq "t" || $ltype eq "3") { # T3 or A35K
    $fire = 1;
    $target_disk = "";

  } elsif ($ltype eq "a") {  # a5k
    $target_disk = Fibre::Rules->a5kTargetIsLast($reads, $writes, $a5, $pno);
    return (undef, "") if (!defined($target_disk));

  } else {
    return (undef, "") ;
  }
  
  my($level, $cnt, $desc, $mins) = 
              $th->test("counters","rule6","$name.$port" , 1);

  if ( $level eq "E") { # error level threshold fired
    print "$cnt, $desc, $mins<br>";
    print "   <b><font color=red>Rule 6 fired</font></b>\n";

    print "   <b>Origin Port</b>: Disk $target_disk on $target_name<br>";
    print "   <b>Destination Port</b>: Port $port on $name \n<br>";

    my($label) = "Disk $target_disk in '" . substr($target_name,2) . "'";
    Fibre::Rules->log(6,
                      "$target_name:$pno",
                      "s:$name:$port",
                      $label, $reads, $writes);
  }

  return (undef, "");
}


1;


