package Fibre::State;
use TO;
use Data::Dumper;
use PDM;
use GUI::Instr;
use Fibre::Discover;
use GUI::EventLog;


sub topo {
  my($q) = @_;

  eval {
   TO->readTopo($q->{topo}); # get objects in globals
   &topoApplet();
  };
  print "$@";

}

sub run {
  my($q) = @_;

  print "<body bgcolor=#F0F0F0 link=blue alink=blue vlink=blue>";
  opendir(O, System->get_home() . "/DATA/tmp");
  @files = readdir(O); closedir(O);
  $list = "<b>[</b> ";
  $current = $q->{topo} || System->hostname();
  foreach $f (sort @files) {
     if ($f =~ /^topo_(.*)/) {
        next if ($1 eq "data1");
        if ($1 eq $current) {
          $list .= "<b><a href=/?GO=Fibre::State::run&topo=$1>$1</a> |</b> ";
        } else {
          $list .= "<a href=/?GO=Fibre::State::run&topo=$1>$1</a> <b>|</b> ";
        }
     }
  }
  $list = substr($list, 0, -6);
  $list .= " <b>]</b> ";
  print "<table border=0 cellspacing=0 cellpadding=3 width=100%>
  <tr><td width=10% nowrap><b>State of SubSystems :</b>
      <td>$list</td>
      <td align=right><b>[  <a href=/monitorF.html target=_parent>Back</a> ]&nbsp;</table>
  ";


  my($applet);
  $applet =<<EOF;
 <script>
  var a_width =  window.innerWidth  - 10;
  var a_height =  window.innerHeight - 20;
  window.document.writeln(
   '<applet  CODE=VertexApplet.class codebase=Topo archive=topo.jar height=' + a_height + ' width=' + a_width + '>');
  </script>
  <param name=url value="GET=Fibre::State::topos&topo=$current">
  <param name=urlRefresh value="GET=Fibre::State::topos&topo=$current">
  <param name=timeRefresh value="10000">
  <param name=drop1 value="Report|details||GET=Fibre::State::report&topo=$current">
  <param name=drop2 value="Config|details||GET=Fibre::State::details&topo=$current">
  <param name=drop3 value="Event Log|details||GET=Fibre::State::eventLog&topo=$current">
  <param name=drop4 value="Clear|t|r|GET=Fibre::State::clear&topo=$current">
  <param name=ldrop1 value="Display Log|details||GET=Fibre::State::fibrelog">
  <param name=ldrop2 value="Clear Log|details||GET=Fibre::State::clearlog">
  <param name=browser value="sun">
  </applet>
EOF
  print $applet;
}

sub get_clearlog {
  unlink System->get_home() . "/DATA/CountersLog";
  print "CoutersLog erased!";
}

sub get_fibrelog {
  my($q) = @_;

  print "<body bgcolor=white>";
  my(@nodes) = split(/ /, $q->{link});

  if ($nodes[0] gt $nodes[1]) {
     $node0 = $nodes[1];
     $node1 = $nodes[0];
  } else {
     $node0 = $nodes[0];
     $node1 = $nodes[1];
  }

  &call($node0, $node1);
  print "<tr><td>&nbsp;</td>";
  &call($node1, $node0);
}

sub call {
  my($node0, $node1) = @_;

  %MAP = (a => 'a5k', s => 'Switch',t => 'T3',   h => 'Host');
  %MAP2= (a => 'interface-', s => 'port-'  ,t => 'ctrl-', h => 'hba-');

  my(@b1) = split(/:/, $node0);
  my(@b2) = split(/:/, $node1);

  my($type1) = $MAP{$b1[0]};
  my($type2) = $MAP{$b2[0]};
  my($name1) = $b1[1];
  my($name2) = $b2[1];
  my($port1) = $MAP2{$b1[0]} . $b1[2];
  my($port2) = $MAP2{$b2[0]} . $b2[2];

  print "<table border=0 cellpadding=2 cellspacing=0 width=100% bgcolor=#F0F0F0>
   <tr bgcolor=#666699><td colspan=2><font color=white><b>Fibre Errors
    <tr><td align=right><b>Origin:<td> $type1 '$name1' $port1</td>
    <tr><td align=right><b>Destination:<td> $type2 '$name2' $port2</table>";

  open(O, System->get_home() . "/DATA/CountersLog");
  my(%C, $key, $k);
  print "<table border=0 width=100%>";
  $l = <O>;
  while ($l) {
    chop($l);
    next if (substr($l,0,1) eq " ");
    my($date, $rule, $lnode1, $lnode2, $info) = split(/\t/, $l);
    my($df) = substr($date,0,2) . "/" . substr($date,2,2) . " " . substr($date,4,2) . ":".
              substr($date,6,2) . ":" . substr($date,8);

    if ($lnode1 eq $node0 && $lnode2 eq $node1) {
        print "<tr><td><b>Rule$rule $df  $info</td>";
        @LIST = ();
        while (($l = <O>) && substr($l,0,1) eq " " ) {
            push(@LIST, "<tr><td nowrap><small>&nbsp;&nbsp;$l</td>");
        }
        for ($x=$#LIST; $x > $#LIST - 10; $x--) {
            print $LIST[$x];
        }
        print "<tr><td>&nbsp;&nbsp;<big><b>...</b></big> ($#LIST)</td>" if ($#LIST > 10);

    } else {
      $l = <O>;
    }
  }
  print "</table>&nbsp;<p>&nbsp;<p>";
  close(O);
}

sub put_topos {
  my($q, $post_data) = @_;
  Fibre::Discover::put_topos($q, $post_data);
}

sub get_eventLog {
  my($q) = @_;
  my($renv, $devs, $hosts,$notifs) = PDM::ConfigFile->read;
  %MAP = (t => 'T3.', a => 'A5K.', s => 'Switch.' , 3 => 'A3500FC.');

  my($type, $name, $comp) = split(/:/, $q->{enc});
  my($filter1);
  my($host) = "host_local";
  my($found) = 0;
  foreach $d (@$devs) {
    if ($d->{name} eq "$name") {
      $host = "host_$d->{host}" if ($d->{host});
      $filter1 = substr($d->{wwn},-4) if ($d->{wwn});
      $found = 1;
      last;
    }
  }
  if (!$found) {
    print "No entry in config file for $q->{enc}";
    return;
  }
  $q->{filter1} = $filter1;
  $q->{category} = $MAP{$type};
  $q->{$host}    = 1;
  $q->{BACK} = 0;
  GUI::EventLog::display($q);
  
}

sub get_report {
  my($q) = @_;
  if (!$q->{page}) {
    print "<frameset rows=50%,*>
    <frame src=/?GO=Fibre::State::get_report&page=1&enc=$q->{enc} f1 scrolling=no>
     <frame src=javascript:return() name=main2 scrolling=auto>
    </frameset>
    ";
    return;
  }

  print "<body bgcolor=white>";
  my($type, $name, $comp) = split(/:/, $q->{enc});
  my($renv, $devs, $hosts,$notifs) = PDM::ConfigFile->read;
  my(%MAP) = (t=> 't3', a => 'a5k', 3 => 'a35k', s => 'switch' );

  $q->{type} = $MAP{$type};
  $q->{name} = $name;

  foreach $d (@$devs) {
    if ($d->{type} eq $q->{type} && $d->{name} eq $q->{name}) {
       $q->{host} = $d->{host};
       last;
    }
  }
  if ($q->{type}) {
    GUI::Instr::explore1($q);
  } else {
    print "Nothing on $q->{name}";
  }
}


sub get_details {
  my($q) = @_;
  my($renv, $devs, $hosts,$notifs) = PDM::ConfigFile->read;

  TO->readTopo($q->{topo});
  print "<body bgcolor=white>";
  print "<table border=1 cellspacing=0 cellpadding=2 width=100%>
   <tr bgcolor=#666699><td><font color=white><b>System Review: $q->{enc}</td>
   </table><pre>";
  print TO->display($devs, $q->{enc});

}

$CACHE =undef;

sub get_clear {
  my($q) = @_;
  my($type, $name, $comp) = split(/:/, $q->{enc});
  $CACHE = PDM->readCache("STATE");
  if ($comp eq "e") {  # enclosure
    my($name) = "$type:$name.$comp";
    $CACHE->{$name} = [];
  }
  if ($type eq "a") {
     if ($comp eq "s1") {
        $CACHE->{"$type:$name.interface_board.A"} = [];
     } elsif ($comp eq "s2") {
        $CACHE->{"$type:$name.interface_board.B"} = [];

     } elsif (substr($comp, 0, 1) eq "d") {
        if (substr($comp, 1,1) eq "f") {
          $u = "disk_front";
        } else {
          $u = "disk_rear";
        }
        my($no) = substr($comp,2);
     
        $CACHE->{"a5k:$name.$u.$no"} = [];
     }

  } elsif ($type eq "s") {
     $u = sprintf("%3.3d", substr($comp,1));
     $CACHE->{"switch:$name.port.$u"} = [];

  } elsif ($type eq "t") {
     if ($comp eq "s1") {
        $CACHE->{"$type:$name.controller.u1ctr"} = [];
     } elsif ($comp eq "s2") {
        $CACHE->{"$type:$name.controller.u2ctr"} = [];

     } elsif (substr($comp,0,1) eq "d") {
        $unit = substr($comp,1,1);
        $d = substr($comp,2) + 1;
        $CACHE->{"$type:$name.disk.u${unit}d$d"} = [];

     } elsif (substr($comp,0,1) eq "L") {
        $CACHE->{"$type:$name.loopcard.u1l1"} = [];
        $CACHE->{"$type:$name.loopcard.u1l2"} = [];
        $CACHE->{"$type:$name.loopcard.u2l1"} = [];
        $CACHE->{"$type:$name.loopcard.u2l2"} = [];

     } elsif (substr($comp,0,1) eq "M") {
        $CACHE->{"$type:$name.midplane.u1mpn"} = [];
        $CACHE->{"$type:$name.midplane.u2mpn"} = [];

     } elsif (substr($comp,0,1) eq "P") {
        $CACHE->{"$type:$name.power.u1pcu1"} = [];
        $CACHE->{"$type:$name.power.u1pcu2"} = [];
        $CACHE->{"$type:$name.power.u2pcu1"} = [];
        $CACHE->{"$type:$name.power.u2pcu2"} = [];

     } elsif (substr($comp,0,1) eq "V") {
        $CACHE->{"$type:$name.volume.u1vol1"} = [];
        $CACHE->{"$type:$name.volume.u1vol2"} = [];
        $CACHE->{"$type:$name.volume.u2vol1"} = [];
        $CACHE->{"$type:$name.volume.u2vol2"} = [];
     }

  }
         
  PDM->writeCache($CACHE, "STATE");
  &get_topos($q);
  # 
}

# returns encstatus, portstatus, diskstatus, otherstatus for each
# category: s=switch,a=a5, t=t3, 3=a3500

sub val {
  my(@a) = @_;
  my($o) = -2;
  foreach my $x (@a) {
     $o = $x if (defined($x) && ($x > $o));
  }
  return "" if ($o == -2);
  return $o;
}

sub statusFunc {
  my($type, $name) = @_;
  my($enc, $port, $disk, $other, $d) ;
  my($l1,$l2, $p1, $p2, $m1, $v1, $v2);
  my($encInfo, $portInfo, $diskInfo, $otherInfo) ;
  
  if ($type eq "t") {
     $i = $CACHE->{"$name.e"};
     $enc = $i->[0];
     $encInfo = $i->[1];
     $port =  $CACHE->{"$name.controller.u1ctr"}[0] . "," .
              $CACHE->{"$name.controller.u2ctr"}[0];

     $portInfo = $CACHE->{"$name.controller.u1ctr"}[1];
     $disk =""; $diskInfo = ""; $otherInfo = ""; $other = "";
     for ($u=1; $u <= 2; $u++) {
       for ($d=1; $d <= 9; $d++) {
         $disk .= $CACHE->{"$name.disk.u${u}d$d"}[0] . ",";
         $diskInfo .=$CACHE->{"$name.disk.u${u}d$d"}[1] . ",";
       }
    }
#   LMPV
     
     $l1 = $CACHE->{"$name.loopcard.u1l1"};
     $l2 = $CACHE->{"$name.loopcard.u1l2"};
     $l3 = $CACHE->{"$name.loopcard.u2l1"};
     $l4 = $CACHE->{"$name.loopcard.u2l2"};

     $p1 = $CACHE->{"$name.power.u1pcu1"};
     $p2 = $CACHE->{"$name.power.u1pcu2"};
     $p3 = $CACHE->{"$name.power.u2pcu1"};
     $p4 = $CACHE->{"$name.power.u2pcu2"};

     $v1 = $CACHE->{"$name.volume.u1vol1"};
     $v2 = $CACHE->{"$name.volume.u1vol2"};
     $v3 = $CACHE->{"$name.volume.u2vol1"};
     $v4 = $CACHE->{"$name.volume.u2vol2"};

     $m1 = $CACHE->{"$name.midplane.u1mpn"};

     $other = &val($l1->[0], $l2->[0], $l3->[0], $l4->[0])  . "," . 
               $m1->[0] . "," . 
              &val($p1->[0], $p2->[0], $p3->[0], $p4->[0]) . "," . 
              &val($v1->[0], $v2->[0], $v3->[0], $v4->[0]);

     $otherInfo = &val($l1->[1], $l2->[1], $l3->[1], $l4->[1])  . "," . 
              $m1->[1] . "," . 
              &val($p1->[1], $p2->[1], $p3->[1], $p4->[1]) . "," . 
              &val($v1->[1], $v2->[1], $v3->[1], $v4->[1]);

  } elsif ($type eq "a") { # a5k
     ($type, $name) = split(/:/, $name);
     $name = "a5k:$name";

     my($p1) = $CACHE->{"$name.interface_board.A"}[0] ;
     my($p2) = $CACHE->{"$name.interface_board.A.gbic0"}[0];
     my($p3) = $CACHE->{"$name.interface_board.A.gbic1"}[0];
     $port  = &val($p1, $p2, $p3);
     $port  .= ",";

     my($p1) = $CACHE->{"$name.interface_board.B"}[0] ;
     my($p2) = $CACHE->{"$name.interface_board.B.gbic0"}[0];
     my($p3) = $CACHE->{"$name.interface_board.B.gbic1"}[0];
     $port  .= &val($p1, $p2, $p3);


     $portInfo =  ($CACHE->{"$name.interface_board.A"}[1] ||
               $CACHE->{"$name.interface_board.A.gbic0"}[1] ||
               $CACHE->{"$name.interface_board.A.gbic1"}[1] ) . "," . 

              ($CACHE->{"$name.interface_board.B"}[1] ||
               $CACHE->{"$name.interface_board.B.gbic0"}[1] ||
               $CACHE->{"$name.interface_board.B.gbic1"}[1] );

     foreach $u ('disk_front','disk_back') {
       for ($d=0; $d <= 10; $d++) {
         $disk .= $CACHE->{"$name.${u}.$d"}[0] . ",";
         $diskInfo .=$CACHE->{"$name.${u}.$d"}[1] . ",";
       }
    }
  } elsif ($type eq "s") {
     ($type, $name) = split(/:/, $name);
     $name = "switch:$name";

     for ($x=0; $x <= 16; $x++) {
         $u = sprintf("%3.3d", $x);
         $port .= $CACHE->{"$name.port.$u"}[0] . ",";
         $portInfo .= $CACHE->{"$name.port.$u"}[1] . ",";
     }
  }
  return ($enc, $port, $disk, $other,
          $encInfo, $portInfo, $diskInfo, $otherInfo);
}

sub get_topos {
  my($q) = @_;
  my($l, @LOG);
  $CACHE = PDM->readCache("STATE");
  open(O, System->get_home() . "/DATA/CountersLog");
  my(%C, $key, $k);
  while ($l = <O>) {
    chop($l);
    next if (substr($l,0,1) eq " ");
    my($date, $rule, $node1, $node2, $info) = split(/\t/, $l);

    if ($node1 gt $node2) {
      $key = "$node2||$node1";
    } else {
      $key = "$node1||$node2";
    }

    if ($C{$key}){ 
      ($date, $cnt, $node1, $node2, $info) = split(/\t/, $C{$key});
      $cnt++;
      $C{$key} = "$date\t$cnt\t$node1\t$node2\t$info";
    } else {
      $C{$key} = "$date\t1\t$node1\t$node2\t$info";
    }
  }
  close(O);
  foreach $k (keys %C) {
    push(@LOG, $C{$k});
  }

  print TO->topos({   topo => $q->{topo},
                    status => \&statusFunc, 
                    fibreLog => \@LOG,
                  counters => undef, clear => $q->{clear}}); 

}



1;
