package GUI::Config;
use PDM::ConfigFile;
use GUI::Hosts;
use strict;

#  $Id: Config.pm,v 1.25 2001/07/26 00:41:43 ccadieux Exp $


sub upd {
  my($q, $post) = @_;
  my($renv, $dev, $host, $notifs, $c1, $c2);
  my($err1, $info, $err2, $err3, $err5, $err6, $err8);
  my($error);
  if ( Util->findMaster()) {
    print "<body bgcolor=white><h1><center>This function is not allowed on a slave!";
    return;
  }
  print "\n";
  $info = "";
  my($categories) = &main::findSelectableAgents();
  my($warn2, $warn3, $cat);

  if ($q->{ACTION} eq " Back ") {
      GUI::Hosts::list($q);
      return;
  } elsif ($q->{ACTION} eq " Submit ") {
#     if ($q->{ping}) {
#        @a = split(/ *[\n\r]+ */, $q->{ping});
#        $err1 = "";
#        foreach $p (@a) {
#           @l = split(/ *[\:\#\|] */, $p);
#           if (!(-d $l[0] || -f $l[0])) {
#              $err1 .= "Cannot read path: $l[0]<br>";
#           }
#        }
#     }
     ($renv, $dev, $host,$notifs) = PDM::ConfigFile->read();
     if ($err1) {
       $info = &main::info("Error with data-ping paths!");
       $err1 = "<font color=red>$err1</font>";
     }
     if (!$q->{customer}) {
       print &main::info("Error: Customer-Name is mandatory!");
       $err5 = "<font color=red>Mandatory</font>";
     }
     $q->{site_state} = uc($q->{site_state});
     if (!$q->{site_name} || !$q->{site_city} || !$q->{site_country} || !$q->{site_zip}) {
       print &main::info("Error: SiteName/City/Zip/Country are mandatory!");
       $err8 = "<font color=red>Enter Mandatory Site Information.</font>";
     }
     if ($q->{t300logfile}) {
       if (!-f $q->{t300logfile}) {
         $warn2 = "<br><font color=red>Warn: Cannot find $q->{t300logfile}";

       } elsif ($q->{t300logfile} !~ /\/var\/adm/) {
         $warn2 = "<br><font color=red>Warn: file should be in /var/adm/ dir.";
       }
     }
     $q->{logfile} = "/var/adm/messages";
     if ($q->{logfile} && !-f $q->{logfile}) {
       $warn3 = "<br><font color=red>Warn: Cannot find $q->{logfile}";
     }
     my $cat = "";
     foreach my $m (@$categories) {
        my(@bb) = split(/=/, $m);
        $cat .= "$bb[0]|"  if ($q->{$bb[0]});
     }
     chop($cat) if ($cat);
     if (!$cat) {
       print &main::info("Error: No Categories to monitor have been checked!");
       $err6 = "<font color=red>Mandatory</font>";
     }

     goto err2 if ($err1 || $err2 ||$err3 || $err5 || $err6 || $err8);
     $q->{site_country} = "USA" if (! $q->{site_country});

     for my $v ('customer','cust_no','site_name','site_address','site_city',
             'site_state', 'site_zip','site_contact','site_email','site_country',
             'production',
             'contract', 'ticker', 'logfile','t300logfile','st4logfile','contract') {
        $renv->{$v}    = $q->{$v};
     }
     $renv->{hostname} = System->hostname();
     if ($renv->{frequency} ne $q->{frequency}) {
        &main::log_change("Monitoring Frequency on Master changed from '$renv->{frequency}' to '$q->{frequency}'");
     }
     $renv->{showoob}   = $q->{showoob}? "Y":"N";
     $renv->{frequency}   = $q->{frequency} || 5;
     $renv->{local_event_log} = $q->{local_event_log};
     $renv->{log_months}  = ($q->{local_event_log} eq "Y")? $q->{log_months} :"";
#     $q->{ping} =~ s/ *[\:\|\#] */#/g;
#     $q->{ping} =~ s/ *[\n\r]+ */|/g;
#     $renv->{ping}       = $q->{ping};

     if ($renv->{categories} ne $cat) {
        &main::log_change("Monitored categories on Master changed from '$renv->{categories}' to '$cat'");
     }
     $renv->{categories} = $cat;

     if (!PDM::ConfigFile->write( $renv, $dev, $host,$notifs)) {
        print "Cannot write to ConfigFile <br>";
     } else {
        $info = &main::info("Configuration updated!", "green");
     }

  } else {
     ($renv, $dev, $host,$notifs) = PDM::ConfigFile->read;
     if ($renv->{t300logfile} && !-f $renv->{t300logfile}) {
       $warn2 = "<br><font color=red>Warn: Cannot find $renv->{t300logfile}";
     }
     if ($renv->{logfile} && !-f $renv->{logfile}) {
       $warn3 = "<br><font color=red>Warn: Cannot find $renv->{logfile}";
     }
  }

err2:
  if ($err1 || $err2 || $err3 || $err5 || $err6 || $err8) {
    foreach my $x ('cust_no','contract','t300logfile','st4logfile',
                'site_city', 'site_state', 'site_country', 'site_zip',
                'site_contact', 'site_email','site_address','site_name',
                'customer','ticker','contract','frequency','production',
                'showoob','local_event_log') {
       $renv->{$x} = $q->{$x} 
    }
    $cat = "";
    foreach my $m (@$categories) {
      my(@bb) = split(/=/, $m);
      $cat .= "$bb[0]|"  if ($q->{$bb[0]});
    }
    $renv->{categories} = $cat;
  }
  my $h = &main::header("Master Configuration ");

  $c2 = "selected" if ($renv->{local_event_log} eq "Y");

  my $mths = "<select name=log_months><option value=\"\">[Select]</option>";
  foreach my $x (1,2,3) {
    my $sel = ($renv->{log_months} == $x) ? "selected":"";
    my $ss = ($x == 1) ? "":"s";
    $mths .= "<option $sel value=$x>$x month$ss</option>";
  }
  $mths .= "</select>";
  my $frequency = &main::select_frequency($renv);
  my $pings = $renv->{ping};
  $pings =~ s/\|/\n/g;
  $pings =~ s/\#/  #/g;
  my($modules_html) = "";
  foreach my $mod (@$categories) {
     my(@bb) = split(/=/, $mod);
     my($ck) = "checked" if (index($renv->{categories}, $bb[0]) >= 0);
     $modules_html .= "<input type=checkbox name=$bb[0] $ck>:$bb[1]&nbsp; ";
  }
  my $man = "<font size=+3 color=red><b>*</b></font>";
  my($p_1, $p_2);
  if ($renv->{production} eq "Y") {
     $p_1 = "selected";
  } else {
     $p_2 = "selected";
  }
  my $showoob = "<input type=checkbox name=showoob " . ($renv->{showoob} eq "Y"?"checked":"") .
       ">";

  
  my $o =<<EOF;
<body bgcolor=$main'BGCOLOR>
<form>
 <input type=hidden name=GO value=GUI::Config::upd>
<center>
$h
$info
$error
<table border=2 cellspacing=2 width=90% bgcolor=white><tr><td>
<table border=0 cellspacing=2 width=100%>
<tr><td colspan=4 bgcolor=#666699><b><font color=white>&nbsp;Enter Customer Information</td>
<tr><td bgcolor=$main'LIGHT width=30% align=right>Customer Name :</td>
    <td colspan=3><input type=text name=customer size=40  maxlength=60 value="$renv->{customer}">$man <font color=red><b>  is mandatory</b></font>$err5
<tr><td bgcolor=$main'LIGHT width=30% align=right>StockMarket Symbol (ticker):</td>
    <td colspan=3><input type=text name=ticker size=10  maxlength=20 value="$renv->{ticker}">

<tr><td bgcolor=$main'LIGHT align=right width=30%>Customer No :</td>
    <td ><input type=text name=cust_no size=20 maxlength=20 value="$renv->{cust_no}"></td>
    <td nowrap bgcolor=$main'LIGHT align=right>ContractNo :</td>
    <td><input type=text size=20 maxlength=20 name=contract value="$renv->{contract}"></td>
<tr><td colspan=4 bgcolor=#666699><b><font color=white>&nbsp;Enter Site Information</td>
<tr><td nowrap bgcolor=$main'LIGHT align=right>Site Name :</td>
    <td colspan=3>$err8<br>
       <input type=text size=40 maxlength=60 name=site_name value="$renv->{site_name}"> $man</td>

<tr><td nowrap bgcolor=$main'LIGHT align=right>Site Address :</td>
    <td  colspan=3>
       <input type=text size=30 maxlength=50 name=site_address value="$renv->{site_address}"></td>

<tr><td nowrap bgcolor=$main'LIGHT align=right>City :</td>
    <td  colspan=3>
       <input type=text size=30 maxlength=50 name=site_city value="$renv->{site_city}">$man</td>

<tr><td nowrap bgcolor=$main'LIGHT align=right>State :</td>
    <td>
       <input type=text size=10 maxlength=20 name=site_state value="$renv->{site_state}"></td>
    <td nowrap bgcolor=$main'LIGHT align=right>ZipCode/PostalCode:</td>
     <td>
       <input type=text size=15 maxlength=20 name=site_zip value="$renv->{site_zip}">$man</td>
<tr> <td nowrap bgcolor=$main'LIGHT align=right>Country:</td>
     <td colspan=3>
       <input type=text size=30 maxlength=50 name=site_country value="$renv->{site_country}">$man</td>
<tr><td nowrap bgcolor=$main'LIGHT align=right>Contact :</td>
    <td colspan=3>
       <input type=text size=30 maxlength=50 name=site_contact value="$renv->{site_contact}"></td>
<tr><td nowrap bgcolor=$main'LIGHT align=right>Email :</td>
    <td colspan=3>
       <input type=text size=30 maxlength=50 name=site_email value="$renv->{site_email}"></td>
<tr><td nowrap bgcolor=$main'LIGHT align=right>Is this a production Site? :</td>
    <td colspan=3>
       <select name=production><option value=Y $p_1>Yes<option value=N $p_2>No</select></td>



<tr><td colspan=4 bgcolor=#666699><font color=white><b>&nbsp;Enter Default Storage Logfiles</td>
<tr><td bgcolor=$main'LIGHT align=right>Message Log:</td>
    <td colspan=3><table border=1 cellspacing=0 cellpadding=2><tr><td>$renv->{logfile}</table>
<tr><td bgcolor=$main'LIGHT align=right>T3 Message Log:</td>
    <td colspan=3><input type=text name=t300logfile size=50 maxlength=60 value="$renv->{t300logfile}">$warn2
<tr><td bgcolor=$main'LIGHT align=right>Stortools4 Log Directory:</td>
    <td colspan=3><input type=text name=st4logfile size=50 maxlength=60 value="$renv->{st4logfile}">


<tr><td></td>
<tr><td colspan=4 bgcolor=#666699><font color=white>
        <b>&nbsp;Enter Local Network Storage Agent Information</td>

<tr><td bgcolor=$main'LIGHT align=right>Log Network Storage Agent events locally:</td>
     <td colspan=3><select name=local_event_log>
            <option $c1 value=N>Off (No local logging)</option>
            <option $c2 value=Y>On (Log Events)</option>
         </select>

<tr><td bgcolor=$main'LIGHT align=right>Categories to&nbsp;<br>Monitor :
  </td>
  <td colspan=3> $modules_html $err6
 </td>
<tr><td bgcolor=$main'LIGHT align=right>Monitoring Frequency: </td>
   <td colspan=3>
     $frequency
   </td>
<tr><td bgcolor=$main'LIGHT align=right>Show OutOfBand devices&nbsp;<br> in topology: </td>
   <td colspan=3>
     $showoob
   </td>
</table>
</table>
<b>
<input type=submit name=ACTION value=" Submit ">
<input type=submit name=ACTION value=" Back ">
</form>
EOF

  print $o;
}
#<tr><td colspan=2 bgcolor=$main'LIGHT>&nbsp;Local DataPing Directories (One dir/file per line)</td>
#<tr><td colspan=2>$err1
#      <textarea name=ping cols=60 rows=12>$pings</textarea></td>

1;
 
