package GUI::Devices;
#  $Id: Devices.pm,v 1.24 2001/07/26 00:41:44 ccadieux Exp $

use PDM;
use Serialize;
#
# List all devices, refer to GUIAdmin::<device>::addDevice and updDevice for 
# maintenance.

sub list {
 my($q) = @_;
 my($ho, $o, @devs);

  if ( Util->findMaster()) {
    print "<body bgcolor=white><h1><center>This function is not allowed on a slave!";
    return;
  }

  print "\n";
  if ($q->{ADD}) {
    my($pk) = $q->{ADD};
    if (eval "require \"GUIAdmin/$pk.pm\"") {
       $f = "GUIAdmin::${pk}::addDevice";
       &$f($q);    
       return;
    }
  } elsif ($q->{ACTION} eq "Erase All Devices") {
    ($renv, $dev, $hosts,$notifs) = PDM::ConfigFile->read;
    PDM::ConfigFile->write( $renv, [], $hosts,$notifs);

  } elsif ($q->{ACTION} eq " Discover ") {
    &main::discover0($q);
    return;

  } elsif ($q->{ACTION} eq "Update Slave Configs") {
    GUI::Hosts::push_slaves($q);
  }
  ($renv, $dev, $hosts,$notifs) = PDM::ConfigFile->read;
  $head = &main::header("Maintain Devices","","","maintaindev");
  %H = ();
  $H{Master} = (-f System->get_home() . "/DATA/start")? "Y":"N";
  foreach $h (@$hosts) {
    $H{$h->{hostname}} = $h->{active};
  }

  for ($x=0; $x <= $#$dev; $x++) {
     $d = $dev->[$x];
     my $ho = $d->{host} || "LOCAL" ;
     next if ($q->{HOST} && $q->{HOST} ne $ho);
     $d->{no} = $x;
     $s = Serialize->join($d);
     $loc = lc($d->{host}) || (System->hostname() . " (local)");
     if ($q->{sort} == 1) {
       $v = sprintf("%-30.30s %s", lc($d->{name}), $s);
     } elsif ($q->{sort} == 2) {
       $v = sprintf("%-30.30s %s", lc($d->{type}), $s);
     } elsif ($q->{sort} == 3 || !$q->{sort}) {
       $v = sprintf("%-30.30s %s", $loc, $s);
     }
     push(@devs, $v);
  }
  my($last);
  foreach $line (sort @devs) {
    $h = Serialize->hash_split(substr($line,31));
#   $h = $dev->[$x];
    $type = uc($h->{type});
    
    $type0 = $type;

    $lnk = "<a href=/?GO=GUIAdmin::${type0}::updDevice&no=$h->{no}><b>$h->{name}</b></a>";
    $ip  = $h->{ipno} || $h->{ip};
    $loc = $h->{host} || System->hostname();
    my $ix2 = index($loc, ".");
    $loc0 = $loc;
    $loc0 = substr($loc,0,$ix2) if ($ix2 > 0);

    $active = ($h->{active} eq "Y")? "On":"Off";
#    $rep_active = ($h->{report} eq "Y")? "Yes":"No";

    $col = ($active eq "Off") ? "#FFC0C0":"#C0F0C0";
    my($bold);

    if (!$q->{sort} || ($q->{sort} == 3)) {
      if ($loc ne $last) {
         $ho .= "<tr><td colspan=6></td>" if ($last);
         $bold = "<b>";
         $last = $loc;
      }
    }
    my $dh = $h->{datahost} || $loc0;
    my $WWN = $h->{wwn};
    if ($h->{type} eq "t3" && length($WWN) < 2) {
       $WWN = "<font color=red>Warning: no WWN !";
    }
    $ho .= "<tr>
                <td $col>$bold &nbsp;$loc0 </td>
                <td>$lnk</td>
                <td>$type</td>
                <td>$ip&nbsp;</td>
                <td>$WWN&nbsp;</td>
                <td>&nbsp;$dh&nbsp;</td>
                <td><b><center>$active</td>
           ";
    $bold="";
  }
  if ($#$dev < 0) {
     $ho .= "<tr><td colspan=3><b>No registered device(s) were found.</td>";
  }
  $x = &main::read_file("device_registration");

  my($categories) = &main::find_devices();
  my $add ;
  foreach my $cat (@$categories) {
    $add .= "<a href=/?GO=GUI::Devices::list&ADD=$cat>$cat</a> | ";
  }
  chop($add);
  chop($add);

  my($hostsD) = "<select name=HOST><option value=LOCAL>$renv->{hostname}</option>";

  foreach $h (@$hosts) {
     $sel = ($h->{hostname} eq $q->{HOST})? "selected":"";
     $hostsD .= "<option value=\"$h->{hostname}\" $sel>$h->{hostname}</option>";
  }
  $sel = ($q->{HOST} eq "")? "selected":"";
  $hostsD .= "<option value=\"\" $sel>All Hosts</option>";
  $hostsD .= "</select>";


  $o =<<EOF;
<body bgcolor=$main'BGCOLOR>
<form method=get>
 <input type=hidden name=GO value=GUI::Devices::list>
<center>
$head
$x
$q->{ERR}
<table border=1 cellspacing=1 width=90% bgcolor=white><tr><td>
<table border=0 cellspacing=2 width=100% bgcolor=#F0F0F0>
<tr><td colspan=7 bgcolor=#666699>
 <table border=0><tr><td><b><font color=white>&nbsp;Add a new Device Manually
 </table></td>
<tr><td colspan=7 bgcolor=white><center>&nbsp;<b>Select:</b>&nbsp;$add<br>&nbsp;</td>
<tr><td colspan=7 bgcolor=#666699>
  <table border=0 cellspacing=0 cellpadding=0 width=100%>
    <tr><td><b><font color=white>&nbsp;List Existing Devices</td>
    <td align=right width=10% nowrap><font color=white>&nbsp;<b>Host: $hostsD<input type=submit name=ACTION value=GO>
  </table>
<tr>
    <td bgcolor=$main'LIGHT><center><b>
        <a href=?GO=GUI::Devices::list&sort=3&HOST=$q->{HOST}>Primary Host</a></td>
    <td bgcolor=$main'LIGHT><center><b>
        <a href=?GO=GUI::Devices::list&sort=1&HOST=$q->{HOST}>Name</a></td>
    <td bgcolor=$main'LIGHT><center><b>
        <a href=?GO=GUI::Devices::list&sort=2&HOST=$q->{HOST}>Type</a></td>
    <td bgcolor=$main'LIGHT><center><b>IP Address</td>
    <td bgcolor=$main'LIGHT><center><b>WWN</td>
    <td bgcolor=$main'LIGHT><center><b>Data-Host</td>
    <td bgcolor=$main'LIGHT><center><b>Monitor</td>
$ho
</table>
</table>
<b>&nbsp;<br>
<input type=submit name=ACTION value=" Discover ">
<input type=submit name=ACTION value="Update Slave Configs">
<input type=submit name=ACTION value="Erase All Devices"
         onclick="return confirm('Remove all devices from your configuration?')"><p>
</table>
</form>
EOF

print $o;
}


1;
