package GUI::EventLog;
#  $Id: EventLog.pm,v 1.15 2001/08/23 00:24:22 ccadieux Exp $

use System;
use Util::Http;
use WebTabs;

$CATEGORY = "<select name=category>
            <option value=\"\">All</option>
            <option value=t3.>T3 Events</option>
            <option value=t3message.>T3 Message Events</option>
            <option value=a5k.>A5K</option>
            <option value=a3500fc.>A3500FC</option>
            <option value=switch.>Switch</option>
            <option value=agent.>Agent</option>
            <option value=message.>Message Events</option>
            <option value=host.>Host Events</option>
            <option value=topo.>Topology Events</option>
          </select>";

$EVENT = "<select name=event>
            <option value=\"\">All</option>
            <option value=.Communication>Communication Events</option>
            <option value=.DiscoveryEvent>Discovery</option>
            <option value=.AlarmEvent>Alarm Event</option>
            <option value=.RemovalEvent>Removal Event</option>
            <option value=.TopologyEvent>Topology Event</option>
            <option value=.AuditEvent>Audit Event</option>
            <option value=.StateChangeEvent>State Change Event</option>
            <option value=.Agent>Agent Events</option>
            <option value=.backup>Backup Event</option>
            <option value=.patch>Patch Event</option>
            <option value=.LinkEvent>Link Event</option>
            <option value=.LocationCh>Location Change Event</option>
            <option value=.Statistics>Statistical Events</option>
          </select>";


sub list {
  my($q) = @_;

  $hname = System->hostname;
  $hid = System->hostid;
  $ip  = System->local_ip;
  ($renv, $dev, $host,$notifs) = PDM::ConfigFile->read;
  $head = &main::header("Event Log");
  print "\n";
  $o =<<EOF;
<body bgcolor=$main'BGCOLOR>
<center>
$head
<table border=2 cellspacing=2 width=90% bgcolor=white><tr><td>
<form>
  <input type=hidden name=GO value=GUI::EventLog::display>
<table border=0 cellspacing=2 width=100% bgcolor=#F0F0F0>
<tr><td colspan=5>
  <table border=0 cellspacing=2 width=100% cellpadding=0>
   <tr><td bgcolor=$main'LIGHT>&nbsp;<b>Category </td>
       <td bgcolor=$main'LIGHT>&nbsp;<b>Event    </td>
       <td bgcolor=$main'LIGHT>&nbsp;<b>Filter1  </td>
       <td bgcolor=$main'LIGHT>&nbsp;<b>and Filter2 </td>
   <tr><td>$CATEGORY</td>

     <td>$EVENT </td>
     <td><input type=text name=filter1 size=20></td>
     <td><input type=text name=filter2 size=20></td>
  </table>
<tr><td colspan=5 bgcolor=#666699><b><font color=white>&nbsp;Select a Host</td>
<tr bgcolor=$main'LIGHT>
    <th><center>Select</td>
    <td ><center><b>HostName</td>
    <td ><center><b>Type</td>
    <td ><center><b>HostID</td>
    <td ><center><b>Host IP</td>
<tr>
EOF
  $o .= "<tr>
          <td><center><input type=checkbox name=host_local checked></td>
          <td>$hname</td>
          <td>Master</td>
          <td>$hid</td>
          <td>$ip</td>
          ";

  for ($x=0; $x <= $#$host; $x++) {
     $h = $host->[$x];
     $o .= "<tr>
          <td><center><input type=checkbox name=host_$h->{ip}></td>
          <td>$h->{hostname}</td>
          <td>Slave</td>
          <td>$h->{hostid}</td>
          <td>$h->{ipno}</td>
         ";
  }
  $o .= "</table></table><b><input type=submit name=ACTION value=\"Search Log\">";
  print $o;

}


sub alerts {
  my($q) = @_;

  $hname = System->hostname;
  $hid = System->hostid;
  $ip  = System->local_ip;
  ($renv, $dev, $host,$notifs) = PDM::ConfigFile->read;
  $head = &main::header("Alert Log");
  print "\n";
  $o =<<EOF;
<body bgcolor=$main'BGCOLOR>
<center>
$head
<table border=2 cellspacing=2 width=90% bgcolor=white><tr><td>
<form>
  <input type=hidden name=GO value=GUI::EventLog::display>
<table border=0 cellspacing=2 width=100% bgcolor=#F0F0F0>
<tr><td colspan=5>
  <table border=0 cellspacing=2 width=100% cellpadding=0>
   <tr><td bgcolor=$main'LIGHT>&nbsp;<b>Category </td>
       <td bgcolor=$main'LIGHT>&nbsp;<b>Event    </td>
       <td bgcolor=$main'LIGHT>&nbsp;<b>Severity</td>
   <tr><td>$CATEGORY</td>
     <td>$EVENT </td>
     <td><select name=sev>
            <option value=\"Sev:\">All</option>
            <option value=\"Sev:3\">System Down</option>
            <option value=\"Sev:2\">Critical (Error)</option>
            <option value=\"Sev:1\">Alert (Warning)</option>
            <option value=\"Sev:0\">Caution (Information)</option>
         </select>
  </table>
<tr><td colspan=5 bgcolor=#666699><b><font color=white>&nbsp;Select a Host</td>
<tr bgcolor=$main'LIGHT>
    <th><center>Select</td>
    <td ><center><b>HostName</td>
    <td ><center><b>Type</td>
    <td ><center><b>HostID</td>
    <td ><center><b>Host IP</td>
<tr>
EOF
  $o .= "<tr>
          <td><center><input type=checkbox name=host_local checked></td>
          <td>$hname</td>
          <td>Master</td>
          <td>$hid</td>
          <td>$ip</td>
          ";

  for ($x=0; $x <= $#$host; $x++) {
     $h = $host->[$x];
     $o .= "<tr>
          <td><center><input type=checkbox name=host_$h->{ip}></td>
          <td>$h->{hostname}</td>
          <td>Slave</td>
          <td>$h->{hostid}</td>
          <td>$h->{ipno}</td>
         ";
  }
  $o .= "</table></table><b><input type=submit name=ACTION value=\"Search Log\">";
  print $o;

}

sub display {
  my($q) = @_;
  my(@a, $cnt, $name);
  my($filter, $tab, $back);
  $filter  = "[ F1:$q->{filter1} ] " if ($q->{filter1});
  $filter .= "[ F2:$q->{filter2} ] " if ($q->{filter2});
  $filter .= "[ Cat:$q->{category} ] " if ($q->{category});
  $filter .= "[ Event:$q->{event} ] " if ($q->{event});
  if ($q->{sev}) {
    $filter .= ($q->{sev} eq "Sev:") ? "[ Severity:All ]  ": "[ $q->{sev} ] ";
  }
  my($sev) = $q->{sev};

  if (!$filter) {
    $filter = "No Filter</b>" ;
  } else {
    $filter = "Filter(s): </b>" . $filter;
  }

  $filter =~ s/\\//g;
  my($info1) = ($q->{sev}) ? "GUI::EventLog::alerts": "GUI::EventLog::list";

  print "<body bgcolor=$main'BGCOLOR marginheight=1 marginwidth=1>";
  my($back0);
  if (!$q->{NOBACK}) {
    $back0  = "[ <a href=?GO=$info1>Back</a> ]" if (!defined($q->{BACK}));
  }
  print "<center><table border=0><tr><td></table><table width=98% bgcolor=white cellspacing=0 cellpadding=2 border=0><tr>
    <td>&nbsp;<b>EventLog - $filter</td>
    <td align=right><b>&nbsp;$back0
   </td></table></center>";

  my($lastfile) = System->get_home() . "/DATA/LastAlerts";
#  print "<table border=0><tr><td></table>";
  print "<pre>" if (!$sev);

  if ($q->{option})  {
     &sev_header($q, $lastfile);
     &sev_display($q->{option}, $lastfile);
     return;
  }

  open(AL, ">$lastfile");
  foreach $host0 (keys %$q) {
    next if (substr($host0,0,5) ne "host_");
    $host = substr($host0,5);

    if ($host eq "local" || $host eq System->hostname() ) {
      $hname = System->hostname;
      print "<b>Local Host ($hname)</b>\n";
      $q->{GET} = undef;  # local 
      my($out) = &get_event_log($q);
      if ($sev) {
        print AL $out . "\n";
      } else {
        print $out . "\n";
      }
    } else {

       my($fil) = "filter1=$q->{filter1}&filter2=$q->{filter2}&category=$q->{category}&event=$q->{event}&sev=$q->{sev}";
       $fil =~ s/ /+/g;
       $url  = Util->makeUrl($host, "?GET=GUI::EventLog::event_log&$fil");
       print "<b>Calling $host ...</b>\n";
       $page = Util::Http->get($url, $main::TO);
       if ($sev) {
         print AL $page;
       } else {
         print $page;
       }
  
    }
  }
  close(AL);
  if ($q->{sev}) {
     open(AL, $lastfile);
     @SEV = ();
     while ($l = <AL>) {
        if ($l =~ /Sev:(\d)/) {
           $SEV[$1]++;
        }
     }
     close(AL);
     open(AL2, ">$lastfile.count");
     print AL2 "$SEV[0]|$SEV[1]|$SEV[2]|$SEV[3]|$SEV[4]";
     close(AL2);

     &sev_header($q, $lastfile);
     &sev_display($q->{option}, $lastfile);
  }
  print "Done\n";
}

sub sev_header {
  my($q, $lastfile) = @_;
  open(AL2, "$lastfile.count");
  $l = <AL2>; close(AL2);
  @sev = split(/\|/, $l);
  $sev[0] += 0;
  $sev[1] += 0;
  $sev[2] += 0;
  $sev[3] += 0;
  $sev[4] += 0;
  close(AL2);
  
  my($tt) = ["4=<img src=/gif/al_down.gif border=0 align=$al>Down ($sev[3])",
             "3=<img src=/gif/al_crit.gif border=0 align=$al>Critical ($sev[2])",
             "2=<img src=/gif/al_alert.gif border=0 align=$al>Alert ($sev[1])",
             "1=<img src=/gif/al_caution.gif border=0 align=$al>Caution ($sev[0])",
            ];

  $tab = WebTabs::create(list  =>  $tt,
                       url  => "/?GO=GUI::EventLog::display&sev=$q->{sev}",
                     width  => "100%",
             selectedColor  => "white",
         selectedTextColor  => "blue",
           backgroundColor  => $main'LIGHT,
        backgroundTextColor => black,
                  selection => $q->{option}
               );
  print "<table border=0><tr><td></table>" . $tab;
}

sub sev_display {
  my($opt, $file) = @_;
  my(@gifs) = ('al_caution2','al_alert2','al_crit2','al_down2');
  $opt = $opt - 1;

  open(AL, $file);
  $cnt = 0;
  print "<pre>";
  while ($l = <AL>) {
     next if ($l !~ /Sev:(\d)/);
     next if ($opt >= 0 && $opt != $1);
     if ($cnt++ < 50) {
        print "<img src=/gif/$gifs[$1].gif>$l";
     } else {
        print $l;
     }
  }
  close(AL);    
  print "Done\n";
}


#
# always pulls local data
# will print if called by a $q->{GET}, else will return it.
#
sub get_event_log {
  my($q) = @_;
  my($out, @a);
  my $MAXSIZE = 50000;
  my($grep) = System->get_home() . "/bin/rgrep";
  if ($q->{sev}) {  # alerts have a sev
    $file = System->get_home() . "/DATA/Alerts.log";
  } else {
    $file = System->get_home() . "/DATA/Events.log";
  }

  if ($q->{filter1} || $q->{filter2} || $q->{category} || $q->{event} ||
      $q->{sev}) {
     my($command);
     foreach my $c ('filter1','filter2','category','event','sev') {
        if ($q->{$c}) {
           if ($command) {
              $command .= "|$grep  -p \"$q->{$c}\" -i L";
           } else {
              $command = "$grep -p \"$q->{$c}\" -f $file -i L";
           }
        }
     }
     $file = "$command|";
     if (!open(O, $file)) {
        $out .= "ERR Cannot read $q->{file}: $!<br>";
        return;
     }
  } else {
    if (!open(O, $file)) {
      $out .= "ERR Cannot read $q->{file}: $!<br>";
      return;
    }
    my $fsize = (stat($file))[7];
    if ($fsize > $MAXSIZE) {
       seek(O, - $MAXSIZE, 2);
       $l = <O>;
    }
  }

  while ($l = <O>) {
     chop($l);
     my(@b) = split(/\t/, $l);
     if (substr($l, 0, 1) eq "L") {
        $a[$#a] .= "    - " . substr($l,1) . "\n";
     } else {
       $time = $b[0];
       $time =~ /(\d\d\d\d)(\d\d)(\d\d)(\d\d)(\d\d)(\d\d)/;
#      next if (!$1);
       $time = "$2/$3/$1 $4:$5:$6";
#      next if (!$b[1]);
       $type = sprintf("%-25.25s", $b[1]);
       push(@a, "$time  $type  $b[2] $b[3]\n");
     }
   }
   close(O);
   for ($x=$#a; $x >= 0; $x--) {
     $out .= $a[$x];
   }
   if ($q->{GET}) {
      print "$out";
   } else {
      return $out;
   }
}

1;

