package GUI::Graph;

use System;
use TO;
use State;
use strict;
use GUI::Instr;
use GUI::EventLog;
use Data::Dumper;
use Catalog;

use vars qw($AGE $CACHE @CACHEX);


sub index {
  my($q) = @_;
  my($renv, $devs, $hosts, $notifs) = PDM::ConfigFile->read;


  print "<body bgcolor=#666699>";
  print "<center>
    <table border=0 cellspacing=0 cellpadding=2 width=120  bgcolor=$main'LIGHT>
     <tr><td><b>&nbsp;SAN Topo</td>
     <td>&nbsp;&nbsp;<small><a href=/?GO=GUI::Graph::index>Close</a>
    </table>
  <table border=0 cellpadding=0 cellspacing=1 width=120>
  <tr><td nowrap bgcolor=$main'LIGHT></td>
  <tr><td bgcolor=white nowrap>
 ";

  my($TOindex) = System->get_home(). "/DATA/tmp/topoindex";

  my $tree =  Tree->new({target => 'left',
                     this => "/?GO=GUI::Graph::index",
                           q => $q,
                      sysgif => '/gifTopo',
                     linkall => 1,
                       bold1 => 1,
                      level1 => "Show Category",
                      level2 => "Show Hosts",
                        name => "ROOT"});

  my $redo = 1;
  my $age;
  my ($host_cnt, $san_cnt);
  if (!-f $TOindex) {
    $redo = 1;

  } else {
    $AGE = (stat($TOindex))[9];
    $redo = 0;
    my($T) = System->get_home() . "/DATA/topo";
    opendir(O, $T);
    my(@files) = readdir(O); closedir(O);
    my $cnt = 0;
    foreach my $f (sort @files) {
      next if (substr($f,0,1) eq ".");
      $cnt++;
      $age = (stat("$T/$f"))[9];
      if ($age > $AGE) {
        $redo = 1;
        last;
      }
    }
    $age = (stat(System->get_home() . "/DATA/topo_merge"))[9];
    $redo = 1 if ($age > $AGE);
    $redo = 1 if ($cnt == 0);
  }
  my $empty = 0;

  if ($redo) {
    my(%SW);
    @CACHEX = ();
    foreach my $sw (@$devs) {
      if ($sw->{type} eq "switch") {
         $SW{$sw->{ipno}} = $sw->{name};
      }
    }
    my $DD =  System->get_home() . "/DATA/topo";
    opendir(O, $DD); my(@files) = readdir(O); closedir(O);
  
    my($in) = 0;
    foreach my $f (sort @files) {
       next if (-d "$DD/$f");
       next if (substr($f,0,1) eq "." || substr($f,0,6) eq "MERGE-");
       my $i = index($f, ".");
       my $f0 = $f;
       $f0 = substr($f,0, $i) if ($i > 0);
       push(@CACHEX, ["/*Hosts/h:$f0", "/?GO=GUI::Graph::run3&topo=$f"]);
       $host_cnt++;
    }
    $empty = 1 if ($#CACHEX == -1);
  
    if (!$empty) {
      my($F) = System->get_home() . "/DATA/topo_merge";
      open(O, $F);
      my(@a) = <O>; close(O);
  
      foreach my $m (@a) {
        my(@b) = split(/\|/, $m);
        my($t) = $b[0];
        push(@CACHEX, ["/*SANs/$t", "/?GO=GUI::Graph::run3&stopo=MERGE-$t"]);
       $san_cnt++;
      }
    }

    opendir(O, $DD);
    my($type, %AT , $name, $type, $h);

    my(%SORT);
    foreach my $t (@files) {
      next if (-d "$DD/$t");
      next if (substr($t,0,5) eq "MERGE");
      next if (substr($t,0,1) eq ".");
  
      my($to)       =  TO->readTopo($t);
      next if (!$to);
      my($switches) = $to->switchList();
      my($storages) = $to->storageList();
      foreach my $sw (@$switches) {
         my $ip = $sw->{info}{sw_ipAddr};
         $name = $SW{$ip} || $ip;
         $SORT{"SWITCH:$name"} .= "$t|" . $sw->{info}{name} . "\t";
      }
      foreach my $st (@$storages) {
         $name = $st->{info}{BoxName};
         my $i = index($name, ".");
         $name = substr($name,0, $i) if ($i > 0);
         
         $type = uc($st->{info}{type});
         if ($name) {
           $SORT{"$type:$name"} .= "$t|" . $st->{info}{name} . "\t";
         }
      }
    }
    my($h1);
    foreach my $s (sort keys %SORT) {
      ($type, $name) = split(/:/, $s);
      my $val = $SORT{$s};
      $val = substr($val, 0, -1) if (substr($val,-1) eq "\t");
      my(@list) = split(/\t/, $val);

      my($l0,$l1) = split(/\|/, $list[0]);
      push(@CACHEX, ["/$type/$name", "/?GO=GUI::Graph::run3&topo=$l0&key=$l1&name=$name"]);
      if ($#list > 0) {
        foreach my $h0 (@list) {
          my($l0,$l1) = split(/\|/, $h0);
          my $i = index($l0, ".");
          $h1 = ($i > 0) ? substr($l0 ,0, $i) :$l0;
          push(@CACHEX, ["/$type/$name/h:$h1", "/?GO=GUI::Graph::run3&topo=$l0&key=$l1&name=$name"]);
        }
      }
    }
    if (!$empty) {
      open(O, ">$TOindex");
      foreach my $l (@CACHEX) {
         print O $l->[0] . "\t" . $l->[1] . "\n";
      }
      close(O);
    }
    $AGE = time;

  } elsif ($#CACHEX < 0) {
    open(O, $TOindex);
    my($l);
    while ($l = <O>) {
      chop($l);
      my(@a) = split(/\t/, $l);
      push(@CACHEX, [$a[0], $a[1]]);
    }
    close(O);
  }

  if ($empty) {
    print "<b><center>No Topology <br>available<br> Run rasagent first!";
  } else {
    my $o;
    $o = "SANs" if ($san_cnt < 4);
    if ($host_cnt < 4) {
       $o .= "|" if ($o);
       $o .= "Hosts";
    }
    print $tree->read(\@CACHEX, undef, $o);
  }
  print "</table></table>";
  print "</center> &nbsp;<br><font color=white>-</font> <a href=/sanF.html target=bottom><font color=white>SAN Menu</font></a>
  ";
  
}

sub f2 {
  my($q) = @_;

  my $p = ($q->{topo}) ? "topo=$q->{topo}":"stopo=$q->{stopo}";
  $p .= "&key=$q->{key}&name=$q->{name}";
  print "<frameset cols=*,33% border=1>
   <frame src=/?GO=GUI::Graph::run3&$p name=left scrolling=no  marginheight=1 marginwidth=1>
   <frame src=javascript:return() name=details scrolling=auto >
 </frameset>
  ";
}





sub run3 {
  my($q) = @_;
  my($ck, $in, $title2, $title, $type);
  print "<body bgcolor=white link=blue alink=blue vlink=blue>";
  my($renv) = System->get_renv();

  $title = ($q->{topo})? "Host: $q->{topo}":"SAN: " . substr($q->{stopo},6);
  my($F) = System->get_home() . "/DATA/topo_merge";


  my $rediscover;
  if ($q->{topo} eq $renv->{hostname} ) {
     $rediscover =<<EOF;
      <script> function open1(x) {
        var O = window.open(x, "win1","menubar=no,resizable=yes,scrollbars=yes,width=500,height=600");
        O.focus();
        return undef;
      }
      </script>
     <a href=javascript:open1("/?GO=GUI::Graph::run3&rediscover=1")
      onclick=\"return confirm('This may take a while, Are you sure you want to re-discover?')\">Re-Discover</a> |
EOF
  }
  if ($q->{key}) {
     my $ii = index($q->{key},":");
     $type = substr($q->{key},0,$ii+1);
  }
  if ($q->{CE} == 1) { # clear that State file
     my($renv) = System->get_renv();
     unlink System->get_home() . "/DATA/state/$renv->{hostname}";
  }


  if ($q->{rediscover}) {
    TO->clearTopo();
    print "</center></b><pre><small>";
    print " Re-Discovering topology...\n<br>";
    my($to) =  TO->readTopo();
    my $url = "/?GO=GUI::Graph::run&topo=" . System->hostname();
    print $to->toString();
    
  } else {
    $rediscover =<<EOF;
[$rediscover <a href=/?GO=GUI::Graph::run3&topo=$q->{topo}&CE=1
       onclick=\"return confirm('Are you sure you want to clear all errors?')\">Clear</a> ]
EOF
    print "<table border=0 width=100% cellpadding=3 cellspacing=1 bgcolor=#CCCCFF>
    <td nowrap><b> &nbsp;$title </td>
    <td><b>&nbsp;$type$q->{name} </td>
    <td align=right><img src=/gif/lights.gif alt=\"Red=Error, Yellow=Warning, Green=Back to Normal\"></td>
    <td align=right>$rediscover&nbsp;</table>
    ";
#    return if (!$in);
    if ($q->{stopo}) {
      $q->{topo} = $q->{stopo};
      print &genApplet($q);
    } elsif ($q->{topo}) {
      print &genApplet($q);
    }
  }
}



sub run {
  my($q) = @_;
  my($ck);
  print "<body bgcolor=#F0F0F0 link=blue alink=blue vlink=blue>";
  my($renv) = System->get_renv();

  opendir(O, System->get_home() . "/DATA/topo");
  my(@files) = readdir(O); closedir(O);
  my($list)  = "<select name=topo ONCHANGE=this.form.elements[2].selectedIndex=0><option value=\"\">[Select]";
  my($Slist) = "<select name=stopo ONCHANGE=this.form.elements[1].selectedIndex=0><option value=\"\">[Select]";

  my($in) = 0;
  foreach my $f (sort @files) {
     next if (substr($f,0,1) eq "." || substr($f,0,6) eq "MERGE-");
     $in++;
     $ck = "";
     if (!$q->{stopo} && ($q->{topo} eq $f || $q->{topo} eq "")) {
         $ck = "selected";
         $q->{topo} = $f;
     }
     my $ii = index($f,".");
     my $f0 = $f;
     $f0 = substr($f, 0, $ii) if ($ii > 0);
      
     $list .= "<option $ck value=\"$f\">$f0</option>";
  }

  my($F) = System->get_home() . "/DATA/topo_merge";
  open(O, $F);
  my(@a) = <O>; close(O);
  foreach my $m (@a) {
     my(@b) = split(/\|/, $m);
     my($t) = $b[0];
     $ck = "";
     if ($q->{stopo} eq "MERGE-$t") {
         $ck = "selected";
         $q->{stopo} = "MERGE-$t";
     }
     $Slist .= "<option $ck value=\"MERGE-$t\">$t</option>";
  }
  my $rediscover;
  if ($q->{topo} eq $renv->{hostname} ) {
   $rediscover = "<a href=/?GO=GUI::Graph::run&rediscover=1 
      onclick=\"return confirm('This may take a while, Are you sure you want to re-discover?')\">Re-Discover</a> |";
  }

  $list .= "</select>";
  $Slist .= "</select>";
  print "<table border=0 cellspacing=0 cellpadding=0 width=100%>
  <tr>
     <form><input type=hidden name=GO value=GUI::Graph::run>
     <td nowrap><b>
         &nbsp;Topology Host: $list
         &nbsp;SAN: $Slist <input type=submit name=ACTION value=Display>
      </td>
      <td align=right><b>[ $rediscover <a href=/sanF.html target=_parent>Back</a> ]&nbsp;</table>
  ";
  if (!$in) {
     print "&nbsp;<center><p><h3>No Topology available yet, need to wait for rasagent execution.";
  }


  if ($q->{rediscover}) {
    TO->clearTopo();
    print "</center></b><pre><small>";
    print " Re-Discovering topology...\n<br>";
    my($to) =  TO->readTopo();
    my $url = "/?GO=GUI::Graph::run&topo=" . System->hostname();
    print "<meta http-equiv=Refresh content=\"3;URL=$url\">";
    print $to->toString();
    
  } else {
    return if (!$in);
    if ($q->{stopo}) {
      $q->{topo} = $q->{stopo};
      print &genApplet($q);
    } elsif ($q->{topo}) {
      print &genApplet($q);
    }
  }
}


sub genAppletData {
  my($q, $parms_format)= @_;
  my($o1);
  my($to) = TO->readTopo($q->{topo});    # merge topos
  if (!$to) {
     print "ReadTopo failed on $q->{topo}<br>";
     return;
  }

# merge states
  my($State) = State->read();  # merge state
  

# q->{email} decides if the applet is inside an email or not.

  my($zoom,$objs) = $to->appletStream({
                      name => $q->{topo},
                    status => \&statusFunc,
                     state => $State,
                  fibreLog => [],
                  counters => undef, clear => $q->{clear}});

  if ($parms_format) {
    my($out2) = "";
    my($cnt) = 1;
    $zoom = $q->{zoom} if (defined($q->{zoom}));
    if ($zoom >= 0) {
      $out2 .= "<param name=zoom value=\"$zoom\">\n";
    }
    foreach my $o (split(/\n/, $objs) ) {
      $o1 = $o; $o1 =~ s/'/ /g;
      $out2 .= "<param name=object$cnt value=\"$o1\">\n";
      $cnt++;
    }
    return $out2;
  } else {
    return $objs;
  }
}

# $out =  GUI::Graph::genApplet({  topo   => $k,  email => 1, 
#                                [ width=> 600, height => 400, zoom  => 3 ] } );

sub genApplet {
  my($q) = @_;
  my($o1);
  
  my $out2 = genAppletData($q, 1); # returns <parms ...

  my $current = $q->{topo};

  my($applet, $parm1, $parm2);
  my($code, $off, $offx);

  if ($q->{email}) {
    $code = "http://nscc/CC/Topo/";
    $off = 70;
    $offx = 30;
  } else {
    $code = "Topo";
    $off = 20;
    $offx = 6;
  }
  my $zoom = $q->{zoom}  + 0;

  if ($q->{height} && $q->{width}) {
    $applet = "<applet  CODE=VertexApplet.class codebase=$code archive=topo.jar height=$q->{height}  width=$q->{width}>";

  } else {
    $applet = System->appletHeader("code=VertexApplet.class codebase=$code archive=topo.jar", $offx, $off);
  }

  if (!$q->{email}) {
   $parm1 =<<EOF;
  <param name=url value="GET=GUI::Graph::topos&topo=$current">
  <param name=urlRefresh value="GET=GUI::Graph::topos&topo=$current">
  <param name=timeRefresh value="10000">
  <param name=circle value="$q->{key}">
  <param name=drop1 value="Report on|details|h|GET=GUI::Graph::report&topo=$current">
  <param name=drop2 value="Discman on|details||GET=GUI::Graph::details&topo=$current">
  <param name=drop3 value="Event Log|details|h|GET=GUI::Graph::eventLog&topo=$current">
  <param name=drop4 value="Clear|t|r,h|GET=GUI::Graph::clear&topo=$current">
  <param name=ldrop1 value="Display Error|details|h|GET=GUI::Graph::fibrelog&topo=$current">
  <param name=ldrop2 value="Clear Error|t|r,h|GET=GUI::Graph::clearlog&topo=$current">
  <param name=browser value="sun">
EOF
   }
   return "$applet $parm1 $out2 </applet> </form>";
}



#
# call-back from applet
#
sub get_topos {
  my($q) = @_;
  my($l, @LOG);
     
  print genAppletData($q);
  
}

sub get_topos0 {
  print "
s0|v|s,Ancor,2-4/6-8,8,F0F0F0|switch:100000c0dd008855=switchA,Ancor,()|126|8|||||||diskinfo|otherinfo
00|e|s||s0,2|s0,4
00|e|s||s0,6|s0,8
s1|v|s,Ancor,6-8,8,F0F0F0|switch:100000c0dd008855,Ancor,()|126|108|||||||diskinfo|otherinfo
00|e|s||s1,6|s1,8
u0|v|u,Hub|u:H0|226|328|||||encInfo|portinfo|diskInfo|encinfo
00|e|f||u0,0|s0,8
00|e|f||u0,1|a2,1
00|e|f||u0,2|a0,1
u1|v|u,Hub|u:H1|229|219|||||encInfo|portinfo|diskInfo|encinfo
00|e|f||u1,0|s1,8
00|e|f||u1,1|a0,0
00|e|f||u1,2|a2,0
h0|v|h,Sun,8|host:nscc-test,host|10|86||-1,,-1,,-1,,-1,|||encInfo| /pci\@6_4000/pci\@2/SUNW_qlc\@4, /devices/pci\@6_4000/pci\@2/SUNW_qlc\@5, /devices/pci\@6_4000/pci\@3/SUNW_qlc\@4,/devices/pci\@6_4000/pci\@3/SUNW_qlc\@5, /devices/pci\@6_4000/pci\@4/SUNW_qlc\@4, /devices/pci\@6_4000/pci\@4/SUNW_qlc\@5, /devices/pci\@6_2000/pci\@1/SUNW_qlc\@4, /devices/pci\@6_2000/pci\@1/SUNW_qlc\@5|diskInfo|otherInfo
00|e|f||h0,1|s0,6
00|e|f||h0,3|s1,6
00|e|f||h0,7|s0,2
a0|v|a,A5K,2,11,f/r,FBP,Fan/BackPlane/Power,D0D0F0|a5k:508002000008a328=e,A5200,()|343|167||||||||
00|e|f||u1,1|a0,1
00|e|f||u0,2|a0,2
a1|v|a,T3,2,9,1/2,LMPV,Lun/Midplane/Power/Volume,F0C0C0|t3:21312312-1232133=diag230,PGroup,()|333|20||||||||
00|e|f||h0,5|a1,1
";
}

# returns encstatus, portstatus, diskstatus, otherstatus for each
# category: s=switch,a=a5, t=t3, 3=a3500

sub val2 {
  my($ix, @a) = @_;
  my($o) = -2;
  my($val);
  foreach my $x (@a) {
    if (defined($x->[0]) && $x->[0] > $o) {
          $o = $x->[0];
          $val = $x->[$ix];
    }
  }
  return $val;
}

sub val {
  my(@a) = @_;
  my($o) = -2;
  foreach my $x (@a) {
     $o = $x if (defined($x) && ($x > $o));
  }
  return "" if ($o == -2);
  return $o;
}


sub statusFunc {
  my($type, $name, $arg) = @_;
  my($enc, $port, $disk, $other, $d) ;
  my($l1,$l2, $p1, $p2, $m1, $v1, $v2, $l3, $l4, $p3, $p4, $v3, $v4, $x);
  my($encInfo, $portInfo, $diskInfo, $otherInfo, $i, $u) ;

  my($State) = $arg->{state}->{C};

  if ($type eq "a3500fc") {
     $i = $State->{"$name:e"};
     $enc = $i->[0];
     $encInfo = $i->[1];
     $port =  $State->{"$name:controller.a"}[0] . "," .
              $State->{"$name:controller.b"}[0];

     $portInfo = $State->{"$name:controller.a"}[1] . "," . 
                 $State->{"$name:controller.b"}[1];

     $disk =""; $diskInfo = ""; $otherInfo = ""; $other = "";
     for ($d=0; $d <= 9; $d++) {
         $disk .= $State->{"$name:disk.$d"}[0] . ",";
         $diskInfo .=$State->{"$name:disk.$d"}[1] . ",";
     }


  } elsif ($type eq "t3") {
     $i = $State->{"$name:e"};
     $enc = $i->[0];
     $encInfo = $i->[1];
     $port =  $State->{"$name:controller.u1ctr"}[0] . "," .
              $State->{"$name:controller.u2ctr"}[0];

     $portInfo = $State->{"$name:controller.u1ctr"}[1] . "," . 
                 $State->{"$name:controller.u2ctr"}[1];

     $disk =""; $diskInfo = ""; $otherInfo = ""; $other = "";
     for ($u=1; $u <= 2; $u++) {
       for ($d=1; $d <= 9; $d++) {
         $disk .= $State->{"$name:disk.u${u}d$d"}[0] . ",";
         $diskInfo .=$State->{"$name:disk.u${u}d$d"}[1] . ",";
       }
    }
#   LMPV

     $l1 = $State->{"$name:loopcard.u1l1"};
     $l2 = $State->{"$name:loopcard.u1l2"};
     $l3 = $State->{"$name:loopcard.u2l1"};
     $l4 = $State->{"$name:loopcard.u2l2"};

     $p1 = $State->{"$name:power.u1pcu1"};
     $p2 = $State->{"$name:power.u1pcu2"};
     $p3 = $State->{"$name:power.u2pcu1"};
     $p4 = $State->{"$name:power.u2pcu2"};

     $v1 = $State->{"$name:volume.u1vol1"};
     $v2 = $State->{"$name:volume.u1vol2"};
     $v3 = $State->{"$name:volume.u2vol1"};
     $v4 = $State->{"$name:volume.u2vol2"};

     $m1 = $State->{"$name:midplane.u1mpn"};

     $other = &val($l1->[0], $l2->[0], $l3->[0], $l4->[0])  . "," .
               $m1->[0] . "," .
              &val($p1->[0], $p2->[0], $p3->[0], $p4->[0]) . "," .
              &val($v1->[0], $v2->[0], $v3->[0], $v4->[0]);

     $otherInfo = &val2(1,$l1, $l2, $l3, $l4)  . "," .
              $m1->[1] . "," .
              &val2(1,$p1, $p2, $p3, $p4) . "," .
              &val2(1,$v1, $v2, $v3, $v4);


 } elsif ($type eq "a5k") { 
     $i = $State->{"$name:e"};
     $enc = $i->[0];
     $encInfo = $i->[1];

     ($type, $name) = split(/:/, $name);
     $name = "a5k:$name";

     my($p1) = $State->{"$name:interface_board.A"}[0] ;
     my($p2) = $State->{"$name:interface_board.A.gbic0"}[0];
     my($p3) = $State->{"$name:interface_board.A.gbic1"}[0];
     $port  = &val($p1, $p2, $p3);
     $port  .= ",";

     my($p1) = $State->{"$name:interface_board.B"}[0] ;
     my($p2) = $State->{"$name:interface_board.B.gbic0"}[0];
     my($p3) = $State->{"$name:interface_board.B.gbic1"}[0];
     $port  .= &val($p1, $p2, $p3);


     $portInfo =  ($State->{"$name:interface_board.A"}[1] ||
               $State->{"$name:interface_board.A.gbic0"}[1] ||
               $State->{"$name:interface_board.A.gbic1"}[1] ) . "," .

              ($State->{"$name:interface_board.B"}[1] ||
               $State->{"$name:interface_board.B.gbic0"}[1] ||
               $State->{"$name:interface_board.B.gbic1"}[1] );

     $l1 = $State->{"$name:power.0"};
     $l2 = $State->{"$name:power.1"};
     $l3 = $State->{"$name:power.2"};

     $p1 = $State->{"$name:fan.0"};
     $p2 = $State->{"$name:fan.1"};

     $other = &val($p1->[0], $p2->[0]) . ",," . 
              &val($l1->[0], $l2->[0], $l3->[0], $l4->[0]);

     $otherInfo =  &val2(1,$p1, $p2) . ",," . 
                   &val2(1,$l1, $l2, $l3, $l4) ;

     foreach $u ('disk_front','disk_rear') {
       for ($d=0; $d <= 10; $d++) {
         $disk .= $State->{"$name:${u}.$d"}[0] . ",";
         $diskInfo .=$State->{"$name:${u}.$d"}[1] . ",";
       }
    }
  } elsif ($type eq "switch") {
     $i = $State->{"$name:e"};
     $enc = $i->[0];
     $encInfo = $i->[1];

     my $f1 = $State->{"$name:chassis.fan.1"};
     my $f2 = $State->{"$name:chassis.fan.2"};

     my $p1 = $State->{"$name:chassis.power"};

     my $t1 = $State->{"$name:chassis.temp"};

     $other = &val($f1->[0], $f2->[0]) . "," . $p1->[0] . "," . 
              $t1->[0];

     $otherInfo =  &val2(1,$f1, $f2) . "," . $p1->[1] . "," .
                   $t1->[1];

     for ($x=0; $x <= 16; $x++) {
         $port .= $State->{"$name:port.$x"}[0] . ",";
         $portInfo .= $State->{"$name:port.$x"}[1] . ",";
     }
  }
  return ($enc, $port, $disk, $other,
          $encInfo, $portInfo, $diskInfo, $otherInfo);
}


sub get_clearlog {
  my($q) = @_;

  my(@nodes) = split(/\//, $q->{link});

  my $State  = State->read($q->{topo});

  $State->clearLink("$nodes[0]|$nodes[1]");
  $State->clearLink("$nodes[1]|$nodes[0]");

  
  State->write();
  &get_topos($q);
  
}


sub get_fibrelog {
  my($q) = @_;
  my($node0, $node1);
  print "<body bgcolor=white>";
  my(@nodes) = split(/\//, $q->{link});

  if ($nodes[0] gt $nodes[1]) {
     $node0 = $nodes[1];
     $node1 = $nodes[0];
  } else {
     $node0 = $nodes[0];
     $node1 = $nodes[1];
  }

  &call($q, $node0, $node1);
  print "<tr><td>&nbsp;</td>";
  &call($q, $node1, $node0);
}

sub call {
  my($q, $node0, $node1) = @_;
  my($x);

  my(@b1) = split(/:/, $node0);
  my(@b2) = split(/:/, $node1);

  my($type1) = $b1[0];
  my($type2) = $b2[0];
  my($name1) = $b1[1];
  my($name2) = $b2[1];
  my($port1) = "Port." . $b1[2];
  my($port2) = "Port." . $b2[2];

  my $L     = State->read($q->{topo});
  my $links = $L->links();

  my $ln      = $links->{"$node0|$node1"};
  my $v       =  $ln->[1];
  my $actions =  $ln->[2];
  my $host    = $ln->[4];
  my $detec   = $host;
  my $ii      = index($host,".");
  $detec      = substr($host, 0, $ii) if ($ii > 0);
  my $pc      = $actions->[0];
  my $ra      = $actions->[1];
  $pc =~ s/\|\|/<br>/g;
  $ra =~ s/\|\|/<br>/g;

  if ($v) {
    print "<table border=0 cellpadding=2 cellspacing=0 width=100%>
    <tr bgcolor=#666699><td>
     <table border=0 cellspacing=0 width=100%>
       <tr><td><font color=white><b>Fibre Errors: $type1 -> $type2</td>
       <td align=right><font color=white>$detec</table></td>
    ";
    $v =~ s/Origin:/<br>Origin:/;
    $v =~ s/Destination:/<br>Destination:/;

    print "<tr><td>$v";
    if ($pc || $ra) {
    print " <tr><td bgcolor=#E0E0E0><b>Probable Causes</td>
<tr><td>$pc<br>
<tr><td bgcolor=#E0E0E0><b>Recommended Actions</td>
<tr><td>$ra<br>&nbsp;";
    } else {
      print "<tr><td>&nbsp;</td>";
    }

    print "</table>\n";

    print "<table  border=0 cellpadding=2 cellspacing=0 width=100%>
";
    my $log = State->linkLog($host, "$node0|$node1");
    if ($log) {
     my @x = split(/\n/, $log);
     my $lt = "(last 10)" if ($#x > 10);
     $log =~ s/\n/<br>/g;
     print 
"<tr><td bgcolor=#E0E0E0><b>Message-Log (R=read,W=write) $lt:</td>
<tr><td><small>" . $log;
    }
    print "</table><hr>";
  }
}

sub put_topos {
  my($q, $post_data) = @_;
  TO::put_topo_xy($q, $post_data);
}


sub get_eventLog {
  my($q) = @_;
  my($renv, $devs, $hosts,$notifs) = PDM::ConfigFile->read;

  my($type, $key, $comp) = split(/:/, $q->{enc});
  my($filter1);
  my($host) = "host_local";
  my($found) = 0;

  my $ci = Catalog->deviceRead($type, Catalog::Key, $key);

  if (!$ci) {
    print "No entry in config file for $q->{enc}";
    return;
  }
  $host = $ci->[Catalog::Host];
  $q->{"host_$host"} = 1;
  $q->{filter1}  = $key;

  $q->{category} = $type;
  $q->{BACK}     = 0;
  GUI::EventLog::display($q);

}

sub get_report {
  my($q) = @_;
  my($l);
  if (!$q->{page}) {
    print "<frameset rows=50%,*>
     <frame src=/?GO=GUI::Graph::get_report&page=1&enc=$q->{enc} f1 scrolling=auto>
     <frame src=javascript:return() name=main2 scrolling=auto>
    </frameset>
    ";
    return;
  }

  print "<body bgcolor=white>";

  my($type, $key, $comp) = split(/:/, $q->{enc});

  my($renv) = System->get_renv();
  $q->{file} = "$type:$key";
  my $found = 0;

  my $host = Report->findReportHost($q->{file});

  if (!defined($host)) {
     my($ci,$port) = Catalog->deviceRead("", Catalog::WWN, $key);

     if (!$ci) {
        print "<b>No Report available for: $q->{file}";
        return;
     }
     $host = $ci->[Catalog::Host];
     $q->{file} =  $type . ":" . $ci->[Catalog::Key];
  }

  $q->{host} = $host;
  GUI::Instr::explore1($q);
}

sub get_details {
  my($q) = @_;
  my($renv, $devs, $hosts,$notifs) = PDM::ConfigFile->read;

  my($to) = TO->readTopo($q->{topo});

  my($type, $key, $comp) = split(/:/, $q->{enc});

  print "<body bgcolor=white>";
  print "<table border=1 cellspacing=0 cellpadding=2 width=100%>
   <tr bgcolor=#666699><td><font color=white><b>System Review: $q->{enc}</td>
   </table><pre><small>";
  my($node)  = $to->nodeByName("$type:$key");
   $Data::Dumper::Indent = 1;
  print Dumper($node);

}


$CACHE =undef;


sub log2 {
  my($l) = @_;
  open(OO, ">>/tmp/log2"); print OO $l . "\n"; close(OO);
}

sub get_clear {
  my($q) = @_;
  my($type, $name, $comp) = split(/:/, $q->{enc});
  my($u, $unit, $d);

  my($State) = State->read($q->{topo});

  if ($comp eq "e") {  # enclosure
    $State->clear($q->{enc});
 
  } else {
    if ($type eq "a3500fc") {
       if ($comp eq "s1") {
          $State->clear("$type:$name:controller.a");
       } elsif ($comp eq "s2") {
          $State->clear("$type:$name:controller.b");
  
       } elsif (substr($comp, 0, 1) eq "d") {
          my($no) = substr($comp,1);
  
          $State->clear("$type:$name:disk.$no");
       }

    } elsif ($type eq "a5k") {
       if ($comp eq "s1") {
          $State->clear("$type:$name:interface_board.A");
          $State->clear("$type:$name:interface_board.A.gbic0");
          $State->clear("$type:$name:interface_board.A.gbic1");
       } elsif ($comp eq "s2") {
          $State->clear("$type:$name:interface_board.B");
          $State->clear("$type:$name:interface_board.B.gbic0");
          $State->clear("$type:$name:interface_board.B.gbic1");
  
       } elsif (substr($comp, 0, 1) eq "d") {
          if (substr($comp, 1,1) eq "f") {
            $u = "disk_front";
          } else {
            $u = "disk_rear";
          }
          my($no) = substr($comp,2);
  
          $State->clear("a5k:$name:$u.$no");
       }
  
    } elsif ($type eq "switch") {

       my $key = "switch:$name:port." . substr($comp,1);
       &log2("enc=$q->{enc}, key=$key ");

       $State->clear($key);
  
    } elsif ($type eq "t3") {
       if ($comp eq "s1") {
          $State->clear("$type:$name:controller.u1ctr");
       } elsif ($comp eq "s2") {
          $State->clear("$type:$name:controller.u2ctr");
  
       } elsif (substr($comp,0,1) eq "d") {
          $unit = substr($comp,1,1);
          $d = substr($comp,2) + 1;
          $State->clear("$type:$name:disk.u${unit}d$d");
  
       } elsif (substr($comp,0,1) eq "L") {
          $State->clear("$type:$name:loopcard.u1l1");
          $State->clear("$type:$name:loopcard.u1l2");
          $State->clear("$type:$name:loopcard.u2l1");
          $State->clear("$type:$name:loopcard.u2l2");
  
       } elsif (substr($comp,0,1) eq "M") {
          $State->clear("$type:$name:midplane.u1mpn");
          $State->clear("$type:$name:midplane.u2mpn");
  
       } elsif (substr($comp,0,1) eq "P") {
          $State->clear("$type:$name:power.u1pcu1");
          $State->clear("$type:$name:power.u1pcu2");
          $State->clear("$type:$name:power.u2pcu1");
          $State->clear("$type:$name:power.u2pcu2");
  
       } elsif (substr($comp,0,1) eq "V") {
          $State->clear("$type:$name:volume.u1vol1");
          $State->clear("$type:$name:volume.u1vol2");
          $State->clear("$type:$name:volume.u2vol1");
          $State->clear("$type:$name:volume.u2vol2");
       }
  
    }
  }
  State->write();
  &get_topos($q);
  #
}

sub topo {
  my($q) = @_;

  eval {
   TO->readTopo($q->{topo}); # get objects in globals
   &topoApplet();
  };
  print "$@";

}




1;
