package GUI::Instr;
#  $Id: Instr.pm,v 1.34 2001/07/26 00:41:44 ccadieux Exp $

use Util;
use Util::Http;
use Tree;
use System;
use PDM;
use Report;
use Catalog;
use GUI::Graph;
use State;

sub reverse {
  my($d) = @_;
  return (3000 - substr($d,0,4)) .   # year
         (20 - substr($d,5,2))   .   # month
         (40-substr($d,8,2))     .   # day
         (999999- (substr($d,11,2).substr($d,14,2).substr($d,17,2)));
}

sub explore {
  my($q, $post, $util) = @_;
  my(%D, $data, $head);
  print "<body bgcolor=#E0E0E0 vlink=blue><center>";
  print "\n";

  my($renv, $dev, $hosts, $notifs) = PDM::ConfigFile->read;
  my(%MAP);
  my($local) = System->hostname();
  my($hostsD) = "<select name=host><option value=local>$local</option>";

  foreach $h (@$hosts) {
     $MAP{$h->{hostname}} = $h->{ip};
     $sel = ($h->{hostname} eq $q->{host})? "selected":"";
     $hostsD .= "<option value=\"$h->{hostname}\" $sel>$h->{hostname}</option>";
  }
  $sel = ($q->{host} eq "ALL")? "selected":"";
  $hostsD .= "<option value=ALL $sel>All Hosts</option>";

  $hostsD .= "</select><input type=submit name=ACTION value=GO>";

  $head = "<table border=0 cellspacing=0 width=100%>
   <form><input type=hidden name=GO value=GUI::Instr::explore>
   <tr><td><font color=navy size=+2><b>Instrumentation</td>
       <td align=right><b>
          Select Name:
          <input type=text size=10 name=PREFIX value=$q->{PREFIX}>&nbsp;
          Host: $hostsD </table>";
  my $prefix = $q->{PREFIX};

  $shost = $q->{host} || "local";
  my $sort = $q->{sort} || "HOST";

  print $head;

  my(%CONF) = ();
  my($types) ;
  foreach my $d1 (@$dev) {
     $CONF{$d1->{ip}} = $d1->{name};
     $types .= "$d1->{type},";
  }
  my $State = State->read();
  my $Comp = $State->components();
  my %DB = ();
  foreach my $q (keys %$Comp) {
     if ($Comp->{$q}[0] >= 1) {
       my($t, $n, $p) = split(/:/, $q);
       my $k = "$t:$n";
       if ($Comp->{$q}[0] >= $DB{$k}) {
          $DB{$k} = $Comp->{$q};
       }
     }
  }

  my @GIF = ('al_ok.gif alt=OK','al_alert.gif alt=Warning','al_crit.gif alt=Error','al_down.gif alt=Down');
  

# LOCAL RUNS
  my(@LIST);
  if ($shost eq "local" || $shost eq "ALL") {
    my($D) = System->get_home() . "/DATA/OLD_REPORTS";
    opendir(O, $D);
    @a = readdir(O); closedir(O);
    $found = 0;
    $first = System->hostname();
    foreach $file (@a) {
       next if ($file !~ /.+:.+/);
       $found++;
       @b = split(/:/, $file);
       next if (index("message,host,san,topo,mpxio", $b[0]) >= 0);
       next if (index($types, $b[0]) < 0); # only display types that are in the config file
       $date    =  Util->get_file_created("$D/$file");
       my($wwn) = $b[1];
       my $name = Catalog->deviceRead("", Catalog::Key, $b[1], Catalog::Name);
       if (!$name) {
          open(O1, "$D/$file");
          my @x = <O1>; close(O1);
          eval "@x";
          $name= $VAR1->name();
       }
       next if ($prefix and $name !~ /^$prefix/);
  
       $url = "<a href=?GO=GUI::Instr::explore1F&file=$file&type=$b[0] target=tree>$name </a>";
       $report = "<a href=?GO=GUI::Instr::report&file=$file&type=$b[0] target=tree>Report</a> ";
       
       my($conf_name) = $CONF{$name} ? "$CONF{$name} / ":"";
       $state = $DB{$file};

       if ($sort eq "TYPE") {
          $v = lc($b[0]);
       } elsif ($sort eq "NAME") {
          $v = $name;
       } elsif ($sort eq "STATUS") {
          $v = sprintf("%2.2d", 10 - $state->[0]);
       } elsif ($sort eq "DATE") {
          $v = &reverse($date);
       } else {  # if ($sort eq "HOST") {
          $v = $first;
       }
       $v .= "\t$first\t$b[0]\t$url\t$report\t$state->[0]\t$file\t$date\thost_local";
       push(@LIST, $v);
    }
  }

# SLAVE RUNS
  $D = System->get_home() . "/DATA/REMOTE_LISTS";
  opendir(O, $D);
  @fs = readdir(O); closedir(O);
  foreach $f (@fs) {
    next if (substr($f,0,1) eq ".");
    next if ($shost ne $f && $shost ne "ALL");
    open(O, "$D/$f");
    $host = $f;
    $out .= "<tr><td colspan=7></td>";
    while ($l = <O>) {
       my($file_1, $date_1, $acces_1, $name_1) = split(/=/, $l);
       next if (!$date_1);
       my($type_1, $wwn_1) = split(/:/, $file_1);
       next if (index("message,host,san,topo", $type_1) >= 0);
       next if ($prefix and $name_1 !~ /^$prefix/);

       $url = "<a href=?GO=GUI::Instr::explore1F" . 
             "&host=$MAP{$f}&file=$file_1 target=tree>$name_1</a> ";
       $report = "<a href=?GO=GUI::Instr::report" . 
             "&host=$MAP{$f}&file=$file_1 target=tree>Report</a> ";

       $state = $DB{$file_1};

       if ($sort eq "TYPE") {
          $v = lc($type_1);
       } elsif ($sort eq "NAME") {
          $v = $name_1;
       } elsif ($sort eq "STATUS") {
          $v =  sprintf("%2.2d", 10 - $state->[0]);
       } elsif ($sort eq "DATE") {
          $v = &reverse($date_1);
       } else {
          $v = $f;
       }
       $v .= "\t$host\t$type_1\t$url\t$report\t$state->[0]\t$file_1\t$date_1\thost_$f";
       push(@LIST, $v);
    }
    close(O);
  }

  $out =<<EOF;
<table border=1 cellpadding=1 cellspacing=0 width=100% bgcolor=white><tr bgcolor=#666699>
   <td><b><font color=white><center>
      <a href=/?GO=GUI::Instr::explore&sort=HOST&host=$q->{host}><font color=yellow>Host</font></a></td>
   <td><b><font color=white><center>
      <a href=/?GO=GUI::Instr::explore&sort=TYPE&host=$q->{host}><font color=yellow>Type</font></a></td>
   <td><b><font color=white><center>
      <a href=/?GO=GUI::Instr::explore&sort=NAME&host=$q->{host}><font color=yellow>Name</font></a></td>
   <td><b><center><font color=white>Links</td>
   <td><b>
      <a href=/?GO=GUI::Instr::explore&sort=STATUS&host=$q->{host}><font color=yellow>Status</font></a></td>
   <td><b><font color=white>&nbsp;Last Event</td>
   <td><b>
     <a href=/?GO=GUI::Instr::explore&sort=DATE&host=$q->{host}><font color=yellow>Report-Date</font></a></td>
EOF


  my($gif, $details, $url);

  foreach $l (sort @LIST) {
     @a = split(/\t/, $l);
     $gif = $details = "";
     my($t, $k) = split(/:/, $a[6]);
   
     if ($a[5] > 0) {
        $gif = "<img src=/gif/$GIF[$a[5]] border=0>";
        $details = $DB{$a[6]}->[1];
     }

     $url = " <a href=/?GO=GUI::EventLog::display&$a[8]=1&filter1=$k&NOBACK=1"
            .  " target=tree>EventLog</a>";

     my $h = Util->shortHostname($a[1]);
     $out .= "<tr><td>&nbsp;$h<td>&nbsp;$a[2]<td>&nbsp;$a[3]".
    "<td nowrap><center>$a[4] | $url<td valign=middle><center>$gif&nbsp;<td><small>$details</small>&nbsp;<td><small>&nbsp;$a[7]";
  }

  $out .= "</table></table>&nbsp;</form>";

  print $out;
  print "<table border=0 bgcolor=white>
    <tr><td bgcolor=#666699><font color=yellow><u><b>Use yellow headers to sort column<tr><td>";
  my($x);
  for ($x=1; $x <= $#GIF; $x++) {
     $g = $GIF[$x];
     $g =~ /(.+) alt=(.*)/;
     print "<img src=/gif/$1>:$2 &nbsp;";
  }
  print "</table><p>&nbsp;";
}

sub explore1F {
  my($q, $port, $util) = @_;
  my($url) = "host=$q->{host}&file=$q->{file}";
  print "<frameset cols=50%,* border=0>
     <frame src=?GO=GUI::Instr::explore1&$url name=left0 scrolling=auto>
     <frame src=javascript:return() name=main2 scrolling=auto>
 </frameset>
  ";
}


sub explore1 {
  my($q, $port, $util) = @_;
  my($data, @a);
  print "\n";
  my($WIN) = "WIN=$q->{WIN}" if ($q->{WIN});
  
  print "<body bgcolor=#F0F0F0>";
  my($P) = System->get_home() . "/DATA/OLD_REPORTS";
  my($ip);
  my($renv) = System->get_renv();
  $q->{host} = "" if ($q->{host} eq $renv->{hostname});

  if ($q->{host}) {
    print "Calling $q->{host}...<br>\n";
    my($renv, $devs, $hosts, $notifs) = PDM::ConfigFile->read;
    foreach $h (@$hosts) {
      if ($h->{hostname} eq $q->{host} || $q->{host} eq $h->{ip}) {
        $ip = $h->{ip};
        last;
      }
    }
    if (!$ip) {
      print "No IP defined for $q->{host} in config file!";
      return;
    }
  }

  ($err, $VAR1) = Report->readNetReport({ host  => $ip,
                                  timeout  => 10,
                                  file     => $q->{file},
                                  wwn      => $q->{wwn},
                                  name     => $q->{name} });
     
  if ($err) {
    print "<b>$err</b><br>";
    return;
  }
  require Report;

  my($id) = $VAR1->id();
  $q->{file} = "$id->{category}:$id->{deviceName}";
  $pl = "<font color=white>[ <a href=/?GO=GUI::Instr::explore1&host=$q->{host}&file=$q->{file}&level=10><font color=white>Open</font></a>
   | <a href=/?GO=GUI::Instr::explore1&host=$q->{host}&file=$q->{file}&level=0><font color=white>Close</font></a> ] ";
  print "
<table border=1 cellpadding=2 cellspacing=0 width=100% bgcolor=white>
  <tr><td bgcolor=#666699><b>&nbsp;<font color=white>$id->{category} $id->{name}</td>
      <td bgcolor=#666699 align=right><b> $pl</td>
<tr><td colspan=2><font face=arial,helvetica>
  <table border=0><tr><td></table>
 ";

  $h = $VAR1->value();
  $tree =  Tree->new({target => 'main2',
                     this => "/?GO=GUI::Instr::explore1&file=$q->{file}&host=$q->{host}",
                           q => $q,
                      sysgif => '/gif',
                     linkall => 1,
                        name => "ROOT"});
  %X = ();
  foreach $k (sort keys %$h) {
    next if (substr($k,0,1) eq "_");
    $ix = rindex($k, ".");
    $k1 = substr($k, 0, $ix);
    $X{$k1} = 1;
  }
  my(@X) = ();
  print " <img src=/gif/menu_root.gif border=0 align=top>&nbsp;<a href=/?GO=GUI::Instr::explore2&file=$q->{file}&host=$q->{host} target=main2>$id->{category}:$id->{deviceName}</a><br>";

  foreach $k (sort keys %X) {
    $k2 = $k; $k2 =~ s/\./\//g;
    push(@X, [ $k2, "/?GO=GUI::Instr::explore2&file=$q->{file}&section=$k2&host=$q->{host}" ]);
  }
  print $tree->read(\@X);
  print "<br>&nbsp;</table></table>";
}


sub explore2 {
  my($q, $port, $util) = @_;
  my($local);
  require Report;

  my($P) = System->get_home() . "/DATA/OLD_REPORTS";

  print "\n<body bgcolor=#F0F0F0>";
  @a = split(/:/, $q->{file});
  $i = rindex($a[0],"/");
  $a[0] = substr($a[0],$i+1) if ($i) ;
  $title = "$a[0]:$a[1] $q->{section}";

  if ($q->{host}) { # remote file
     my($D2) = System->get_home() . "/DATA/remote";
     $data = Util->readf("$D2/$q->{file}");

#     $url = Util->makeUrl($q->{host}, "?GET=run_file&file=$q->{file}");
#     print "Retrieving data from $url...<br>";
#     $data = Util::Http->get($url, $main::TO);
     $local =0;
  } else {          # local file
     $data = Util->readf("$P/$q->{file}");
     $local =1;
  }
  if (substr($data,0,3) =~ /ER/) {
     print "$data<br>";
     return;
  }
  my($VAR1);
  eval $data;
  $h = $VAR1->value();
  my($id) = $VAR1->id();
  $section = $q->{section};

  $l = length($section);
  $section =~ s/\//./g;
  print "
<table border=0 cellpadding=2 cellspacing=0 width=100% bgcolor=white><tr><td bgcolor=black>
<table border=0 cellpadding=0 cellspacing=0 width=100% bgcolor=white>
  <tr><td colspan=2 bgcolor=#666699>&nbsp;<font color=white><b>$title</td>
<tr><td><pre>";
  $last = undef;
  foreach $k (sort keys %$h) {
    next if ($l && substr($k,0,$l) ne $section || substr($k,0,1) eq "_");
    $k0 = $k;
    $k0 = substr($k, $l+1) if ($l);
    $ix = index($k0,".");
    if ($ix > 0) {
      $v = substr($k0,0,$ix);
      if ($v ne $last) {
        print "<tr><td colspan=2>&nbsp;</td>" if (defined($last));
        $last = $v;
      }
    }
    $co = ($cnt++ % 2 == 0) ? "bgcolor=#F0F0F0" : "";
    
    print "<tr $co><td>&nbsp;";
    print "$k0</td><td>";
    print " = $h->{$k}</td>";
  }
  print "</table></table><center>";
  print "&nbsp;";


}

# NU
sub update {

  my($q, $port, $util) = @_;
  require Report;
  print "\n<body bgcolor=#F0F0F0>";
  @a = split(/:/, $q->{file});
  $i = rindex($a[0],"/");
  $a[0] = substr($a[0],$i+1) if ($i) ;
  $title = "$a[0]:$a[1] $q->{section}";
  if ($q->{ACTION} eq "Update") {
     open(O, System->get_home() ."/$q->{file}");
     open(W, ">" . System->get_home() . "/$q->{file}.new");  
     while ($l = <O> ) {
         chop($l);
         @a = split(/ *\= */, $l);
         if ($a[0] eq "$q->{section}.$q->{value}") {
            print W "$a[0]  = $q->{new}\n";
         } else {
            print W $l . "\n";
         }
     }
     close(O); close(W);
  }

  if ($q->{host}) { # remote file
     print "Retrieving data from $q->{host}...<br>";
     $url = Util->makeUrl($q->{host}, "?GET=run_file&file=$q->{file}");
     $data = Util::Http->get($url, $main::TO);
  } else {          # local file
     $data = Util->readf(System->get_home() ."/$q->{file}");
  }
  if (substr($data,0,3) =~ /ER/) {
    print "$data<br>";
    return;
  }
  my($r) = eval substr($data, 7);
  $h = $r->value();
  my($id) = $r->id();
  $section = $q->{section};

  $l = length($section);
  $section =~ s/\//./g;
  print "
<table border=0 cellpadding=2 cellspacing=0 width=100% bgcolor=white><tr><td bgcolor=black>
<table border=0 cellpadding=0 cellspacing=0 width=100% bgcolor=white>
 <form  method=get>
 <input type=hidden name=GO value=update>
 <input type=hidden name=section value=$q->{section}>
 <input type=hidden name=value value=$q->{value}>
  <tr><td colspan=2 bgcolor=#666699>&nbsp;<font color=white><b>$title</td>
<tr><td><pre>";
  $last = undef;
  foreach $k (sort keys %$h) {
    next if ($l && substr($k,0,$l) ne $section || substr($k,0,1) eq "_");
    $k0 = $k;
    next if (substr($k0, 0 - length($q->{value})) ne $q->{value});
    $k0 = substr($k, $l+1) if ($l);
    $ix = index($k0,".");

    print "<tr><td align=right><b>$k0: </td>
               <td><input type=text name=new value=\"$h->{$k}\"></td>";
  }
  print "</table></table><center><input type=submit name=ACTION value=Update>";
  print "</form>&nbsp;";
  
}


sub mon {
  my($type, $name) = @_;

  if (defined($D{$type}{$name})) {
    return ($D{$type}{$name}[0] eq "Y")? "<font color=green><b>On":"<font color=red><b>Off"
  } else {
    return "<font color=red><b>No";
  }
}


sub report {
  my($q) = @_;
  my($type, $wwn) = split(/:/, $q->{file});
  $file = $q->{file};
  $ip = $q->{host};

  if ($q->{host}) {
    print "Calling $q->{host}...<br>\n";
  }
  ($err, $VAR1) = Report->readNetReport({ host  => $ip,
                                  timeout  => 10,
                                  file     => $q->{file}
                                       });
  if ($err) {
    print "$err";
    return;
  }
  print "<body bgcolor=#E0E0E0><center>";

  $module = uc($type) . "Agent";
  eval "require \"Agent/$module.pm\"";

  if (!$@) {
    print $module->REPORT($q->{host}|| System->hostname(), $VAR1);
  }

}

sub dumpConfig {
  my($q) = @_;
  print "<body bgcolor=$main'BGCOLOR>";
  my($renv, $devs, $hosts, $notifs) = PDM::ConfigFile->read;

  if ($q->{ACTION}) {
     if ($q->{email_address} !~ /.+\@.+/) {
        print "<big><font color=red><b>Invalid Email Address!</font>";
     } else {
        &dumpConfig1($q);
        print "<font color=green size=+1><b>Configuration emailed to $q->{email_address}
</b></font>";
     }
  }
  print "<center>";
  opendir(O, System->get_home() . "/DATA/topo");
  my @dirs = readdir(O); closedir(O);
  my $checks = "";
  my $bg = "bgcolor=D0D0FF";
  my $ho = System->hostname();
  $checks .= "<tr><td align=right $bg>$ho:<td> <input type=radio name=radioHost value=$ho></td>";
  foreach $ho (@$hosts) {
    $checks .= "<tr><td align=right $bg>$ho->{hostname}:<td> <input type=radio name=radioHost value=$ho->{hostname}></td>";
  }

  print &main::header("Email Configuration", "80%"); 

  print "<table border=1 width=80%  cellspacing=0 cellpadding=3 bgcolor=white>
  <form><input type=hidden name=GO value=GUI::Instr::dumpConfig>
  <tr><td colspan=2>This function will email a detailed report of the Network Storage Agent configuration including a list of all devices being monitored, along with the last instrumentation report available on each host.</td>
  <tr bgcolor=#666699>
    <td colspan=2><font color=white><b>Email Network Storage Agent Configuration
  
  <tr><td align=right $bg>Email Address:</td>
      <td><input type=text size=60 name=email_address>
  <tr><td align=right $bg>Comments:</td>
      <td><input type=text size=60 name=info>
  <tr><td colspan=2 bgcolor=#666699><font color=white><b>Select Host Topology</td>
  $checks
  </table>
  <b><input type=submit name=ACTION value=EMAIL>
  </form>";

}

sub dumpConfig1 {
  my($q) = @_;
  my($renv, $devs, $hosts, $notifs) = PDM::ConfigFile->read;
  my($space) = "&nbsp;";
  my($out);
  my($today) = `/usr/bin/date`; # Util->today();
  my($master) = System->hostname();
  $q->{email} = 1;

  $out .= "<body bgcolor=#F0F0F0>
  <table border=0 cellspacing=0 width=100%><tr><td>
     <h2>Network Storage Agent Configuration on $renv->{customer}</h2></td>
     <td align=right><b>$renv->{hostname} - $renv->{version}<br>$today</table>
  <table border=1 cellspacing=0 cellpadding=2 width=100% bgcolor=white>
  <tr bgcolor=#666699><td colspan=2>
  <font color=white><big><b>Site Configuration 
  <tr><td>
  <table border=0 cellspacing=0 bgcolor=white>
    <tr><td align=right bgcolor=#E0E0E0>Name:</td>
        <td>&nbsp;$renv->{customer}</td>
    <tr><td align=right valign=top bgcolor=#E0E0E0>Address:</td>
        <td>&nbsp;$renv->{site_address}<br>
           &nbsp;$renv->{site_city} $renv->{site_state} $renv->{site_zip} $renv->{site_country}<br>
    <tr><td align=right bgcolor=#E0E0E0>Contact:</td>
        <td>&nbsp;$renv->{site_contact} $renv->{site_email}</td>
  </table>
  <td valign=top><table border=0 cellspacing=0>
    <tr><td align=right bgcolor=#E0E0E0>CustomerNo:</td>
        <td>&nbsp;$renv->{cust_no} &nbsp;Contract: $renv->{contract}</td>
    <tr><td align=right bgcolor=#E0E0E0>Host Selected:</td>
        <td>&nbsp;$q->{radioHost}</td>
    <tr><td align=right bgcolor=#E0E0E0>Admin:</td>
        <td>&nbsp;$renv->{site_email}</td>
    <tr><td align=right bgcolor=#E0E0E0>Polling:</td>
        <td>&nbsp;$renv->{frequency} mins.</td>
    </table>
  </table>
  ";
  my $b;
  $b = ($q->{radioHost} eq System->hostname())? "<b>":"";

  $out .= "$space<table border=1 cellspacing=0 cellpadding=2 width=100% bgcolor=white>
  <tr bgcolor=#666699>
  <td colspan=7><big><FONT color=white><b>Hosts Monitored (selected is bold)</td>
  <tr bgcolor=#E0E0E0>
     <th>Host
     <th>Hostid
     <th>IP
     <th>IPNO
     <th>Active
     <th>Freq(mins)
     <th>Categories
    ";

    $out .= "<tr><td>$b$master".
    "<td>$renv->{hostname}</td>".
    "<td>" . System->hostname() . "</td>".
    "<td>&nbsp;</td>".
    "<td><center>Y</td>".
    "<td><center>$renv->{frequency}</td>
    <td>$renv->{categories}&nbsp;</td>
     ";
  my(@L) ;
  foreach $h (@$hosts) {
    push(@L, "$h->{hostname}\t$h->{hostid}\t$h->{ip}\t$h->{ipno}\t$h->{active}\t$h->{frequency}\t$h->{categories}");
  }
  foreach $h (sort @L) {
    my(@a) = split(/\t/, $h);
    $b = ($a[0] eq $q->{radioHost}) ? "<b>":"";
    $out .= "<tr><td>$b$a[0]<td>$a[1]<td>$a[2]<td>$a[3]
    <td><center>$a[4]</td>
    <td><center>$a[5]</td>
    <td>$a[6]&nbsp;</td>
     ";
  }
  $out .= "</table><table border=0><tr><td></table>";


  my $F = System->get_home()  . "/DATA/topo/$q->{radioHost}";
  if (-f $F) {
      print "topology for $q->{radioHost}...<br>\n";
      $out .= "<table border=1 width=100% cellspacing=0  cellpadding=3 bgcolor=#666699>
         <tr><td><font color=white><b>Topology of Host $q->{radioHost}</table>";
          
      $out .= GUI::Graph::genApplet({topo => $q->{radioHost}, email => 1, height => 400,  zoom => 3});
  }

  $out .= "$space<table border=1 cellspacing=0 cellpadding=2 width=100% bgcolor=white>
  <tr bgcolor=#666699>
  <td colspan=7><big><FONT color=white><b>Devices Monitored (sorted by Host)</td>
  <tr bgcolor=#E0E0E0>
     <th>Host
     <th>Type
     <th>DeviceName
     <th>IP
     <th>Monitoring
    ";

  foreach $d (@$devs) {  # master devices
     next if ($d->{host} ne "");
     next if ($q->{radioHost} ne System->hostname());
     $out .= "<tr><td>$master<td>$d->{type}<td>$d->{name}<td>$d->{ip}&nbsp;<td>$d->{active}</td>";
  }

  foreach $h (sort @L) {
    my(@a) = split(/\t/, $h);
    next if ($q->{radioHost} ne $a[0]);
    foreach $d (@$devs) {
        next if ($d->{host} ne $a[0]);
        $out .= "<tr><td>$a[0]<td>$d->{type}<td>$d->{name}<td>$d->{ip}&nbsp;<td>$d->{active}</td>";
    }
  }
  $out .= "</table>";

  $out .= "$space<table border=1 cellspacing=0 cellpadding=2 width=100% bgcolor=white>
  <tr bgcolor=#666699>
  <td><big><FONT color=white><b>Instrumentation Reports from " . System->hostname() .
   "</td></table>";
  print "Reading<br> "; 

   if ($q->{radioHost} eq System->hostname()) {
     my($D) = System->get_home() . "/DATA/OLD_REPORTS";
     opendir(O, $D);
     @a = readdir(O); closedir(O);
     $found= 0;
     foreach $file (@a) {
        next if ($file !~ /.+:.+/);
        $found++;
        print "$file<br>\n";
        @b = split(/:/, $file);
        $date    =  Util->get_file_created("$D/$file");
        my($type) = $b[0];
        my $name = Catalog->deviceRead("", Catalog::Key, $b[1], Catalog::Name);
  
        ($err, $VAR1) = Report->readNetReport({host  => "",
                                            timeout  => 10,
                                            file     => $file,
                                         });
        $out .= "$err" if ($err);
        $module = uc($type) . "Agent";
        eval "require \"Agent/$module.pm\"";
        if ($module->can("REPORT")) {
          $out .= $module->REPORT($master, $VAR1);
            $out .= "&nbsp;";
        }
         
     }
  }

  $D = System->get_home() . "/DATA/REMOTE_LISTS";
  opendir(O, $D);
  @fs = readdir(O); closedir(O);
  $cnt=0;
  foreach $f (@fs) {
    next if (substr($f,0,1) eq ".");
    next if ($f ne $q->{radioHost});
    open(O, "$D/$f");
    $host = $f;
    $out .= "&nbsp;<p><table border=1 cellspacing=0 width=100% bgcolor=white>
       <tr bgcolor=#666699><td><font color=white><big><b>Instrumentation Reports from $host</td></table>";
    while ($l = <O>) {
      my($file_1, $date_1, $acces_1, $name_1) = split(/=/, $l);
      my($type, $xxx) =   split(/:/, $file_1);
      next if (!$xxx);
      print "$file_1, ";
      print "<br>\n" if ($cnt++ % 2 == 0);
    
      ($err, $VAR1) = Report->readNetReport({host  => $host,
                                          timeout  => 10,
                                          file     => $file_1,
                                       });
      if ($err) {
        $out .= "$err";
      } else {
        $module = uc($type) . "Agent";
        eval "require \"Agent/$module.pm\"";
        if ($module->can("REPORT")) {
          $out .= $module->REPORT($host, $VAR1);
          $out .= "&nbsp;";
        }
      }
    }
  }
  print "<br>\n";

  my($hostname) = System->hostname();
  my($email) = Util->email_html("Network Storage Agent", 
                  "Network Storage Agent Configuration at $renv->{customer}", 
                  $q->{email_address},
                  "Email from Network Storage Agent on $master.
$q->{info}
Click on the attachment to see '$q->{radioHost}' Configuration on: 

  Customer: $renv->{customer} ($renv->{ticker})
  Address : $renv->{site_address}   
  City    : $renv->{site_city} $renv->{site_state} $renv->{site_zip}
  Country : $renv->{site_country} 
  Contact : $renv->{site_contact} $renv->{site_email}
 ",
                  "rasconfig.html",
                  $out, "html");
  
  open(O, ">/tmp/xx"); print O $email ; close(O);
  my($mailer) = $renv->{mailer};
  open(O,"|$mailer $q->{email_address}");
  print O $email;
  close(O);
}
  

sub readR {
  my($file) = @_;
  my(@a, $v);
  open(O, System->get_home() . "/DATA/OLD_REPORTS/$file");

  @a = <O>; close(O);

  $l = '$v = ' . substr("@a",7);
  eval $l;
  return $v;
}


1;
 

1;
