package GUI::Review;
use System;
use GUI::Hosts;
use Util;
#  $Id: Review.pm,v 1.15 2001/08/23 00:24:23 ccadieux Exp $


sub run {
  my($q, $post) = @_;

  ($renv, $dev, $hosts,$notifs) = PDM::ConfigFile->read;
  my($h)  = 
    &main'header("Configuration Error/Warning Report" , "90%","","reviewconfig");

  print "<body bgcolor=$main'BGCOLOR><center>$h";
  $info = "";

  print "<table border=1 cellspacing=0 cellpadding=3 width=90% bgcolor=white><tr bgcolor=$main'LIGHT>
   <th>No</td><td><b>Details</td>
  ";
  $cnt= 0;
  if (!$renv->{customer} || ($renv->{customer} =~ /Enter/) ||
      !$renv->{site_name} || !$renv->{site_city} || !$renv->{site_zip} ||
      !$renv->{site_country} ) {
     $cnt++;
     print "<tr><td>$cnt</td><td><b>Error: All mandatory fields of the Master configuration must be entered. Go to <a href=/?GO=GUI::Config::upd>[Maintain Hosts]</a>.</td>";
  }

  if (!$renv->{categories} || $renv->{categories} eq "message") {
     $cnt++;
     print "<tr><td>$cnt</td><td><b>Error: No device Categories were selected in <a href=/?GO=GUI::Config::upd>[Maintain Hosts]</a>.</td>";
  }

  $local_active = (-f System->get_home() . "/DATA/start")? "Y":"N";

  if ($local_active eq "N") {
     $cnt++;
     print "<tr><td>$cnt</td><td><b>Warning: Master Agent is not active, activate in  <a href=/?GO=GUI::Start::Agents>[Start/Stop Agents]</a> .</td>";
  }

#
# CHECK IF SLAVES CONFIG WERE PUSHED
#
  $CAT{H} = $renv->{categories};

  for ($x0 = 0; $x0 <= $#$hosts; $x0++) {
    $h = $hosts->[$x0];
    $CAT{"H" . $h->{hostname}} = $h->{categories};

    if (!$h->{categories} || ($h->{categories} eq "message") ) {
      $cnt++;
      print "<tr><td>$cnt</td><td><b>Error : No storage categories selected on slave $h->{hostname}. Execute <a href=/?GO=GUI::Hosts::upd&no=$x0>Update Slave</a> to fix.</td>";
    }
    if (!$h->{last_push}) {
      $cnt++;
      print "<tr><td>$cnt</td><td><b>Error : The configuration of slave $h->{hostname} needs to be updated, Execute <a href=/?GO=pushSlaves>Push Slaves</a> to update Slaves.</td>";
    }
    if ($h->{active} eq "N") {
      $cnt++;
      print "<tr><td>$cnt</td><td><b>Warning : Slave Host $h->{hostname} is not active, activate it at <a href=/?GO=GUI::Start::Agents>Start/Stop Agents</a></td>";
    }

    my $url = Util->makeUrl($h->{hostname}, "?GET=Util::checkRasCrons");
    $rc = Util::Http->get($url, 20);
    if ($rc =~ /ERROR/) {
      $cnt++;
      print "<tr><td>$cnt</td><td><b>On $h->{hostname}:</b> $rc</td>";
    }
 
  }


  $active = 0; $found = 0;

  for ($x0 = 0; $x0 <= $#$dev; $x0++) {
     $h = $dev->[$x0];
     if (!$h->{host} && !defined($CAT{"H" . $h->{host}})) {
        $cnt++;
        print "<tr><td>$cnt</td><td><b>Warning: Host $h->{host} not found. Attach <a href=/?GO=GUIAdmin::A5K::updDevice&no=$x0>device $h->{name}</a> to a valid host.</td>";
     }
     if (index($CAT{"H" . $h->{host}}, $h->{type}) < 0) {
        $cnt++;
        $hh = $h->{host} || System->hostname();
        print "<tr><td>$cnt</td><td><b>Warning: There is no category in '$hh' selected in 'Maintain Host' for this $h->{type} device: $h->{name}. Change the categories in <a href=/?GO=GUI::Hosts::list>Maintain Hosts</a>.</td>";
     }
         
     $found++;
     if ($h->{active} eq "Y") {
        $active++;
     }
  }
  if (!$active) {
     $cnt++;
     print "<tr><td>$cnt</td><td><b>Warning: No device has been entered or activated for monitoring, go to <a href=/?GO=GUI::Start::Devices>[Start/Stop Devices]</a> to active devices .</td>";
  }

  if ($found != $active) {
     $cnt++;
     print "<tr><td>$cnt</td><td><b>Warning: Some of the devices that were entered for monitoring are inactive, go to <a href=/?GO=GUI::Start::Devices>[Start/Stop Devices]</a> if you need to activate all your devices.</td>";
  }
 
  $active = 0;
  opendir(O, System->get_home() . "/lib/Provider");
  @list = readdir(O); closedir(O);

  foreach $x (@list) {
    next if ($x !~ /Provider.pm$/);
    $name = substr(lc($x), 0 , -11);
    $active = 1 if ($renv->{"pro.$name.active"} eq "Y");
  }

  if (!$active) {
     $cnt++;
     print "<tr><td>$cnt</td><td><b>Warning: No Provider has been activated, go to <a href=/?GO=GUI::Providers::display>[Providers]</a> to activate a provider. Providers are external recipients for  Network Storage Agent events.</td>";
  }

  if ($#$notifs < 0) {
     $cnt++;
     print "<tr><td>$cnt</td><td><b>Warning: No Email address has been entered for Local notification, go to <a href=/?GO=GUI::Notifs::list>[Notification]</a> to enter a local notification email.</td>";
  }

  $out = Util->checkRasCrons();

  if ($out) {
     $cnt++ if ($out =~ /ERROR:/);
     print "<tr><td>$cnt<td><b>On Master:<b> $out</td>";
  }


  my $netc = `/usr/bin/pkginfo SUNWncon`;
  if ($netc  && $renv->{pro.netconnect.active} ne "Y") {
     $cnt++;
     print "<tr><td>$cnt</td><td><b>Warning: The NetConnect Package is installed but NetConnect has not been activated in the Network Storage Agent. Go to <a href=/?GO=GUI::Providers::display>Provider Maintenance</a> to activate NetConnect.</td>";
  }

  if ($cnt == 0) {
     print "<tr><td colspan=2>&nbsp;<br><center><font color=green><h2>No error(s) to report at this time.<br>&nbsp;</td>";
  }
     


  print "</table>";
}

1;
 
