package GUI::SAN;

use Util;
use System;
use strict "vars";
use PDM::Modules;
use Util::Http;
use PDM::ConfigFile;
use PDM::Thresholds;
use Data::Dumper;
use TO;
use FC;
use WebTabs;
use FCConfig::Python;

sub healthck {
  my($q) = @_;
  my($hostname, $mach, $h, $x);
  
  $mach = Util->select_hosts("GUI::SAN::healthck");
  $hostname = System->hostname();

  $h = &main::header("Fibre Channel Counters Check (on $hostname)", "95%", $mach);
  $x = &main::read_file("san_health");
  print "<body bgcolor=$main'BGCOLOR><center> $h";

  print "<table border=0 width=90% cellspacing=0 cellpadding=6 
     bgcolor=white><tr><td>$x</table>";
  my $con = Util->stor_conflicts();
  if ($con) {
    print "&nbsp;<br>";
    print &main::info("Stortools program '$con' is currently running,
      <br>come back to this function when '$con' ends.");
  } else {
    print "<form><input type=hidden name=GO value=GUI::SAN::start_hck>
    <b><input type=submit name=ACTION value=\"START FC Check\">
    </form>";
  }
}

sub start_hck {
  my($q) = @_;
  
  my($renv, $devs, $hosts,$notifs) = PDM::ConfigFile->read;

  my($cat) = $renv->{categories}; # verify if agent is active (todo)

  my(@agents) = PDM::Modules->load("Agent");
  my($cache) = 0;
  my(@PASS);
  my(@INFO);
  my($pno, @o1);
  my($errors) = 0;
  my($pass1file) = System->get_home() . "/DATA/tmp/save_pass1";
  my($pass) = $q->{pass} || 1;
  print "<body bgcolor=#E0E0E0><pre>\n\n<b>Running pass $pass/2 ...</b>\n\n";

  my($report) = {};

  foreach my $agent (sort @agents) {
    if ($agent->can("FCCounters")) {
       print "  --> Running $agent->FCCounters\n";
       $report->{time} = time;
       $report->{$agent}  = $agent->FCCounters({cache => $cache});
    }
  }
  my($url, @a, $pass1, $pass2, $VAR1, $data1, $data2, $diff, $i, $x, $counterType, $h, $mach);
  my($WAIT) = 2; # min

  if ($pass == 1) {
     open(O, ">$pass1file");
     $Data::Dumper::Indent = 1;
     print O Dumper($report);
     close(O);
     $WAIT = $WAIT * 60;
     print "\n<b>Waiting $WAIT seconds before pass 2 ...</b>\n";
     $url = "/?GO=GUI::SAN::start_hck&pass=2";
     print "<meta http-equiv=Refresh content=\"$WAIT;URL=$url\">";
     return;
  }

# PASS 2

  open(O, $pass1file);
  @a = <O>; close(O);
  eval "@a";
  $pass1 = $VAR1;
  $pass2 = $report;
  if (0) {
    print Dumper($pass1) . "\n";
    print Dumper($pass2) . "\n";
  }
  my($th) = PDM::Thresholds->new;
  $th->init;
  print "<b>Analyzing...</b>\n</pre>";

# th1 =  [ 100, '1m', '0m', 'E', 'Too many InvalidTxWords' , 'comments'];

  my($out) .= "<table border=1 cellspacing=0 cellpadding=1 bgcolor=white width=99%>
   <tr><td bgcolor=#666699 colspan=9><font color=white><b>FC Check Conclusions
   <tr bgcolor=$main'LIGHT>
      <td><b>#
      <td><b>Type
      <td><b>Name
      <td><b>WWN
      <td><b>Component
      <td><b>FCC
      <td><b>+Inc.
      <td><b>Threshold
      <td><b>Description
   ";
  

  my($th1);
  my(%T) = ();
  foreach my $k (keys %$pass2) {
     next if ($k eq "time");
     $data1 = $pass1->{$k}{data};
     $data2 = $pass2->{$k}{data};
     $diff = 0;
     foreach $i (keys %$data2) {
        next if (!$data1->{$i});
        if ($data1->{$i} ne $data2->{$i}) {
           $diff = 1;
           my($hba,$wwn,$comp, $type) = split(/\|/, $i);
           my(@c1) = split(/\t/, $data1->{$i});  # old counters
           my(@c2) = split(/\t/, $data2->{$i});
           for ($x=0; $x <= $#c2; $x++) {
               if ($c2[$x] > $c1[$x]) {
                  $diff = $c2[$x] - $c1[$x];
                  $counterType = $FC::Counters[$x];
#print "$i $diff, $counterType<br>";
                  if (($th1 = $th->exist("health-$type", $counterType))) {
                      my($x) = $diff * $th1->[1] / $WAIT;
                      if ($x >= $th1->[0]) {
                         my($min) = $th1->[1];
                         $min =~ s/m/mins/;
                         my($agent) = substr($k, 0, -5);
                         my($name) = $pass2->{$k}{enc}{$wwn};
                         $errors++;
                         $out .= "<tr bgcolor=#F0F0F0><td>$errors<td>$agent<td>$name<td>$wwn<td>$comp<td>$counterType<td>$diff<td>$th1->[0] in $min<td>$th1->[4]<tr><td colspan=5>&nbsp;<td colspan=5>$th1->[5]</tr>";
                      }
                  }
               }
           }
        }
     }
  }
  $out .= "<tr><td colspan=9><b>No Link-Status related Errors Found !" if (!$errors);
  $out .= "</table>";
  print $out;

  print  "<table border=0 cellspacing=1 cellpadding=2 bgcolor=white>";
  if ($errors) {
    print "&nbsp;<p>&nbsp;<p>";
    print "<tr><td bgcolor=$main'LIGHT colspan=5><b>FC Counters";
    for ($x=0; $x <= $#FC::Counters; $x+=2) {
      print "<tr><td>$FC::Counters[$x]<td>$FC::Description[$x]<td bgcolor=#E0E0E0>&nbsp;
     <td>" . $FC::Counters[$x+1]. "<td>". $FC::Description[$x+1];
    }
    print "</table>";
  } else {
    my($text) = &main::read_file("san_health_pass");
    print "&nbsp;<center><p><table border=1 cellspacing=0 cellpadding=4 width=90% bgcolor=white><tr><td>$text</table>";
  }
  
 
}

# 'SWITCHAgent' => {
#    'data' => {
#      '|100000c0dd00885d|port.002|switch' => '0 0  0  0  0  141  63  1010',
#    },
#    'enc' => {
#      '100000c0dd008849' => 'python_switch',
#      '100000c0dd00885d' => 'switch-diag196',
#    },



sub merge_topo {
  my($q) = @_;
  my($l);
  my($mach);
  my($F) = System->get_home() . "/DATA/topo_merge";
  my($err);
  my($renv) = System->get_renv();
  my($h) = &main::header("SAN Merge Topologies", "90%", $mach);
  print "<body bgcolor=$main'BGCOLOR><center> $h";

  my($x) = &main::read_file("san_merge");
  print "<table border=1 width=90% cellspacing=0 cellpadding=4 
     bgcolor=white><tr><td>$x</table>";

  if ($q->{ACTION} =~ "Delete") {
    my($dels);
    foreach my $x (keys %$q) {
       if (substr($x, 0, 4) eq "del_") {
          $dels .= substr($x,4) . ",";
       }
    }
    open(O, $F);
    my(@a) = <O>; close(O);
    open(W, ">$F");
    foreach my $m (@a) {
       my(@b) = split(/\|/, $m);
       if (index(",$dels" , "$b[0],") < 0) {
           print W $m;
       }
    }
    close(W);
    $err = &main::info("Topology '$dels' deleted", "green");

  } elsif ($q->{ACTION} eq "Create") {
    while (1) {
     if ($q->{merge}) {
        $q->{merge} =~ s/ /_/g;
        open(O, $F);
        my(@a) = <O>; close(O);
        foreach my $m (@a) {
          chop($m);
          my(@b) = split(/\|/, $m);
          if ($b[0] eq $q->{merge}) {
             $err = &main::info("Err: Topology '$q->{merge}' already exist!");
             last;
          }
        }
        last if ($err);
        my($members);
        my($cnt);
        foreach my $x (keys %$q) {
           if (substr($x, 0, 4) eq "sel_") {
              $members .= substr($x,4) . "\t";
              $cnt++;
           }
        }
        open(O, ">>$F");
        my($today) = Util->get_today();
        print O "$q->{merge}|$today|$members\n";
        close(O);
        $err = &main::info("Topology '$q->{merge}' added", "green");
        last;       
     } else {
        $err = &main::info("Err: New Topo name must be selected to create a new topology");
        last;
     }
    }
  }
  open(O, $F);
  my(@a) = <O>; close(O);

  print "
 $err
 <table border=1 cellspacing=0 width=90% bgcolor=white>
 <form><input type=hidden name=GO value=GUI::SAN::merge_topo>
 <tr><td bgcolor=#666699 colspan=4><table border=0><tr><td>
    <font color=white><b>Combined topologies</table></td>
 <tr bgcolor=#E0E0E0>
     <th width=10%>Delete
     <th width=30%>SanName
     <th>Created
     <th>Components
    ";

  my($cnt) = 0;
  foreach my $m (sort @a) {
    chop($m);
    my(@b) = split(/\|/, $m);
    $b[2] =~ s/\t/, /g;
    my($toponame) = $b[0];
    print "<tr>
   <td><center><input type=checkbox name=del_$b[0]></td>
   <td width=30%>&nbsp;$toponame
   <td>&nbsp;$b[1]
   <td>$b[2]
    ";
    $cnt++;
  }
  if (!$cnt) {
    print "<tr><td colspan=4><b>No Merged Topology available.</table>";
 
  } else {
    print "</table><b>
    <table border=1 cellspacing=0 cellpadding=0 width=90%><tr><td><b>
     <input type=submit name=ACTION value=\"Delete Selected\">
    </table>
     ";
  }
  print "&nbsp;";

  my($renv, $devs, $hosts,$notifs) = PDM::ConfigFile->read;

  print "</table>
  &nbsp;
  <table border=1 cellspacing=0 width=90% bgcolor=white>
  <tr><td colspan=3 bgcolor=#666699>
    <table border=0><tr><td><font color=white><b>Available Topologies</table></td>
  <tr bgcolor=#E0E0E0>
     <th width=10%>Select
     <th >HostName
     <th >Created
      ";


  my($cnt) =0;

  my $D2 =  System->get_home() . "/DATA/topo";
  opendir(O, $D2);
  my(@topos) = readdir(O); closedir(O);
  foreach my $h (@topos) {
     next if (substr($h,0,1) eq "." || substr($h,0,6) eq "MERGE-");
     my($name) = $h;
     my $created = Util->get_file_created("$D2/$h");
     print "<tr>";
     print "<td ><center><input type=checkbox name=sel_$name>
            <td >&nbsp;$name</td>
            <td >&nbsp;$created</td>
            ";
     $cnt++;
  }

  print "</table>
  <table border=1 cellspacing=0 cellpadding=0 width=90%><b>
  <tr><td colspan=3>
   <table border=0 cellspacing=0 cellpadding=0 width=95%><tr>
   <td align=right><b>Select Slaves and enter a name for this new topology:</td>
   <td><input type=text name=merge size=20></td>
   <td><b><input type=submit name=ACTION value=Create></td>
   </table>
  </table>
  </form>";
  
}
#   <td><b>&nbsp;Show all devices:<input type=checkbox name=allports></td>

sub topoClear {
  my($q) = @_;
  my($mach);

  my($renv, $devs, $hosts,$notifs) = PDM::ConfigFile->read;

  my($h) = &main::header("Clear Topologies", "80%", $mach);
  print "<body bgcolor=$main'BGCOLOR><center> $h";

  my($x) = &main::read_file("san_discover");
  print "<table border=1 width=80% cellspacing=0 cellpadding=4 
     bgcolor=white><tr><td>$x</table>";

  if ($q->{ACTION} =~ /Clear/) {
     my($renv, $devs, $hosts,$notifs) = PDM::ConfigFile->read;
     foreach my $k (keys %$q) {
        next if (substr($k,0,4) ne "del_");
        if ($k eq "del_LOCAL") {
           unlink System->get_home() . "/DATA/topo/$renv->{hostname}";
           print "<font color=red>$renv->{hostname} Topology cleared.</font><br>";
        } else {
           my $host = substr($k,4);
           my $url =  Util->makeUrl($host, "?GET=DELET&file=topo/$host");
           Util::Http->get($url, 20);
           unlink System->get_home() . "/DATA/topo/$host";
           print "<font color=red>$host Topology cleared.</font><br>";
        }
     }
     unlink(System->get_home() . "/DATA/tmp/topoindex");
  }
  my $TD = System->get_home() . "/DATA/topo/";
  my($created) = Util->get_file_created($TD . $renv->{hostname});
  print <<EOF;
<table border=1 bgcolor=white width=80% cellspacing=0>
<form><input type=hidden name=GO value=GUI::SAN::topoClear>
<tr bgcolor=#666699><td colspan=3><b><font color=white>Select Topology
<tr bgcolor=#E0E0E0>
    <th width=10%>Clear
    <th>Topology
    <th>Last Update
<tr><td><center><input type=checkbox name=del_LOCAL>
    <td>&nbsp;$renv->{hostname} (Local)
    <td>&nbsp;$created
EOF
  my %DONE;
  $DONE{$renv->{hostname}} = 1;
  foreach my $h (@$hosts) {
     $created = Util->get_file_created($TD . $h->{hostname});
     print "<tr><td width=10%><center><input type=checkbox name=del_$h->{hostname}></td>
     <td>&nbsp;$h->{hostname}
     <td>&nbsp;$created";
     $DONE{$h->{hostname}} = 1;
  }
  opendir(O, $TD);
  my @topos = readdir(O); closedir(O);
  foreach my $t (@topos) {
     next if (substr($t,0,1) eq "." || substr($t,0,6) eq "MERGE-");
     next if ($DONE{$t});
     $created = Util->get_file_created("$TD/$t");
     print "<tr><td width=10%><center><input type=checkbox name=del_$t></td>
     <td>&nbsp;$t <font color=red>(Warning: No corresponding Slave-Agent)<td>&nbsp;$created";
  }



  print "</table><br>
   <b><input type=submit name=ACTION value=\"Clear Selected Topology\">
    </form>";

}

sub print_topo {
  my($q) = @_;

  my($to) = TO->readTopo();
  print "<table border=1 width=90% cellspacing=0 cellpadding=4 bgcolor=white><tr><td><pre>";
  print $to->toString();
  print "</table>";
}


sub utilities {
  my($q) = @_;
  my($h);

  if ($q->{login} eq "san") {

     print <<EOF;
<frameset cols=140,* border=0>
     <frame src=/fcutil.html name=fctop scrolling=no>
     <frame src=/fcutil_welcome.html name=detail scrolling=auto>
 </frameset>
EOF

     return;
  }
  my($mach);
  $h = &main::header("SAN Utilities", "90%", $mach,'fcutil');
  my($x) = &main::read_file("san_utilities_login");
     
  print "<body bgcolor=$main'BGCOLOR><center> $h 
  <table border=1 width=90% cellspacing=0 cellpadding=4 
     bgcolor=white><tr><td>$x</table>";

  print <<EOF;
<form target=_parent><input type=hidden name=GO value=GUI::SAN::utilities>
  <table border=1  cellspacing=0 cellpadding=0 width=50% bgcolor=white><tr><td>
  <table border=0  width=100% bgcolor=white>
    <tr><td align=right bgcolor=#666699>
        <b><font color=white>Enter the SAN Password: </td>
        <td>
           <input type=password name=login size=12>
  </table>
  </table>
  <b><input type=submit name=ACTION value=LOGIN>
EOF

}

# name:type:ip

sub findSelected {
  my($q) = @_;
  my($RF) =  System->get_home() . "/DATA/tmp/reallist";
  my(@A, @S, @T, $l, @a);

  open(O, $RF);
  while ($l = <O>) {
      chop($l);
      @a = split(/:/, $l);
      if ($a[1] eq "s") {
        push(@S, "$a[0]:$a[2]");
      } elsif ($a[1] eq "a") {
        push(@A, $a[0]);
      } elsif ($a[1] eq "t") {
        push(@T, $a[2]);
      }
  }
  close(O);
  return (\@A, \@S, \@T);
}




sub real_list {
  my($q) = @_;
  my($F) =  System->get_home() . "/DATA/tmp/reallist";
  print "<body bgcolor=#E0E0E0><center>";

  my $mach = Util->select_hosts("GUI::SAN::real_list");
  my $hostname = System->hostname();
  print &main::header("List (on $hostname)", "90%", $mach);
  


  my($x, $name, $l, @a, $cnt, $ck, $type);
  if ($q->{ACTION} eq "Update") {
     open(O,">$F");
     foreach $x (keys %$q) {
       if (substr($x,0,3) eq "ck_") {
          $name = substr($x,3);
          print O "$name\n";
       }
     }
     close(O);
     print "<b>List Updated.</b>";
  }
  my($renv, $dev, $host,$notifs) = PDM::ConfigFile->read;

  print "<center>
 <form>
 <table border=0 bgcolor=white width=95% cellpadding=4><tr><td>
    Check the devices that you want to display in the Graph and Data Section of this page.
 </table>
  <table border=0><tr><td></table>
  <table border=1 cellspacing=0 bgcolor=white width=95%>
   <input type=hidden name=GO value=GUI::SAN::real_list>
   <input type=hidden name=option value=1>
  <tr bgcolor=#666699>
      <th width=1%><center><font color=white>Select
      <th><font color=white>Device
      <th><font color=white>Adddress
      <td> </td>
      <th width=1%><center><font color=white>Select
      <th><font color=white>Device
      <th><font color=white>Adddress
  ";
  my(%DEV);
  open(O, $F);
  while ($l = <O>) {
    chop($l);
    @a = split(/:/, $l);
    $DEV{$a[0]} = 1;
  }
  close(O);
  $cnt= 0;
  my %EX;
  foreach my $d (@$dev) {
     if ($d->{type} eq "switch" || $d->{type} eq "a5k" || $d->{type} eq "t3") {
        next if ($EX{$d->{type} . $d->{name}});
        $EX{$d->{type} . $d->{name}} = 1;
        print "<tr>" if ($cnt % 2 == 0);
        $ck = ($DEV{$d->{name}})? "checked":"";
        $type = substr($d->{type},0,1);
        print "<td><center><input type=checkbox name=\"ck_$d->{name}:$type:$d->{ip}\" $ck>
             <td>" . substr($d->{type},0,2) . "-$d->{name}</td>
             <td>&nbsp;$d->{ip}</td>
             ";
        print "<td>" if ($cnt % 2 == 0);
        $cnt++;
     }
  }
  print "<form></table>";
  print "<b><input type=submit name=ACTION value=Update><br>\n";
}




sub verify {
  my($q) = @_;

  my($l);
  my($mach);
  my($F) = System->get_home() . "/DATA/topo_merge";
  my($err);
  my($renv) = System->get_renv();

  if ($q->{ACTION} =~ /Verify/) {
     my($h) = &main::header("Verify Topology: $q->{method}", "90%", $mach, 'fcutil');
     print "<body bgcolor=#E0E0E0><center> $h";
     &run_verify($q);
     return;
  }
  my($h) = &main::header("Verify Topologies", "90%", $mach, 'fcutil');
  print "<body bgcolor=#E0E0E0><center> $h";

  my($x) = &main::read_file("san_verify");
  print "<table border=1 width=90% cellspacing=0 cellpadding=4 
        bgcolor=white><tr><td>$x</table>";
 

  my($renv, $devs, $hosts,$notifs) = PDM::ConfigFile->read;

  print "</table>
  &nbsp;
  <table border=1 cellspacing=0 width=90% bgcolor=white>
  <form><input type=hidden name=GO value=GUI::SAN::verify>
  <tr><td colspan=2 bgcolor=#666699>
    <table border=0><tr><td><font color=white><b>Select Method and Topology(s)</table></td>
  <tr bgcolor=white><td colspan=2>
   <table border=0 cellspacing=0 cellpadding=0 width=100%>
    <tr><td>
      <b>&nbsp;Verification Method:</b> <select name=method><option value=Python>Python Configuration</select>
    <td>&nbsp;</td>
    <td><b>ReDiscover Topology (slow): <input type=checkbox name=discover>
   </table>
  <tr bgcolor=#E0E0E0>
     <th>Topology
     <th>Model
      ";

  my($cnt) =0;

  my $D2 =  System->get_home() . "/DATA/topo";
  opendir(O, $D2);
  my(@topos) = readdir(O); closedir(O);
  my $cnt = 0;
  foreach my $h (@topos) {
     next if (substr($h,0,1) eq "." || substr($h,0,6) eq "MERGE-");
     my($name) = $h;
     my $created = Util->get_file_created("$D2/$h");
     my $to = TO->readTopo($name);
     my $if = $to->[0]{"host:$name"}{info};
    
     my $cnt0 = $cnt+1;
     print "<tr><td >&nbsp;$cnt0&nbsp;<big><input type=radio name=host value=$h>
             </big><b>&nbsp;$name</td>
             <td>$if->{model} $if->{release} &nbsp;
            ";
     $cnt++;
  }

  if ($cnt == 0) { 
    print "<tr><td colspan=2 bgcolor=white>
        &nbsp;<br>&nbsp;<b><font color=red>No Topology available for verification: wait for rasagent to run at least once.<br>&nbsp;</td>";
  }
  print "</table>
  <table border=1 cellspacing=0 cellpadding=0 width=90%><b>
   <input type=submit name=ACTION value=\"Verify Selected Topologies\">
  </table>
  </form>";
  
}

sub run_verify {
  my($q) = @_;
  my($disco);
  print "<table border=0 cellpadding=3 width=90% bgcolor=white><tr><td>
  Warning: Verification is not completely automated. Rules that are marked 
  'Manual' must be verified manually by the administrator.</table>";

  my $rt = "<table border=0 cellpadding=2 cellspacing=0 width=90% bgcolor=white><tr><td></td>";
  my $method = $q->{method};
  my $host   = $q->{host};

  if ($q->{discover}) {
       print "Discovering $host...<br>\n";
       my $to = TO->getNewTopo($host,120); # local or remote (store locally)
       my $sws = $to->switchList();
       my $sts = $to->storageList();
       $disco = "Rediscovered: " . ($#$sws+1) . " switches, " . ($#$sts+1) ." storage(s).<br>";
  }
  my $f = "FCConfig::${method}::run";

  my $out = &$f($host, $disco);

  $rt .= "<tr><td> $out</td>
  <tr><td>&nbsp;</td><tr><td></td><tr><td></td>";

  print "$rt</table>&nbsp;<p>&nbsp;";
}

1;
