package GUI::SWITCHUtil;

use Util;
use GUI::SAN;
use System;
use Data::Dumper;
use Agent::SWITCHAgent;

sub get_list {
  my($q, $sw) = @_;


  my($list);
  my($renv, $devs, $hosts,$notifs) = PDM::ConfigFile->read;
  my($first);
  my($allSW) = "<select name=SW>";
  $q->{SW} = "*List" if (!$q->{SW});
  $allSW .= ($q->{SW} eq "*List") ? "<option selected>*List": "<option>*List";
  
  my %E;
  foreach $d (@$devs) {
     if ($d->{type} eq "switch") {
       next if ($E{$d->{name}});
       $E{$d->{name}} = 1;
       $first  = "$d->{name}" if (!$first);
       $allSW .= ($d->{name} eq $q->{SW})? 
            "<option selected value=$d->{name}>$d->{name}":
            "<option value=$d->{name}>$d->{name}";
     }
  }
  $allSW .= "</select>";
  my($list, $p);
  if ($q->{SW} eq "*List" || !$q->{SW}) {
     foreach $xx (@$sw) {
        @vv = split(/:/, $xx);
        $list .= "$vv[0],";
     }
     chop($list) if ($list);
  } else {
    $ip = $q->{SW} if ($q->{SW} && $q->{SW} ne "*List") ;
    $list = $ip;
  }

  return ($allSW, $list, $ip);
}


sub fc_graph {
  my($q) = @_;
  my(%D, $applet, $x, $summ, @X, $xvalues, $reset);

  print "<body bgcolor=#E0E0E0><center>";
  if ($q->{auto} > 0) {
    $q->{auto} = 2 if ($q->{auto} < 2);
    my $url = "/?GO=GUI::SWITCHUtil::fc_graph";
    foreach my $x (keys %$q) {
      next if ($x eq "GO");
      $url .= "&$x=$q->{$x}";
    }
    print "<meta http-equiv=Refresh content=\"$q->{auto};URL=$url\">";
  }

  my $mach ; # = Util->select_hosts("GUI::SWITCHUtil::fc_graph");
  my $hostname = System->shortHostname();
  print &main::header("SWITCH FC Graph ", "95%", $mach, "fcutil");

  my($a5, $sw, $t3) = GUI::SAN::findSelected();
  my($debug) = 0;
  my($cache) = 0;

  if ($q->{ACTION} eq "ClearCache") {
    $cache = 2 ; $debug = 1;
  }
  my($allSW, $list, $ip) = &get_list($q, $sw);

  my($ext) = $list;
  $ext =~ s/,/_/g;

  $x = SWITCHAgent->FCCounters({ cache => $cache, ip => $ip});

  my($BDF) = System->get_home() . "/DATA/tmp/SWFCgraph.$ext";

  if ($q->{ACTION} eq "Set-Baseline") {
     open(O, ">$BDF");
     print O Dumper($x);
     close(O);
  } elsif ($q->{ACTION} eq "Total") {
     unlink $BDF;
  }
  my($created) = "";

  if (-r $BDF) {
     open(O, $BDF); 
     my @a = <O>; close(O);
     eval "@a";
     $reset = $VAR1;
     $created = Util->get_file_created($BDF);
     ($hrs, $mins, $secs) = Util->getFileAge($BDF, "hms");
     $created = " <small>" . substr($created, 5) . " ( ${hrs}h ${mins}m ${secs}s</small>)";
  }

  for ($x0=1; $x0 <= 16; $x0++ ) {
     $xvalues .= "P$x0=Port $x0,";
  }

  $applet =<<EOF;
  <script>
  var a_width =  window.innerWidth - 45;
  var a_height =  window.innerHeight -130;
  window.document.writeln(
   '<applet  $FC::APPLET height=' + a_height + ' width=' + a_width + '>');
  </script>

<param name=xTitle value="Switch Port">
<param name=nostyles value=0>
<param name=printCb value=1>
<PARAM name=backColor value="0,0,0">
<param name=showYvalues value=3>
<param name=browser value="sun">
<param name=fontsize value=11>
<param name=Yfontsize value=10>
<param name=minY value=0>
<param name=decimalsY value=-1>
<xparam name=maxY value=20>
<param name=hideXvalues value=0>
<xparam name=urlColor value="white">
<param name=logY value=2>
<param name=gridCntY value=5>
<param name=vertSpace value=3>
<PARAM NAME=fontColor value="250,250,250">
<PARAM name=Grid value=1>
<param name=graphType value=40>
<param name=urlX value="/?GO=GUI::SWITCHUtil::&fc_graph&">
<param name=urlY value="/?GO=GUI::SWITCHUtil::&fc_graph&">
<param name=xurlTarget value="">
<param name=statusInfo value="select,disk,enclosure">
<param name=ySuffix value="">
<param name=hlColor value="250,250,100">
<PARAM name=xValues value="$xvalues">
<xparam name=minX value=1>
<xparam name=maxX value=9>
EOF

   my($line, @b, @c,  $gc, $enc, $disk, @HBA, @ENC2);

   my $hbas = $x->{hba};
   my $encs = $x->{enc};
   my($y);

   my $data = $x->{data};
   my $in;
   foreach $y (sort keys %$data) {
     @c = split(/\|/, $y);

     $enc =  $c[0] . "|" . $c[1];
     $port = $c[2];

     $D{$enc}{$port} = $data->{$y};
     $in = 1;
   }
   if (!$in) {
     print "<h2>No Device selected!";
     return;
   }
   $stack_cnt = 1;
   $gc        = 1;

   foreach $enc (sort keys %D) {
     my(@c) = split(/\|/, $enc);
     $enc0 =  $encs->{$c[1]};

     $tit = $encs->{$c[1]};
     $applet .= "<param name=title$stack_cnt value=\"$enc0=$tit\">";

     $seq_data = $link_data = $sync_data = $word_data = $crc_data = $sig_data = "";

     for ($port0=1; $port0 <= 16; $port0++) {
       $port = "port.$port0";
       my @new = split(/\t/, $D{$enc}{$port});
       @reset1 = split(/\t/, $reset->{data}{"$enc|$port|switch"});

       $link_data .= ($new[0] - $reset1[0]) . ",";   
       $sig_data  .= ($new[1] - $reset1[1]) . ",";   
       $seq_data  .= ($new[2] - $reset1[2]) . ",";   
       $crc_data  .= ($new[3] - $reset1[3]) . ",";   
       $sync_data .= ($new[4] - $reset1[4]) . ",";   # sync
       $word_data .= ($new[5] - $reset1[5]) . ",";   # word 
     }
     chop($sync_data); chop($word_data);
     chop($sig_data); chop($crc_data);

     $applet .=<<EOF;
<PARAM name=graphColor$gc value="cyan">
<param name=graph$gc value="$link_data">
<PARAM name=label$gc value="Link-Fail">
<PARAM name=yOffset$gc value="0">
<param name=active$gc value=0>
<param name=stack$gc value=$stack_cnt>
EOF
     $gc++;
     $applet .=<<EOF;
<PARAM name=graphColor$gc value="green">
<param name=graph$gc value="$sig_data">
<PARAM name=label$gc value="Sign-Loss">
<PARAM name=yOffset$gc value="0">
<param name=active$gc value=0>
<param name=stack$gc value=$stack_cnt>
EOF
     $gc++;

     $applet .=<<EOF;
<PARAM name=graphColor$gc value="blue">
<param name=graph$gc value="$sync_data">
<PARAM name=label$gc value="Sync-Loss">
<PARAM name=yOffset$gc value="0">
<param name=stack$gc value=$stack_cnt>
EOF
     $gc++;

     $applet .=<<EOF;
<PARAM name=graphColor$gc value="red">
<param name=graph$gc value="$word_data">
<PARAM name=label$gc value="Inv TXWord">
<PARAM name=yOffset$gc value="0">
<param name=stack$gc value=$stack_cnt>
EOF
     $gc++;
     $applet .=<<EOF;
<PARAM name=graphColor$gc value="yellow">
<param name=graph$gc value="$crc_data">
<PARAM name=label$gc value="Inv-CRC">
<PARAM name=yOffset$gc value="0">
<param name=stack$gc value=$stack_cnt>
EOF
     $gc++;
     $applet .=<<EOF;
<PARAM name=graphColor$gc value="white">
<param name=graph$gc value="$seq_data">
<PARAM name=label$gc value="Inv-Seq">
<PARAM name=yOffset$gc value="0">
<param name=active$gc value=0>
<param name=stack$gc value=$stack_cnt>
EOF
     $gc++;
     $stack_cnt++;
   }
   $applet .= "</applet>\n";
   if ($created) {
     $title = "Switch Error Counters since $created by Port";
   } else {
     $title = "Switch Error Counters by Port";
   }
  
   
   print "&nbsp;
    <table border=0 cellspacing=0 cellpadding=0 width=100%><tr><td>
    <table border=0 cellspacing=0 cellpadding=0 width=100% bgcolor=black>
    <form method=get>
      <input type=hidden name=GO value=GUI::SWITCHUtil::fc_graph>
      <input type=hidden name=option value=9>
    <tr bgcolor=#666699>
       <td nowrap ><font color=white><b>
          Select Switch: $allSW 
          Auto:<input type=text name=auto size=3 value=$q->{auto}>
          <input type=submit name=ACTION value=Refresh>&nbsp;</td>
       <td nowrap><b><font color=white>&nbsp;
          <input type=submit name=ACTION value=Set-Baseline>
          <input type=submit name=ACTION value=Total>
          <input type=submit name=ACTION value=ClearCache>
       </td>
    <tr bgcolor=black>
       <td colspan=2 nowrap>
         <center><table border=0><tr><td><font color=white><b>&nbsp;$title</table></td>
    <tr><td colspan=2>$applet</td>
    </table></table></form>";
  
}


sub fc_data {
  my($q) = @_;
  my(%D, $applet, $x, $summ, @X, $xvalues, $reset);

  print "<body bgcolor=#E0E0E0><center>";
  if ($q->{auto} > 0) {
    $q->{auto} = 2 if ($q->{auto} < 2);
    my $url = "/?GO=GUI::SWITCHUtil::fc_data";
    foreach my $x (keys %$q) {
      next if ($x eq "GO");
      $url .= "&$x=$q->{$x}";
    }
    print "<meta http-equiv=Refresh content=\"$q->{auto};URL=$url\">";
  }

  my $mach ; # = Util->select_hosts("GUI::SWITCHUtil::fc_data");
  my $hostname = System->shortHostname();
  print &main::header("SWITCH FC Data ", "95%", $mach, "fcutil");

  my($a5, $sw, $t3) = GUI::SAN::findSelected();
  my($debug) = 0;
  my($cache) = 0;
  if ($q->{ACTION} eq "ClearCache") {
    $cache = 2 ; $debug = 1;
  }

  my($allSW, $list, $ip) = &get_list($q, $sw);

  my($ext) = $list;
  $ext =~ s/,/_/g;

  $x = SWITCHAgent->FCCounters({ cache => $cache, ip => $ip});

  my($BDF) = System->get_home() . "/DATA/tmp/SWFCdata.$ext";

  if ($q->{ACTION} eq "Set-Baseline") {
     open(O, ">$BDF");
     print O Dumper($x);
     close(O);
  } elsif ($q->{ACTION} eq "Total") {
     unlink $BDF;
  }
  my($created) = "";

  if (-r $BDF) {
     open(O, $BDF); 
     my @a = <O>; close(O);
     eval "@a";
     $reset = $VAR1;
     $created = Util->get_file_created($BDF);
     ($hrs, $mins, $secs) = Util->getFileAge($BDF, "hms");
     $created = " <small>" . substr($created, 5) . " ( ${hrs}h ${mins}m ${secs}s</small>)";
  }

   my($line, @b, @c,  $gc, $enc, $disk, @HBA, @ENC2);

   my $encs = $x->{enc};
   my($y);
   my $hba_list;
   my $report;


   $report .= "Name         Component       Link       Sig       Seq       CRC      Sync    InvTxW \n";
   $report .= "=" x 83 . "\n";

   my $data = $x->{data};

   foreach $y (keys %$data) {
     my(@c) = split(/\|/, $y);
     $y2 = "$c[0]|$c[1]|$d[0].". sprintf("%2.2d", $d[1]) . "|$c[3]";
     $D{$y2} = $data->{$y};
   }
   my(@report);
   foreach $y (keys %$data) {
     my(@c) = split(/\|/, $y);
     my(@d) = split(/\./, $c[2]);
     if ($#d == 1) {
       $disk = $d[0] . "." . sprintf("%2.2d", $d[1]);
     } else {
       $disk = $c[2];
     }

     my @new = split(/\t/, $data->{$y});
     @reset1 = split(/\t/, $reset->{data}{$y}) if ($reset);
     my(@y2) = ();
     my($pf);
     for ($y1=0; $y1 <= 5; $y1++) {
        $dif = $new[$y1] - $reset1[$y1];
        if ($reset && $dif ) {
           push(@y2, "<b>$dif/</b>$new[$y1]");
           $pf .= "%17s";
        } else {
           push(@y2, "$new[$y1]");
           $pf .= "%10s";
        }
     }
     push(@report, sprintf("%-13s%-10s$pf\n", $encs->{$c[1]}, 
                   $disk, @y2));

   }
   my($last);
   foreach $l (sort @report) {
     if (substr($l,0,10) ne $last) {
       $report .= "\n" if ($last); 
       $last = substr($l,0,10);
     }
     $report .= $l;
   }

   if ($created) {
     $title = "Switch Error Counters since $created by Port";
   } else {
     $title = "All Switch Error Counters by Port";
   }

   print "
    <table border=1 cellspacing=0 cellpadding=4 width=95% bgcolor=white>
    <form>
      <input type=hidden name=GO value=GUI::SWITCHUtil::fc_data>
      <input type=hidden name=option value=91>
    <tr bgcolor=#666699>
       <td nowrap ><font color=white><b>
          FC Counters for Switch: $allSW 
          Auto:<input type=text size=3 name=auto value=$q->{auto}>
          <input type=submit name=ACTION value=Refresh>&nbsp;</td>
       <td nowrap><b><font color=white>&nbsp;
          <input type=submit name=ACTION value=Set-Baseline>
          <input type=submit name=ACTION value=Total>
          <input type=submit name=ACTION value=ClearCache>
       </td>

    <tr> <td colspan=2><b>$title ($list)</b><br><pre>$report \n\n</td>

    </table></form>&nbsp;<p>&nbsp;";
}
  

1;
