package GUI::Start;
#  $Id: Start.pm,v 1.13 2001/07/26 00:41:45 ccadieux Exp $

use Util;
use Util::Http;
use System;

sub Devices {

  my($q) = @_;
  my(@a, @b, %S);
  print "\n";

  if ($q->{ACTION} =~ /Submit/) { # Submit Changes
     ($renv, $devs, $host,$notifs) = PDM::ConfigFile->read;
     my($hostlist);
     foreach $x (keys %$q) {
        $no = 0;
        if (substr($x,0,6) eq "start_") {
          $no = substr($x,6) ; $active = "Y";
        } elsif (substr($x,0,5) eq "stop_") {
          $no = substr($x,5); $active = "N";
        }
        next if (!$no);
        $no--;
        $dev = $devs->[$no];
        print "Updating state of $dev->{name} ...<br>";
        if ($active eq "Y") {
           &main::save_event("QE", $dev->{type}, $dev->{ip} || $dev->{name}); # QuieceEnd
        } elsif ($active eq "N") {
           &main::save_event("QS", $dev->{type}, $dev->{ip} || $dev->{name}); # QuiescStart
        }
        $dev->{active} = $active;
        if ($dev->{host}) {
           if (index(",$hostlist,", ",$dev->{host},") < 0) {
              $hostlist .= "$dev->{host}," ;
           }
        }
     }
     PDM::ConfigFile->write( $renv, $devs, $host,$notifs);
     if ($hostlist) {
        GUI::Hosts::push_slaves($q, $hostlist);
     }
  }

  ($renv, $devs, $host,$notifs) = PDM::ConfigFile->read;
 

  $h1 = &main::header("Start/Stop Device Monitoring","","","ssdevices");
  $o =<<EOF;
<body bgcolor=$main'BGCOLOR>
<form  method=get>
 <input type=hidden name=GO value=GUI::Start::Devices>
<center>
$h1
<table border=0 width=90% bgcolor=white><tr><td>
Start or Stop devices by checking the appropriate checkbox. When Monitoring is 'On', the 'Stop' checkbox is available. When monitoring is 'Off', the 'Start' checkbox is available. Multiple selection in
the same submission is allowed. Once submitted, the program will call each host and update its configuration.<br>
</table>

<table border=1 cellspacing=1 width=90% bgcolor=white><tr><td>
<table border=0 cellspacing=2 width=100% bgcolor=#F0F0F0>
<tr><td colspan=7 bgcolor=#666699><b><font color=white>&nbsp;Start/Stop Device Monitoring</td>
<tr bgcolor=$main'LIGHT>
   <th>Primary Host</th>
   <th>Name</th>
   <th>Type</th>
   <th>Address/WWN</th>
   <th>Monitoring</th>
   <th>Start</th>
   <th>Stop</th>
EOF
  my(%DEV);
  foreach $dev (@$devs) {
     $DEV{$dev->{host} . ":" . $dev->{name}} = $dev;
  }
  my $lasth;
  foreach $dev0 (sort keys %DEV) {
    $dev = $DEV{$dev0};
    $type = uc($dev->{type});
    if ($type eq "T3" || $type eq "SWITCH") {
      $ip = ($dev->{name} eq $dev->{ip})? $dev->{ipno}:$dev->{ip};
    } else {
      $ip = $dev->{wwn};
    }
    $loc = $dev->{host} || System->hostname();
    my $ii = index($loc, ".");
    $loc = substr($loc,0,$ii) if ($ii > 0);
    if ($loc ne $lasth) {
        $lasth = $loc;
        $loc = "<b>$loc";
    }
    $active =($dev->{active} eq "Y")? "On":"Off";
    $start = $stop= "";
    $no = substr($dev->{_name},6);
    if ($active eq "On") {
      $col = "bgcolor=#C0FFC0";
      $stop = "<input type=checkbox name=stop_$no>";
    } else {
      $col = "bgcolor=#FFC0C0";
      $start = "<input type=checkbox name=start_$no>";
    }
    
    $o .= "<tr>
   <td>&nbsp;$loc</td>
   <td>&nbsp;$dev->{name}</td>
   <td>&nbsp;$dev->{type}</td>
   <td>&nbsp;$ip</td>
   <td $col><center><b>$active</td>
   <td><center>$start</td>
   <td><center>$stop</td>
    ";
  }
  $o .= "</table></table><b>
  <input type=submit name=ACTION value=\"Submit Changes\">
  </form>";
  print $o;
}

sub Agents {
  my($q, $post, $util) = @_;

  print "\n";
  $head = &main::header("Start/Stop Agents","","","ssagents");
  if ($q->{ACTION}) {
    ($renv, $dev, $host,$notifs) = PDM::ConfigFile->read;
    for ($x=0; $x <= $#$host; $x++) {
       $start = "";
       $h = $host->[$x];
       $h->{last_push} = "";
       if ($q->{"start_$h->{hostname}"}) {
             $start = "Y";
       } elsif ($q->{"stop_$h->{hostname}"}) {
             $start = "N";
       }
       if ($start) {
#         $url     =  Util->makeUrl($h->{ip}, "?PUT=start&start=$start");
         if ($start eq "Y") {
           $url =  Util->makeUrl($h->{ip}, "?GET=CREAT&file=start");
         } else {
           $url =  Util->makeUrl($h->{ip}, "?GET=DELET&file=start");
         }
         print "Updating $h->{ip}...<br>\n";
         $rc = Util::Http->get($url, $main::TO);
         print "<b>Error updating slave: $url</b>" if ($rc !~ /Y/);
         $h->{active} = $start;
       }
    }
    if ($q->{start_LOCAL}) {
      open(O, ">" . System->get_home() ."/DATA/start");
      print O "Y";
      close(O);
    } elsif ($q->{stop_LOCAL}) {
      unlink System->get_home() ."/DATA/start";
    }
    PDM::ConfigFile->write( $renv, $dev, $host, $notifs);
  }


  $hname = System->hostname;
  $hid = System->hostid;
  $ip  = System->local_ip;
  ($renv, $dev, $host,$notifs) = PDM::ConfigFile->read;

  $o =<<EOF;
<body bgcolor=$main'BGCOLOR>
<center>
$head
<table border=1 cellspacing=1 width=90% bgcolor=white><tr><td>
<form  method=get><input type=hidden name=GO value=GUI::Start::Agents>
<table border=0 cellspacing=2 width=100% bgcolor=#F0F0F0>
<tr><td colspan=7 bgcolor=#666699><b><font color=white>&nbsp;Hosts Current Monitoring State</td>
<tr>
    <td bgcolor=$main'LIGHT><center><b>HostName</td>
    <td bgcolor=$main'LIGHT><center><b>Type</td>
    <td bgcolor=$main'LIGHT><center><b>HostID</td>
    <td bgcolor=$main'LIGHT><center><b>Host IP</td>
    <td bgcolor=$main'LIGHT><center><b>Monitoring</td>
    <td bgcolor=$main'LIGHT><center><b>Start</td>
    <td bgcolor=$main'LIGHT><center><b>Stop</td>
<tr>
EOF
  $local = (-f System->get_home() . "/DATA/start")? "Yes":"No";
  $col = ($local =~ /Yes/)? "#C0FFC0" : "#FFC0C0";
  $start = $stop = "";
  if ($local =~ /Yes/) {
      $local0 = "On";
      $stop = "<input type=checkbox name=stop_LOCAL>";
  } else {
      $local0 = "Off";
      $start = "<input type=checkbox name=start_LOCAL>";
  }
  $o .= "<tr><td>&nbsp;$hname</td>
          <td>Master</td>
          <td>$hid</td>
          <td>$ip</td>
          <td bgcolor=$col><b><center>$local0</td>
          <td><center>$start</td>
          <td><center>$stop</td>
          ";

  for ($x=0; $x <= $#$host; $x++) {
     $h = $host->[$x];
#     $url     =  Util->makeUrl($h->{ip}, "?GET=start");
     $url     =  Util->makeUrl($h->{ip}, "?GET=EXIST&file=start");
     print "Calling $h->{ip}...<br>\n";
     $start = Util::Http->get($url, $main::TO) || "ERR: $Util::Http::ERROR";
     print $start. "<br>" if ($start =~ /ERR:/);
     $col = ($start =~ /Y/)? "#C0FFC0" : "#FFC0C0";
     $start0 = $stop = "";
     if ($start =~ /Y/) {
       $stop = "<input type=checkbox name=stop_$h->{hostname} >";
       $mon = "On";
     } else {
       $start0 = "<input type=checkbox name=start_$h->{hostname} >";
       $mon = "Off";
     }
     $o .= "<tr><td>&nbsp;$h->{hostname}</td>
          <td>Slave</td>
          <td>$h->{hostid}</td>
          <td>$h->{ipno}</td>
          <td bgcolor=$col><b><center>$mon</td>
          <td><center>$start0</td>
          <td><center>$stop</td>
          ";
  }
  $o .= "</table></table><br>";
  $o .= "<input type=submit name=ACTION value=\"Update Agents State\">&nbsp;
        ";
  print $o;

}


1;
 
