package GUI::StorTools;

#StorTools::mess_summ
#StorTools::snapshot
#StorTools::rev_check


sub last_mess_summ {
  $q->{report} = System->get_home() . "/log/mess_summ.out";
  $q->{title} = "Message Summary";
  &display_report($q);
}
sub display_report {
  my($q) = @_;

  print "\n<body bgcolor=white>";
  $age = Util->get_file_created($q->{report});
  print "<table border=0 bgcolor=#E0E0E0 width=100% cellspacing=0 cellpadding=2><tr><td>
     <b>$q->{title}: $q->{report}<br>Generated on :  $age
            <td align=right>&nbsp;</td>
            </table>";
     open(O,$q->{report}); @all = <O>; close(O);
     print "<pre>@all</pre>";
}

#######################################################
#       MESS SUMMARY
#######################################################


sub mess_summ {
  my($q) = @_;
  my($snap_age, $mess_age, $last_report);
  $mach = Util->select_hosts("GUI::StorTools::mess_summ");
  $hostname = System->hostname();
   $h = &main::header("Message Summary (on $hostname)", "90%", $mach);

  $STSNAP = System->get_home() . "/log/stortools.golden";
  print "<body bgcolor=$main'BGCOLOR><center>$h";

  if (-f $STSNAP) {
    $snap_age = "(lastrun: " . Util->get_file_created($STSNAP) . ")";
  }
  $mess_age = Util->get_file_created(System->get_home() . "/log/mess_summ.out");

  $t = "<td bgcolor=$main'LIGHT align=right width=40%><b>";

  if ($mess_age) {
    $last_report = "<tr>$t Last Report Ran: </td>
       <td><table border=0><tr><td>$mess_age</table></td>
      <tr>$t Review Last Mess-Summaryt Report: </td>
       <td><table border=0><tr><td>
          <a href=/?GO=GUI::StorTools::last_mess_summ>Display Last Mess-Summary Report</a>
          </table></td>
    ";
  }

  opendir(O,"/var/adm");
  @a = readdir(O); closedir(O); $size=0;
  foreach $f (@a) {
     if ($f =~ /^messages/) {
        $size += (stat("/var/adm/$f"))[7];
     }
  }
  $size = sprintf("%.1f", $size / 1000);

  print "<table border=1 cellpadding=4 cellspacing=0 width=90% bgcolor=white><tr><td>
       This command will scan /var/adm/message files and produce an error summary.
       This may take a while, your /var/adm/message files are $size K</table>";
  print "&nbsp;";
  print "
  <table border=1 cellspacing=0 cellpadding=2 width=90% bgcolor=white ><tr><td>
  <table border=0 cellspacing=1 cellpadding=2 width=100% bgcolor=white >
  <tr><td colspan=2 bgcolor=#666699>
     <b><font color=white>Last Run</td>
  $last_report
   </table></table>
   ";
  print "
   <table border=1 cellspacing=0 width=90% bgcolor=white><tr><td>
   <table border=0 cellspacing=1 width=100% bgcolor=white>
  <form>
   <input type=hidden name=GO value=GUI::StorTools::run_mess_summ>
  <tr><td colspan=2 bgcolor=#666699>
     <table border=0><tr><td><b><font color=white>Run Message-Summary </table></td>
  <tr>$t Start Date (mm/dd/yyyy hh:mm:ss): </td>
      <td><input type=text size=20 name=start>
  <tr>$t End Date (mm/dd/yyyy hh:mm:ss): </td>
      <td><input type=text size=20 name=end>

  <tr>$t Run Snapshot: </td>
      <td><input type=checkbox name=snap unchecked>
           &nbsp; $snap_age</td>

  <tr>$t Ignore T3 warnings: </td>
      <td><input type=checkbox name=ignoreT3W>
  <tr>$t Long Output: </td>
      <td><input type=checkbox name=long>
  <tr>$t Message Directory: </td>
      <td><input type=text name=dir value=\"/var/adm\" size=40>
  <tr>$t Select a specific file: </td>
      <td><input type=text name=file size=40>
  <tr>$t Debug: </td>
      <td><input type=checkbox name=debug>

   </table></table><b>";
 print "<input type=submit name=ACTION value=RUN_COMMAND>
       </form>";

}

sub run_mess_summ {
  my($q) = @_;

  print "\n<body bgcolor=#F0F0F0>";
  $com = System->get_home() . "/bin/mess_sum ";
  $com .= "-l "             if ($q->{long});
  $com .= "-dir $q->{dir} " if ($q->{dir});
  $com .= "-f $q->{file} "  if ($q->{file});
  $com .= "-s \"$q->{start}\" " if ($q->{start});
  $com .= "-e \"$q->{end}\" "   if ($q->{end});
  $com .= "-iw "            if ($q->{ignoreT3W});
  $com .= "-X "             if ($q->{debug});
  $tmp = System->get_home() . "/log/mess_summ.out";

  open(O, "/usr/bin/ps -ef | grep mess_sum|");
  $running = 0;
  while ($l = <O>) {
    if ($l =~ /SUNWrasag/) {
       $running = 1; last;
    }
  }
  close(O);
  if ($running) {
     print "SUNWrasag/bin/mess_sum already running, try again later!<br>";
  } else {
      if ($q->{snap}) {
         $com2 = System->get_home() . "/bin/storconfig -save ";
         $com2 .= "-X " if ($q->{debug});
         $com2 .= " 2>&1";
         print "Running storconfig ($com2) ... <br>\n";
         ($err, $out) = &run_command2($com2, 240);
         print "<pre>$err @$out</pre>\n";
      }
      print "Running mess_sum ($com)... <br>\n";
      $com .= " 2>&1";
      ($err, $out) = &run_command2($com, 240);
      open(O, ">$tmp");
      print O "@$out"; close(O);
      print "<pre>@$out</pre>\n";
  }
}


#######################################################
#       SNAPSHOT
#######################################################

sub snapshot {
  my($q) = @_;

  $STSNAP = System->get_home() . "/log/stortools.golden";
  $hostname = System->hostname();
  $help =  &main::read_file("snapshot");

  $mach = Util->select_hosts("GUI::StorTools::snapshot");
  $h = &main::header("SnapShot (on $hostname)", "90%", $mach);

  ($renv, $devs, $hosts,$notifs) = PDM::ConfigFile->read; 

  if ($q->{ACTION} =~ "Update") {
    print "<body bgcolor=$main'BGCOLOR><center>$h";
    $renv->{discman_freq} = $q->{snapsched};
    PDM::ConfigFile->write( $renv, $devs, $hosts,$notifs);

  } elsif ($q->{ACTION} =~ /Save/) {
     print "<body bgcolor=$main'BGCOLOR>";
     if (-f $STSNAP) {
        $mtime = (stat($STSNAP))[9];
        $date = Util->get_date($mtime);
        $date =~ s/ /_/g;
        open(O, $STSNAP);
        open(W, ">" . System->get_home() . "/DATA/golden/golden.$date");
        while ($l = <O> ) {
           print W $l;
        }
        close(W); close(O);
     }
     $com = System->get_home() . "/bin/storconfig -save";
     print "Running storconfig ($com 2>&1) ... <br>\n";

     ($err, $out) = &run_command2($com, 220);
     print "<pre>@$out</pre><br>\n";
     print "$h<center>";

  } elsif ($q->{ACTION} =~ /Compare/) {
     print "<body bgcolor=$main'BGCOLOR>";
     $com = System->get_home() . "/bin/storconfig -cmp";
     print "Running storconfig ($com 2>&1) ... <br>\n";

     ($err, $out) = &run_command2($com, 220);
     print "<pre>@$out</pre><br>\n";
     print "$h<center>";

  } else {
     print "<body bgcolor=$main'BGCOLOR><center>$h";
  }

  $freq = $renv->{discman_freq};
  my($snap_age, $review);

  if (-f $STSNAP) {
    $snap_age = Util->get_file_created($STSNAP);
    $review = "<a href=/?GO=GUI::StorTools::review_snap>Detailed Snapshot</a>";
  } else {
    $review = "No SnapShot available!";
  }
#   "/opt/SUNWrasag/log/stortools.golden");

  $t = "<td bgcolor=$main'LIGHT align=right width=40%><b>";
  print "
   <table border=0 width=90% cellpadding=4 bgcolor=white><tr><td>
     $help
   </table>
   <table border=1 cellspacing=0  width=90% bgcolor=white cellpadding=2><tr><td>
   <table border=0 cellspacing=2  width=100% bgcolor=white cellpadding=4>
   ";

  $snap = "<select name=snapsched>" . &select("1=Every day|2=2 days|3=3 days|5=5 days|7=week|=Never", $freq);

  print "
  <form>
   <input type=hidden name=GO value=GUI::StorTools::snapshot>
   <input type=hidden name=option value=2>
  <tr><td colspan=2 bgcolor=#666699>
     <b><font color=white>Last Run</td>
  <tr>$t Last snapshot date: </td>
      <td>$snap_age &nbsp;
  <tr>$t Review Last Snapshot: </td>
      <td>$review
  <tr>$t Schedule Snapshot execution: </td>
      <td>$snap
   </table></table><b>
   <input type=submit name=ACTION value=\"Update Changes\">
   <input type=submit name=ACTION value=\"Compare\">
   <input type=submit name=ACTION value=\"Save\">
       </form>";

}

sub review_snap {
  my($q) = @_;

  $q->{title} = "Config Snapshot";
  $STSNAP = System->get_home() . "/log/stortools.golden";
  $q->{report} = $STSNAP;
  &display_report($q);
}


#######################################################
#       REVISION CHECKING
#######################################################

sub rev_check {
  my($q) = @_;
  my($stor_age);

  if ($q->{ACTION} =~ /RUN Revision/) {
     print "<body bgcolor=$main'BGCOLOR>";

     $com = System->get_home() . "/bin/storstat -all -warn ";
     $com .= "-v " if ($q->{verbose});
     $com .= "-X " if ($q->{debug});
     $com .= "2>&1";
     print "Running storstat ($com) ... <br>\n";
     ($err, $out) = &run_command2($com, 120);

     open(O, ">" . System->get_home() . "/log/storstat.details");
     print O "@$out"; close(O);
     open(O, ">" . System->get_home() . "/log/storstat.out");
     $in = 0;
     foreach $l (@$out) {
        if ($l =~ /^ *storstat result/) {
           print O $l; $in = 1;
        } elsif ($in) {
           print O $l;
        }
     }
     close(O);
     print "<pre>@$out</pre><br>\n";
  }

  $mach = Util->select_hosts("GUI::StorTools::rev_check");
  $hostname = System->hostname();
  $h = &main::header("SnapShot (on $hostname)", "90%", $mach);

  print "<body bgcolor=$main'BGCOLOR><center>$h";

  my($file) = System->get_home() . "/log/storstat.out";
  if (-f $file) {
    $stor_age = Util->get_file_created($file);
  } else {
    $stor_age = "No Report available!";
  }
  open(O, System->get_home() . "/log/storstat.out");
  @storstat = <O>; close(O);

  $details = "<a href=/?GO=GUI::StorTools::storstat_details>Detailed Output</a>"
         if (-f System->get_home() . "/log/storstat.details");

  $t = "<td bgcolor=$main'LIGHT align=right width=40% cellpadding=3><b>";
  print "
   <table border=0 width=90% bgcolor=white cellpadding=4><tr><td>
     This command will perform revision checking.
   </table>&nbsp;";

  print "
   <table border=1 cellspacing=0 width=90% bgcolor=white cellpadding=4><tr><td>
   <table border=0 width=100% bgcolor=white cellpadding=3 cellspacing=1>
  <tr><td colspan=2 bgcolor=#666699>
     <b><font color=white>Last Run</td>
  <tr>$t Last Storstat Date: </td>
      <td>$stor_age &nbsp;
  <tr>$t Last Storstat Output: </td>
      <td>@storstat &nbsp;
  <tr>$t Review Last Storstat Report: </td>
      <td>$details &nbsp;
   </table></table>";

  print "
   <table border=1 cellspacing=1 cellpadding=2 width=90% bgcolor=white><tr><td>
   <table border=0 cellspacing=1 cellpadding=2 width=100% bgcolor=white>
  <form>
   <input type=hidden name=GO value=GUI::StorTools::rev_check>
   <input type=hidden name=option value=3>
  <tr><td colspan=2 bgcolor=#666699><b><font color=white>Run Revision Checking</td>
  <tr>$t Verbose Output: </td>
      <td><input type=checkbox name=verbose checked>
  <tr>$t Debug ON: </td>
      <td><input type=checkbox name=debug>

   </table></table><b>";
   print "<input type=submit name=ACTION value=\"RUN Revision Checking\">
       </form>";

}

sub storstat_details {
  my($q) = @_;

  $q->{report} = System->get_home() . "/log/storstat.details";
  $q->{title} = "StorStat Details";
  &display_report($q);
}

sub osnapshot {
  my($q) = @_;

  $mach = Util->select_hosts("GUI::StorTools::osnapshot");
  $hostname = System->hostname();
  $h = &main::header("SnapShot History (on $hostname)", "90%", $mach);

  opendir(O, System->get_home() . "/DATA/golden");
  @a = readdir(O);
  closedir(O);
  print "<body bgcolor=$main'BGCOLOR><center>$h";
  print "<table border=1 width=90% bgcolor=white>
    <tr><td bgcolor=$main'LIGHT><b>File Name (most recent first)</td>
  ";
  $cnt=0;
  foreach $f (reverse @a) {
     if ($f =~ /^golden/) {
        $cnt++;
        print "<tr><td><a href=/?GO=GUI::StorTools::display_old_snap&file=$f>$f</a>";    
        last if ($cnt > 100);
     }
  }
  if ($cnt==0) {
     print "<tr><td><b>No Snapshot available!</td>";
  }
  print "</table>";


}

sub display_old_snap {
  my($q) = @_;

  my($file) = $q->{file};
  $q->{report} = System->get_home() . "/DATA/golden/$file";
  $q->{title} = "Snapshot $file";

  if (!open(O,$q->{report})) {
     print "Error on $q->{report}: $!";
     return;
  }
  @all = <O>; close(O);
  print "<body bgcolor=#F0F0F0>";
  print "<table border=1 cellspacing=0 cellpadding=2 width=100%>
   <tr><td><b>File: $q->{report}
       <td align=right><b>[ <a href=/?GO=GUI::StorTools::osnapshot>Back</a> ]</a>
   </table><pre>";
  print "@all";
}


sub run_command2 {
  my($command, $to) = @_;
  $to = 30 if (!$to);
  my($f);
  my($sp)  = index($command," ");
  $command0 = ($sp > 0)? substr($command,0,$sp) : $command;

  $f = "$command|";

  my($err);
  eval {
    local $SIG{ALRM} = sub { die "alarm\n" };
    alarm $to;
    if (open(RUN, $f)) {
       @out = <RUN>;
       close(RUN);
    } else {
       $err = "Cannot open $f: $!";
    }
  };
  alarm 0;
  if ($@) {
    print "Error on $command: $@<br>\n";
    if ($@ eq "alarm\n") {
       my(@procs) = `/usr/bin/ps -ef`;   # kill hanging processes.
       my(@kills) = ();
       foreach my $proc (@procs) {
          if ($proc =~ /$command0/) {
              $proc = Util->ltrim($proc);
              my(@b) = split(/\s+/, $proc);
              if ($b[2] eq $$) {
                 push(@kills, $b[1]) if ($b[1] =~ /\d+/);
              }
          }
       }
       if ($#kills >= 0) {
          print("Killing $command0 processes '@kills' after $to secs time-out ");
          kill 9, @kills;
       }
       return ("Timeout",undef);
    } else {
       return ($@,       undef);
    }
  } elsif ($err)  {
    return ($err, undef);
  } else {
    return (undef, \@out);
  }
}

sub select {
  my($values, $val) = @_;
  my($sel, $x, $val0, $key, @a, $i);
  $sel = "";

  @a = split(/ *\| */, $values);
  foreach $x (@a) {
    $key = $val0 = "";
    $i = index($x,"=");
    if ($i >= 0) {
      $key = substr($x,0,$i);
      $val0 = substr($x,$i+1);
      $selected = ($key eq $val) ? "selected":"";
      $sel .= "<option value=\"$key\" $selected>$val0</option>";
    } else {
      $selected = ($x eq $val) ? "selected":"";
      $sel .= "<option value=\"$x\" $selected>$x</option>";
    }
  }
  $sel .= "</select>";
 
}



1;
