package GUIAdmin::A1000;
#  $Name:  $ 
#  $Id: A1000.pm,v 1.3 2001/03/31 00:12:56 ccadieux Exp $

use PDM;

use strict;
use Debug;
use Util;
use Util::Http;
use System;
use Carp;
use GUIAdmin;
use base 'GUIAdmin';

sub description {'A1000'}
sub isDevice {1}

sub discover {
  my($q,$post,$util) = @_;
  my(%T, @a, $loc, $ip, $new_dev, $d, $adding, $name, $wwn, $hba, $local, $found, $l, $h);
  my($url);
  my($TO) = $util->{TO} || 20;
 
  my(%F);
  my(@NEW);

  my($renv, $dev, $host,$notifs) = PDM::ConfigFile->read;
  $new_dev= $#$dev ;
  print "<pre>1 - Find A1000 already registered ...\n";
  foreach $d (@$dev) {
     if ($d->{type} eq "a1000") {
        $F{$d->{name}} = 1;
     }
  }

  print "2 - Finding A1000 from local Host ...\n";
  $adding = 0; $found = 0;
  $q->{type} = "A1000";
  $local = Agent::get_RM6Devices($q);

  if (substr($local,0,3) eq "ERR") {
     print "   $local<br>";
  } else {
    @a = split(/\n/, substr($local,3));
    foreach $l (@a) {
      ($name, $wwn, $hba) = split(/=/, $l);
      $found++;
      print "  - Found new one $name/$wwn, ";
      if (!$F{$name}) {
         $F{$name} = 1;
         $adding = 1;
         $new_dev++;
         $dev->[$new_dev]{_name}    = "device" . $new_dev;
         $dev->[$new_dev]{type}     = 'a1000';
         $dev->[$new_dev]{name}     = $name;
         $dev->[$new_dev]{wwn}      = "a1000.$name";
         $dev->[$new_dev]{active}   = 'Y';
         $dev->[$new_dev]{host}     = "";
         print " added \n";
      } else {
         print " already exist\n";
      }
    }
  }
  if (!$found) {
    print "  - No A1000 found on Master host\n";
  }

  my($data, $a5, $file);
  print "3 - Finding A1000 on Slave Agents ...\n";
  foreach $h (@$host) {
    print "  - Querying host $h->{hostname} / $h->{ip} ...\n";
    $url = Util->makeUrl($h->{ip}, "?GET=Agent::RM6Devices&type=a1000&print=1");
    if (($data = Util::Http->get($url, 10)) ) {
      if (substr($data,0,3) eq "ERR") {
           print "  $data<br>";
           next;
      } else {
           $data = substr($data,3);
      }
      @a = split(/\n/, $data);
      foreach $a5 (@a) {
           ($name, $wwn, $hba) = split(/=/, $a5);
           next if (!$name);
           print "  - Found new one $name/$wwn ";
           if (!$F{$name}) {
              $adding = 1;
              $new_dev++;
              $dev->[$new_dev]{_name}    = "device" . $new_dev;
              $dev->[$new_dev]{type}     = 'a1000';
              $dev->[$new_dev]{wwn}      = "a1000.$name";
              $dev->[$new_dev]{name}     = $name;
              $dev->[$new_dev]{active}   = 'Y';
              $dev->[$new_dev]{hba}      = $hba;
              $dev->[$new_dev]{host}     = $h->{hostname};
              $h->{last_push} = "";
              print ", Added\n";
              $F{$name} = 1;
           } else {
              print ", already exist\n";
           }
      }
    } else {
      print "No response from $h->{ip}<br>";
    } 
  }

  if ($adding) {
      PDM::ConfigFile->write( $renv, $dev, $host,$notifs);
  } else {
    print "  *** No new devices were added ***\n";
  }
  print "</pre>";
  return "DONE";
}


#
# returns the a1000 that a slave has.
# response to a http request made by a master rasagent.

sub getDevicesDI {
  my($q, $post, $util) = @_;
  my(@out, $f, $l, $name, $hba, $in , $wwn, $x, $i, $path, $out, $out2, $err);
  my($details, $dev, $vendor);

  my($di) = System->get_home() . "/bin/disk_inquiry";

  ($err,$out) = Util->run_command($di, "luxprobe.txt", 20);

  return "\nERR $err" if ($err);

  for ($x=0; $x <= $#$out; $x++) {
    $l= $out->[$x];
    my($ix) = index($l, ":");
    $l= substr($l, $ix+2);
    my(@a) = split(/\s+/, $l);
    $dev = $a[0]; $vendor = $a[2]; $wwn = $a[1];
    next if ($a[2] !~ /A3500/);
    $f .= "$dev=$wwn=X\n";
  }

  return "OK $f";
}

sub getDevicesLUX {
  my($q, $post, $util) = @_;
  my(@out, $f, $l, $name, $hba, $in , $wwn, $x, $i, $path, $out, $out2, $err);
  my($details);

  my($lux) = "/usr/sbin/luxadm";

  my($HOME) = System->get_home();
  ($err,$out) = Util->run_command("$lux probe", "luxprobe.txt", 20);
  return "\nERR $err" if ($err);
  for ($x=0; $x <= $#$out; $x++) {
    $l= $out->[$x];
    $name = $out->[$x+1];
    $name =~ /Logical Path:\/.*\/.*\/(.*)/;
    $name = $1;
    if ($l =~ / Node WWN:(.+)\s+Device Type:Disk/) { # 
      $wwn = $1;
      ($err,$out2) = Util->run_command("$lux display $wwn", "luxadm_disk3.txt",
 10);
      next if ($err);
      $details = "@$out2";
      $f .= "$name=$wwn=X\n" if ($details =~ /A1000/);
    }
  }
  return "OK $f";
}




sub addDevice {
  my( $q) = @_;
  my($ho, $o, $err, $ipno, $x, $info);
  my($renv, $dev, $host,$notifs, $sel);

  print "\n";
  require "GUI/Devices.pm";
  if ($q->{ACTION} eq "Back") {
    GUI::Devices::list($q);
    return;

  } elsif ($q->{ACTION} eq " Add ") {
    while (1) {
     if ($q->{name} eq "") {
        $err = &main::info("Device name is mandatory <br>Record not added!");
        last;
     } else {
        ($renv, $dev, $host,$notifs) = PDM::ConfigFile->read;
        foreach $x (@$dev) {
          if ($x->{name} eq $q->{name}) {
             $err = &main::info("Error: This Device Name is already used <br>Record not added!");
             goto out;
          }
        }
        $x = $#$dev + 1;
        $dev->[$x]{_name}    = "device" . ($x+1);
        $dev->[$x]{type}     = "a1000";
        $dev->[$x]{name}     = $q->{name};
        $dev->[$x]{wwn}      = "a1000." . $q->{name};
        $dev->[$x]{active}   = "Y";
        $dev->[$x]{host}     = $q->{host};
        GUIAdmin->clearSlave($q->{host}, $host);  

        if (!PDM::ConfigFile->write( $renv, $dev, $host,$notifs)) {
           print "Cannot write to ConfigFile<br>";
        } else {
           $info = &main::info("Device added!", "green");
        }

        GUI::Devices::list($q);
        return;
     }
     last;
    }
  }
out:

  my($h) = &main::header("Maintain Device : Add A1000");

  ($renv, $dev, $host,$notifs) = PDM::ConfigFile->read;
  $sel = ($q->{host} eq "")? "selected":"";

  my($phost) = "<select name=host><option value=\"\">[Select]</option>".
              "<option value=\"\" $sel>Local</option>";


  foreach $x (@$host) {
    $sel = ($q->{host} eq $x->{hostname})? "selected":"";
    $phost .= "<option value=" . $x->{hostname} . " $sel>" . $x->{hostname} ."</option>";
  }
  $phost .= "</select>";

  $o =<<EOF;
<body bgcolor=$main'BGCOLOR>
<form  method=get>
 <input type=hidden name=GO value="GUIAdmin::A1000::addDevice">
<center>
$h
$err
<table border=2 cellspacing=2 width=90% bgcolor=white><tr><td>
<table border=0 cellspacing=2 width=100%>
<tr><td colspan=2 bgcolor=#666699><b><font color=white>&nbsp;Enter Device Information</td>

<tr><td bgcolor=$main'LIGHT width=30% align=right>Device Name (from rm6-drivutil):</td>
    <td><input type=text name=name size=15 maxlength=15 value="$q->{name}">

<tr><td bgcolor=$main'LIGHT align=right>Primary Host :</td>
    <td>$phost</td>

</table>
</table>
<b>
<input type=submit name=ACTION value=" Add ">
<input type=submit name=ACTION value="Back">
</form>
EOF

  print $o;

}
sub updDevice {
  my($q) = @_;
  my($ho, $o);
  my($name, $err, $ip, $ipno);
  my($renv, $dev, $host,$notifs, $x, $D, $type, $key, $h1, $h, $sel, $active);

  print "\n";
  require "GUI/Devices.pm";

  if ($q->{ACTION} eq "Back") {
    GUI::Devices::list($q);
    return;

  } elsif ($q->{ACTION} eq "Update") {
    ($renv, $dev, $host,$notifs) = PDM::ConfigFile->read;
    $x = $q->{no};
    $D = $dev->[$x];

    $dev->[$x]{host} = $q->{host};
    $dev->[$x]{name} = $q->{name};
    $dev->[$x]{wwn} = "a1000." . $q->{name};
    GUIAdmin->clearSlave($q->{host}, $host);

    PDM::ConfigFile->write( $renv, $dev, $host,$notifs);
    $err = &main::info("Device $name updated!", "green");

  } elsif ($q->{ACTION} eq "Delete") {
    ($renv, $dev, $host,$notifs) = PDM::ConfigFile->read;
    $x = $q->{no};
    $type = $dev->[$x]{type};
    $key =  $dev->[$x]{name};

    GUIAdmin->clearSlave($q->{host}, $host);

    &main::save_event("DD", $type,  $key) if ($key);
    $dev->[$x]{_name} = "";
    $name = $dev->[$x]{name} . "/ " . $dev->[$x]{ip};
    PDM::ConfigFile->write( $renv, $dev, $host,$notifs);
    &main::log_change("Device $name deleted");
    $q->{ERR} = &main::info("Device $name deleted!" );
    GUI::Devices::list($q);
    return;
  }
out:

 $h1 = &main::header("Maintain Devices : Update A1000");

  ($renv, $dev, $host,$notifs) = PDM::ConfigFile->read;
  $h = $dev->[$q->{no}];

  $sel = ($h->{host})? "":"selected";
  $ho = "<select name=host><option value=\"\" $sel>Local</option>";
  foreach $h1 (@$host) {
       $sel = ($h1->{hostname} eq $h->{host}) ? "selected":"";
       $ho .= "<option name=$h1->{hostname} $sel>$h1->{hostname}</option>";
  }
  $ho .= "</select>";

  $active = ($h->{active} eq "Y") ? "On":"Off";

  $o =<<EOF;
<body bgcolor=$main'BGCOLOR>
<form  method=get>
 <input type=hidden name=GO value=GUIAdmin::A1000::updDevice>
 <input type=hidden name=no value=$q->{no}>
<center>
$h1
$err
<table border=2 cellspacing=2 width=90% bgcolor=white><tr><td>
<table border=0 cellspacing=2 width=100%>
<tr>
<td colspan=2 bgcolor=#666699><b><font color=white>&nbsp;Device Information</td>

<tr><td bgcolor=$main'LIGHT align=right>Device Type :</td>
    <td>
      <table border=0 cellspacing=0 width=100%> <tr>
        <td><b>&nbsp;$h->{type}</td>
        <td bgcolor=$main'LIGHT align=right>Monitoring:</td>
        <td ><b>&nbsp;$active</td>
      </table>

<tr><td bgcolor=$main'LIGHT width=30% align=right>Device Name :</td>
    <td><input type=text name=name size=20 maxlength=40 value="$h->{name}">

<tr><td bgcolor=$main'LIGHT align=right>Primary Host :</td>
    <td><b>$ho</td>


</table>
</table>
<b>

<input type=submit name=ACTION value="Update">
<input type=submit name=ACTION value="Delete">
<input type=submit name=ACTION value="Back">
</form>
EOF

  print $o;
}




1;
