package GUIAdmin::Subnet;
#  $Name:  $ 
#  $Id: Subnet.pm,v 1.7 2001/08/23 23:17:32 ccadieux Exp $

use PDM;

use strict;
use Debug;
use Carp;
use GUIAdmin;
use base 'GUIAdmin';

sub isDevice {0}

sub ipRequired {0}

sub discover {
  my( $q, $post, $util) = @_;
  my($o, $err);
  print "\n";
  if ($q->{ACTION} =~ /Confirm/) {
     $q->{prefix} =~ s/\./_/g;
     $q->{prefix2} =~ s/\./_/g;
     if ($q->{SUB} !~ /\d+\.\d+\.\d+/) {
       $err= "<big><b><font color=red>Error: Invalid subnet, must be xxx.xxx.xxx</font>";
     } else {
       my($data, %F, $adding, $found);
       my($renv, $dev, $host,$notifs) = PDM::ConfigFile->read();
       my $new_dev = $#$dev ;
       my $monitor_on = $q->{monitor_on};
       my $datahost   = $q->{datahost};
       print "<pre>1 - Find Devices already registered ...\n";
       my $cnt=1;
       foreach my $d (@$dev) {
          if ($d->{type} eq "switch" || $d->{type} eq "t3") {
             $F{$d->{wwn} || $d->{ipno}} = $cnt;
          }
          $cnt++;
       }
       if (!$q->{subhost}) {
           $data = &get_snmpdata($q, $post, $util);
       } else {
          print "2 - Getting devices from $q->{subhost}..\n";
          my $url = Util->makeUrl($q->{subhost}, 
                         "?GET=GUIAdmin::Subnet::snmpdata&REM=1&SUB=$q->{SUB}");
          my $rc = Util::Http->get($url, 200);
          if (substr($rc,0,2) ne "OK") {
              print "<font color=red><b>Snmp Error: $rc";
              return;
          } else {
              my @A = split(/\n/, substr($rc,2));
              $data = \@A;
          }
       }
       my $short = Util->shortHostname($q->{subhost} || $renv->{hostname});

       foreach my $line (@$data) {
          my($type, $ip, $wwn) = split(/\|/, $line);
          if (!$F{$wwn}) {
             $F{$wwn} = 1;
             $adding = 1;
             $found++;
             $new_dev++;
             my($ip1,$ip2,$ip3, $ip4) = split(/\./, $ip);
             $dev->[$new_dev]{_name}    = "device" . $new_dev;
             $dev->[$new_dev]{type}     = $type;
             if ($q->{prefixT}) {
               $dev->[$new_dev]{name}     = $short ."-" . sprintf("%3.3d", $ip4);
             } elsif ($q->{prefix}) {
               $dev->[$new_dev]{name}     = $q->{prefix} . "-" . $ip;
             } else {
               $dev->[$new_dev]{name}     = ($type eq "switch"? "sw-":"t3-") .
                                              "$ip3-$ip4";
             }
             $dev->[$new_dev]{ip}       = $ip;
             $dev->[$new_dev]{ipno}     = $ip;
             $dev->[$new_dev]{wwn}      = $wwn;
             $dev->[$new_dev]{host}     = $q->{subhost};
             $dev->[$new_dev]{active}   = ($monitor_on ? "Y":"N");
             $dev->[$new_dev]{datahost} = $datahost;
             print " $type:$ip added. \n";
         } else {
           my $ix = $F{$wwn};
           if ($ix) {
             $dev->[$ix]{wwn}      = $wwn;
             $dev->[$ix]{active}   = ($monitor_on ? "Y":"N");
             $dev->[$ix]{datahost} = $datahost;
           }
           $adding = 1;
           print " $type:$ip already exist.\n";
         }
      }
      if ($adding) {
         PDM::ConfigFile->write( $renv, $dev, $host,$notifs);
      } else {
         print "  *** No new devices found***\n";
      }
    }
  }
  print "</pre>";

  my($h) = GUIAdmin->header("Discover Subnet");
  my($ip)    = Util->name2ip(System->hostname() );
  my($ix) = rindex($ip, ".");
  $ip = substr($ip, 0, $ix);
  my($renv, $dev, $host,$notifs) = PDM::ConfigFile->read();

  my $hosts = "<select name=subhost><option value=\"\">Local</option>";
  foreach my $d (@$host) {
     $hosts .= "<option>$d->{hostname}</option>";
  }
  $hosts .= "</select>";


  $o =<<EOF;
 <body bgcolor=$main'BGCOLOR>
 <center>
 $h  $err
<table border=0 cellpadding=4 width=80% bgcolor=white><tr><td>
  <b>This program will discover all Switches and T3 using the following IP prefixes . This operation will take approx. 1 minute per prefix.<p>
</table>
<table border=2 cellspacing=0 cellpadding=4 width=80% bgcolor=white>
  <form method=get>
  <input type=hidden name=GO value=discover>
  <input type=hidden name=PKG value=GUIAdmin::Subnet::discover>
  <tr><td bgcolor=white><center>
    <table border=0 cellspacing=1 cellpadding=0 bgcolor=#F0F0F0 width=80%>
    <tr><td bgcolor=gray colspan=2><table border=0 cellpadding=1 cellspacing=0><tr><td></table></td>
    <tr><td align=right bgcolor=#CCCCFF><b>Run on Host: </td>
        <td><b>&nbsp;$hosts</td>
    <tr><td align=right bgcolor=#CCCCFF><b> Subnet to Search: </td>
        <td>&nbsp;<input type=text name=SUB value="$ip"> (xxx.xxx.xxx)</td>
    <tr><td align=right  bgcolor=#CCCCFF><b> Use Host Name as Prefix: </td>
        <td><b>&nbsp;<input type=checkbox name=prefixT></td>
    <tr><td align=right  bgcolor=#CCCCFF><b> Use Custom Prefix: </td>
        <td>&nbsp;<input type=text name=prefix value="$q->{prefix}"</td>

    <tr><td bgcolor=gray colspan=2><table border=0 cellpadding=1 cellspacing=0><tr><td></table></td>

    <tr><td align=right bgcolor=#F0F0C0><b>Turn Monitoring On: </td>
        <td><input type=checkbox name=monitor_on></td>
    <tr><td align=right bgcolor=#F0F0C0><b>Data Path Host: </td>
        <td><b><select name=datahost><option value=\"\">Same Host</option>
            <option value=\"*None\">None</option></select>&nbsp; (T3 only)
    <tr><td bgcolor=gray colspan=2><table border=0 cellpadding=1 cellspacing=0><tr><td></table></td>
    </table>
    <b><center>&nbsp;<br>
    <input type=submit name=ACTION value="Confirm Subnet Discovery"><br>&nbsp;
 </table>
 </form>
EOF
  print $o;
  return 0;

}


sub get_snmpdata {
  my($q, $post, $util) = @_;
  my(%T, @a, $loc, $ip, $out);
  my(%F, $d, $adding, $found, $l );
  my(@NEW);
  my($xx, $sub, $remote);

  $remote   = $q->{REM};
  $sub      = $q->{SUB};

  my(@L);
#  foreach my $x (20, 160,180,200) {
  foreach my $x (0,20,40,60,80,100,120,140,160,180,200,220,240) {
      print "Looking at ports $sub.$x  .. " . ($x+19) . " \n" if (!$remote);
      $out = snmpget($sub, $x,  "public 1.1.0");
      foreach my $node (@$out) {
         my($type, $ip, $wwn) = split(/=/, $node);
         push(@L, "$type|$ip|$wwn");
      }
  }
  if ($remote) {
     print "OK" . join("\n", @L);
  } else {
     return \@L;
  }
}
  

sub snmpget {
  my($ip,$no, $f) = @_;
  my($err, @out, $l, $x, $ipno, $comm, $cnt, $ret);
  my($GROUP) = 20;
  if (!-d "/tmp") {
     mkdir "/tmp" , 0777;
  }
  my($prog) = System->get_home() . "/bin/snmpget";
  for ($x = 0; $x < $GROUP; $x++) {
     unlink("/tmp/ras_snmp_$x");
  }
  for ($x = 0; $x < $GROUP; $x++) {
     last if ($no +$x > 255);
     $ipno = "$ip." . ($no+$x);
     $comm = "$prog -r 1 $ipno $f > /tmp/snmp_$x 2>/dev/null";
     system("$comm&");
  }
  sleep(3);
  $cnt= 0;
  for ($x = 0; $x < $GROUP; $x++) {
     last if ($no +$x > 255);
     open(O, "/tmp/snmp_$x");
     $ret = <O>; close(O);
     chop($ret);
     $ipno = "$ip." . ($no+$x);

     if ($ret !~ /No Response/) {
        my(@b) = split(/\s*=\s*/, $ret);
        if (lc($b[1]) =~ /switch/)  {
           open(O1, "$prog -r 2 $ipno public  .1.3.6.1.3.42.2.1.1.1.0|");
           my($wwn) = <O1>; 
           close(O1); chop($wwn);
           my(@wwns) = split(/\s*=\s*/, $wwn);
           $wwn = substr($wwns[1],5); $wwn = Util->rtrim($wwn);
           $wwn =~ s/ //g;
           $wwn = lc($wwn);
           push(@out, "switch=$ipno=$wwn");

        } elsif (lc($b[1]) =~ /t300/) {
           open(O1, "$prog -r 2 $ipno public 2.2.1.6.1 2>/dev/null|");
           my($wwn) = <O1>;
           close(O1); chop($wwn);
           my(@wwns) = split(/\s*=\s*/, $wwn);
           $wwn = lc($wwns[1]);
           $wwn =~ s/hex: //;
           if ($wwn) {
             my(@aa) = split(/[\: ]/, $wwn);
             $wwn = "";
             foreach my $a (@aa) {
              if (length($a) == 1) {
                 $wwn .= "0$a";
              } else {
                 $wwn .= $a;
              }
             }
             push(@out, "t3=$ipno=$wwn");
           }
        }
     }
  }
  return \@out;
}



1;
