package GUIAdmin::T3;
#  $Name:  $ 
#  $Id: T3.pm,v 1.32 2001/08/23 16:21:01 ccadieux Exp $

use PDM;
use Util;
use strict;
use Debug;
use Carp;
use GUIAdmin;
use base 'GUIAdmin';

sub isDevice {1}
sub description {'T3'};

sub ipRequired {1}

sub discover {
  my( $q, $post, $util) = @_;
  my($o, $warn);
  print "\n";
  my($renv, $dev, $host,$notifs) = PDM::ConfigFile->read;
  foreach my $h1 (@$host) {
      if (!$h1->{t300logfile}) {
        $warn .= "<b><font color=red>Warning: The T300 logfile on $h1->{hostname} has not been entered.</font></b><br>";
      }
  }

  if (!$renv->{t300logfile}) {
     $warn .= "<b><font color=red>Warning: The local T300 logfile has not been entered.".
             "</font></b>";
  } else {
     $warn .= "Local T3 logfile is called: $renv->{t300logfile}";
  }

  if ($q->{ACTION} =~ /by WWN/) {
     $q->{WWN} = 1;
     &discovert3($q, $post, $util);
     return 'DONE';

  } elsif ($q->{ACTION} =~ /Confirm/) {
     &discovert3($q, $post, $util);
     return 'DONE';
  }

  my($h) = GUIAdmin->header("Discover T3s");

  $o =<<EOF;
 <body bgcolor=$main'BGCOLOR>
 <center>
 $h
<table border=0 cellpadding=4 width=80% bgcolor=white><tr><td>
This program will request a list of T3's from each registered Slave host.  This list will be compared with the configured T3's and any new ones will be added. This may take a few seconds per Slave.
<br>Use <b>[Confirm T3 Discovery (by WWN)]</b> if you expect to find different T3's that have the same IP and want to use their wwn to identify them. <p><center>
 <table border=0><tr><td>$warn</table>
</table>
<table border=1 cellspacing=0 cellpadding=4 width=80% bgcolor=$main'LIGHT>
  <form method=get>
  <input type=hidden name=GO value=discover>
  <input type=hidden name=PKG value=GUIAdmin::T3::discover>
  <tr><td><center><b>
     <input type=submit name=ACTION value="Confirm T3 Discovery">
     <input type=submit name=ACTION value="Confirm T3 Discovery (by WWN)">
 </table>
 </form>
EOF
  print $o;
  return 0;

}

sub discovert3 {
  my( $q, $post, $util) = @_;

  my(%T, @a, $loc, $ip);
  my(%F);
  my(@NEW);

  my($renv, $dev, $host,$notifs) = PDM::ConfigFile->read;
 
  my($log) = $renv->{t300logfile};
  my($cnt) = 0;
  foreach my $d (@$dev) {
     if ($d->{type} eq "t3") {
        $cnt++;
        if ($q->{WWN}) {
           $F{substr($d->{wwn},1)} = 1;

        } elsif ($d->{ipno}) {
           $F{$d->{ipno}} = 1;

        } elsif ($d->{ip}) {
           my($ipno) = Util->name2ip($d->{ip});
           $F{$ipno} = 1 if ($ipno);
        }
     }
  }
  print "<pre>1 - Found $cnt t3 already registered ...\n";
  print "2 - Finding t3 in Local Message-Log file ...\n";
  
  my(%local, $l,  $h, $file);
  print "2 - Finding t3 in $log Log file ...\n";
  if (open(O, $log)) {
      while ($l = <O>) {
        @a = split(/ +/, $l);
        $loc = $a[3];
        $loc = substr($loc,1) if (substr($loc,0,1) eq "[");
        chop($loc) if (substr($loc,-1) eq "]");
        $loc = substr($loc,0, -4) if (substr($loc,-4) eq ".2.2");
        next if ($loc =~ /\:/);
        $local{$loc} = 1;
      }
      close(O);
  } else {
    print "*** Cannot open $log: $!\n";
  }

  foreach $l (keys %local) {
    $ip = Util->testIp($l);
    if ($ip) {
       my $wwn  = Util->snmpWWN($ip);
       if ($wwn) {
         print "  - Found $ip, ";

         my $ip0 = $q->{WWN}? $wwn : $ip;

         if (!$F{$ip0}) {
            push(@NEW, [$ip,"", $l, $wwn]);
            $F{$ip0} = 1;
            print " added\n";
         } else {
            print " Already there\n";
         }
       } else {
         print "  - Cannot add $l: no WWN, probably not a T3.\n";
       }
    } else {
       print "  - Cannot add $l: not accessible.\n";
    }
  }

 my($url, @a, $data, $list, $added, $name, $xx, $x, $status, $wwn);
 my($TO) = 60;
 my($RASPORT) = $util->{RASPORT};
 print "3 - Finding t3 in Remote Message-Log file (will time-out in $TO secs)...\n";
  foreach $h (@$host) {
      print "  - Querying host $h->{hostname} / $h->{ipno} ...\n";
      $file = $h->{t300logfile};
      next if (!$file);
      $url = Util->makeUrl($h->{ip}, "?GET=device&type=t3&file=$file&WWN=$q->{WWN}");
      if ( ($data = Util::Http->get($url, $TO)) ) {
         if (substr($data,0,3) eq "ERR") {
           print "  $data<br>";
           next;
         }  
         $list = substr($data,3);
         @a = split(/\n/, $list);
         $added = 0;
         foreach $l (@a) {
             ($status, $name, $ip, $wwn) = split(/=/, $l);
             if ($status eq "OK") {
               $name = Util->trim($name);
               $ip = substr($ip, 0, -4) if (substr($ip, -4) eq ".2.2");
               next if (!$name);
              
               my $ip0 = $q->{WWN}? $wwn : $ip;
               if (!$F{$ip0}) {
                 $F{$ip0} = 1;
                 push(@NEW, [$ip,$h->{hostname}, $name, $wwn]) ;
                 $added++;
                 print "   -> $name: added.\n";
               } else {
                 print "   -> $name: already there, not added.\n";
               }
             } else {
               print   "   -> $name.\n";
             }
         }
         #print         "   -> Found " . ($#a+1) . " t3(s): $added added.\n";
      } else {
         print "    - No response from $h->{hostname}-$file / $h->{ip}!\n";
      }
  }

  if ($#NEW >= 0) {
      my($new_dev) = $#$dev;
      foreach my $t (@NEW) {
#         print "  *** Adding device: $t->[0] $t->[1]\n";
         if ($t->[2] =~ /^(\w+\.\w+)\.\w+/) {
            $xx = $1;
         } else {
            $xx = $t->[2];
         }
         $xx      = $t->[2];
         my $wwn  = $t->[3];
         $new_dev++;
         $dev->[$new_dev]{_name}    = "device" . $x;
         $dev->[$new_dev]{type}     = 't3';
         $dev->[$new_dev]{wwn}      = "-" . $wwn;
         if ($q->{WWN}) {
            my $ix = rindex($t->[0],".");
            my $l = ($ix > 0) ? substr($t->[0],$ix+1) : $t->[2];
            my $n = ($t->[1]) ? Util->shortHostname($t->[1]) : "T3";
            $dev->[$new_dev]{name}     = "$n-$l";
         } else {
            $dev->[$new_dev]{name}     = $xx;
         }
         $dev->[$new_dev]{active}   = 'Y';
         $dev->[$new_dev]{ip}       = $t->[2];
         $dev->[$new_dev]{ipno}     = $t->[0];
         $dev->[$new_dev]{host}     = $t->[1];
      }
      PDM::ConfigFile->write( $renv, $dev, $host,$notifs);
  } else {
    print "  *** No new devices were added ***\n";
  }
  print "</pre>";
}

#
# returns the a5000 that a slave has.
# response to a http request made by a master rasagent.

sub getDevices {
  my($q, $post, $util) =@_;
  my($l, $loc, @a, $out, $t);

  my(%F);
  if (open(O, $q->{file})) {
     while ($l = <O>) { 
       @a = split(/ +/, $l);
       $loc = $a[3];
       $loc = substr($loc,1) if (substr($loc,0,1) eq "[");
       chop($loc) if (substr($loc,-1) eq "]");
       next if ($loc =~ /^\s*$/);
       next if ($loc =~ /\:/);
       $F{$loc} = 1;
     }
     close(O);
     $out = ""; 
     foreach $t (sort keys %F) {
        
        my($ip) = Util->testIp($t,5);
        my($wwn) = Util->snmpWWN($ip);
        if (!$ip) {
           $out .= "ERR=cannot ping $t\n";
        } elsif (!$wwn) {
           $out .= "ERR=No wwn for $t, probably not a T3\n";
        } else {
           $out .= "OK=$t=$ip=$wwn\n";
        }
     }
     return "OK $out";
  } else {
     return "ERR $q->{file} $!";
  }
}

sub addDevice {
  my( $q) = @_;
  my($ho, $o, $err, $ipno, $x, $info);
  my($renv, $dev, $host,$notifs, $sel);

  print "\n";
  require "GUI/Devices.pm";
  if ($q->{ACTION} eq "Back") {
    GUI::Devices::list($q);
    return;

  } elsif ($q->{ACTION} eq " Add ") {
    my($active) = "Y";
    while (1) {
     if ($q->{name} eq "") {
        $err = &main::info("Device name is mandatory <br>Record not added!");
        last;
     } elsif (!$q->{ip}) {
        $err = &main::info("You must enter an IP address for this device-type <br>Record not added!");
        last;
     } else {
        if (!($ipno = Util->testIp($q->{ip}))) {
           $q->{ERR} = &main::info("Warning: Cannot ping this T3: $q->{ip}");
           $active = "N";
        }
        ($renv, $dev, $host,$notifs) =PDM::ConfigFile->read;
        my($wwn) = Util->snmpWWN($q->{ip});
        if (length($wwn) < 3) {
             print &main::info("Warning: Cannot get the WWN, this may not be a T3", "red");
        }

        foreach $x (@$dev) {
          if ($x->{name} eq $q->{name}) {
             $err = &main::info("Error: This Device Name is already used <br>Record not added!");
             goto out;
          } elsif ($wwn && $x->{wwn} eq "-$wwn") {
             $err = &main::info("Error: This WWN is already used <br>Record not added!");
             goto out;
          }
        }
            
        $x = $#$dev + 1;
        $dev->[$x]{_name}    = "device" . ($x+1);
        $dev->[$x]{type}     = "t3";
        $dev->[$x]{wwn}      = "-" . $wwn;
        $dev->[$x]{name}     = $q->{name};
        $dev->[$x]{active}   = $active;
        $dev->[$x]{ip}       = $q->{ip};
        $dev->[$x]{telnet}   = $q->{telnet};
        $dev->[$x]{ipno}     = $ipno;
        $dev->[$x]{host}     = $q->{host};
        $dev->[$x]{datahost}   = $q->{datahost};
        GUIAdmin->clearSlave($q->{host}, $host);

        if (!PDM::ConfigFile->write( $renv, $dev, $host,$notifs)) {
           print "Cannot write to ConfigFile<br>";
        } else {
           $info = &main::info("Device added!", "green");
        }

        GUI::Devices::list($q);
        return;
     }
     last;
    }
  }
out:
  my($h) = &main::header("Maintain Devices : Add T3");

  ($renv, $dev, $host,$notifs) =PDM::ConfigFile->read;
  $sel = ($q->{host} eq "")? "selected":"";


  my($phost) = "<select name=host><option value=\"\">[Select]</option>".
              "<option value=\"\" $sel>Local</option>";
  foreach $x (@$host) {
    $sel = ($q->{host} eq $x->{hostname})? "selected":"";
    $phost .= "<option value=" . $x->{hostname} . " $sel>" . $x->{hostname} ."</option>";
  }
  $phost .= "</select>";

  my($phostD) = "<select name=datahost>".  "<option value=\"\" $sel>Same Host</option>";
  my $l1 = {hostname => System->hostname(), ip => System->hostname()};
  foreach $x (@$host, $l1) {
    $sel = ($q->{datahost} eq $x->{ip})? "selected":"";
    $phostD .= "<option value=\"" . $x->{ip} . "\" $sel>" . $x->{hostname} ."</option>";
  }
  $phostD .= "<option value=\"*None\">*None</option></select>";

  $o =<<EOF;
<body bgcolor=$main'BGCOLOR>
<form  method=get>
 <input type=hidden name=GO value="GUIAdmin::T3::addDevice">
<center>
$h
$err
<table border=2 cellspacing=2 width=90% bgcolor=white><tr><td>
<table border=0 cellspacing=2 width=100%>
<tr><td colspan=2 bgcolor=#666699><b><font color=white>&nbsp;Enter Device Information</td>

<tr><td bgcolor=$main'LIGHT width=30% align=right>Device Name :</td>
    <td><input type=text name=name size=15 maxlength=35 value="$q->{name}">

<tr><td bgcolor=$main'LIGHT width=30% align=right>Telnet Password (optional):</td>
    <td><input type=password name=telnet size=20 maxlength=30 value="$q->{telnet}">

<tr><td bgcolor=$main'LIGHT align=right>Primary Host :</td>
    <td>$phost</td>
<tr><td bgcolor=$main'LIGHT align=right>Data-Path Host :</td>
    <td>$phostD</td>
<tr><td bgcolor=$main'LIGHT width=30% nowrap align=right> IP Name/Address :</td>
    <td><input type=text name=ip size=40 maxlength=40 value="$q->{ip}">

</table>
</table>
<b>
<input type=submit name=ACTION value=" Add ">
<input type=submit name=ACTION value="Back">
</form>
EOF

  print $o;

}

sub updDevice {
  my($q) = @_;
  my($ho, $o);
  my($name, $err, $ip, $ipno);
  my($renv, $dev, $host,$notifs, $x, $D, $type, $key, $h1, $h, $sel, $active);

  print "\n";
  require "GUI/Devices.pm";

  if ($q->{ACTION} eq "Back") {
    GUI::Devices::list($q);
    return;

  } elsif ($q->{ACTION} eq "Update") {
    ($renv, $dev, $host,$notifs) =PDM::ConfigFile->read;
    $x = $q->{no};
    $D = $dev->[$x];

    $dev->[$x]{host} = $q->{host};
    $dev->[$x]{datahost} = $q->{datahost};
    $dev->[$x]{name} = $q->{name};
    $dev->[$x]{telnet} = $q->{telnet};
    $dev->[$x]{hba}  = $q->{hba};
    GUIAdmin->clearSlave($q->{host}, $host);

    PDM::ConfigFile->write( $renv, $dev, $host,$notifs);
    $err = &main::info("Device $name updated!", "green");

  } elsif ($q->{ACTION} eq "Delete") {
    ($renv, $dev, $host,$notifs) =PDM::ConfigFile->read;
    $x = $q->{no};
    $type = $dev->[$x]{type};
    $key =  $dev->[$x]{ip};
    GUIAdmin->clearSlave($q->{host}, $host);

    &main::save_event("DD", $type,  $key) if ($key);
    $dev->[$x]{_name} = "";
    $name = $dev->[$x]{name} . "/ " . $dev->[$x]{ip};
    PDM::ConfigFile->write( $renv, $dev, $host,$notifs);
    &main::log_change("Device $name deleted");
    $q->{ERR} = &main::info("Device $name deleted!");
    GUI::Devices::list($q);
    return;
  }
out:

 $h1 = &main::header("Maintain Devices : Update T3");

  ($renv, $dev, $host,$notifs) = PDM::ConfigFile->read;
  $h = $dev->[$q->{no}];

  $ip = $h->{ip}; $ipno = $h->{ipno};

  $sel = ($h->{host})? "":"selected";

  $ho = "<select name=host><option value=\"\" $sel>Local</option>";
  foreach $h1 (@$host) {
       $sel = ($h1->{hostname} eq $h->{host}) ? "selected":"";
       $ho .= "<option name=$h1->{hostname} $sel>$h1->{hostname}</option>";
  }
  $ho .= "</select>";

  $sel = ($h->{datahost})? "":"selected";
  my($dataho) = "<select name=datahost><option value=\"\" $sel>Same Host</option>";
  my $l1 = {hostname => System->hostname(), ip => System->hostname()};
  foreach $h1 (@$host, $l1 ) {
       $sel = ($h1->{ip} eq $h->{datahost}) ? "selected":"";
       $dataho .= "<option value=\"$h1->{ip}\" $sel>$h1->{hostname}</option>";
  }
  $sel = ($h->{datahost} eq "*None")? "selected":"";
  $dataho .= "<option value=\"*None\" $sel>*None</option></select>";

  $active = ($h->{active} eq "Y") ? "On":"Off";


  $o =<<EOF;
<body bgcolor=$main'BGCOLOR>
<form  method=get>
 <input type=hidden name=GO value=GUIAdmin::T3::updDevice>
 <input type=hidden name=no value=$q->{no}>
<center>
$h1
$err
<table border=2 cellspacing=2 width=90% bgcolor=white><tr><td>
<table border=0 cellspacing=2 width=100%>
<tr>
<td colspan=2 bgcolor=#666699><b><font color=white>&nbsp;Device Information</td>

<tr><td bgcolor=$main'LIGHT align=right>Device Type :</td>
    <td>
      <table border=0 cellspacing=0 width=100%> <tr>
        <td><b>&nbsp;$h->{type}</td>
        <td bgcolor=$main'LIGHT align=right>Monitoring:</td>
        <td ><b>&nbsp;$active</td>
      </table>

<tr><td bgcolor=$main'LIGHT width=30% align=right>Device Name :</td>
    <td><input type=text name=name size=40 maxlength=40 value="$h->{name}">

<tr><td bgcolor=$main'LIGHT width=30% align=right>Telnet Password (optional):</td>
    <td><input type=password name=telnet size=20 maxlength=40 value="$h->{telnet}">

<tr><td bgcolor=$main'LIGHT width=30% nowrap align=right>IP Name/Address :</td>
    <td>&nbsp;$ip</td>
<tr><td bgcolor=$main'LIGHT width=30% nowrap align=right>IP Number :</td>
    <td>&nbsp;$ipno</td>

<tr><td bgcolor=$main'LIGHT align=right>WWN :</td>
    <td><b>$h->{wwn}</td>
<tr><td bgcolor=$main'LIGHT align=right>Primary Host :</td>
    <td><b>$ho</td>

<tr><td bgcolor=$main'LIGHT align=right>Data-Path Host :</td>
    <td><b>$dataho</td>

</table>
</table>
<b>

<input type=submit name=ACTION value="Update">
<input type=submit name=ACTION value="Delete">
<input type=submit name=ACTION value="Back">
</form>
EOF

  print $o;
}


1;

