package MessageHealth;
#  $Name:  $ 
#  $Id: MessageHealth.pm,v 1.6 2001/06/09 20:20:36 ccadieux Exp $


use base 'Health';
use Ilist;
use Message;
use Report;
use Catalog;
use Events;
use strict;
use Debug;

sub revision {'$Revision: 1.6 $'}

sub new {
  my($hm, $pdm) = @_;

  my($self) = {pdm => $pdm};
  bless ($self, 'MessageHealth');

# Registers for A5K/ T3 message Reports.
#
#                            HM  Callback,  Filters
  $pdm->reportRequest($self, 'all_logic' , {category => Report::CAT_MESSAGE});
  $pdm->reportRequest($self, 'all_logic' , {category => Report::CAT_T3MESSAGE});
  return $self;
}

#####################################################


sub all_logic {
  my($hm, $report) = @_;
  my($pdm) = $hm->{pdm};

  my($name)    =  $report->accessName();  # name of the A5K, by luxadm
  my $hostid   =  $report->deviceName(); 
  my($log)     = $report->log();
  my($id)      = $report->id('display');

  $hm->logEvent($log, $report, $hostid, "Message(s) found in logfile: ".
     $report->id("logFile") . " on $id:") if ($log);

}


1;
