package Julian;
#  $Name:  $ 
#  $Id: Julian.pm,v 1.2 2000/11/12 20:03:30 ccadieux Exp $


# 1998.11.16	Bug found by Scott D. Foster
#		when runing in ActiveStates build of Perl 5.0, Jul 10, 1998
#		on line 416 a warning occurs Parens missing around "my" 
# 1999.08.11	Bug found by Vince Bono
#		Routine doesn't know 29the februar
# $Log: Julian.pm,v $
# Revision 1.2  2000/11/12 20:03:30  ccadieux
# *** empty log message ***
#
# Revision 1.1.1.1  2000/11/12 19:50:15  ccadieux
#
# Revision 1.2  1999/08/30 14:49:11  n9523
# 29feb bug
#
# Revision 1.1  1999/03/24 14:15:56  n9523
# Initial revision
#

$VERSION = '$Id: Julian.pm,v 1.2 2000/11/12 20:03:30 ccadieux Exp $';

my $FDOW = xx_FDOW(1);  		# firstday of the week default monday
my $wgr = {
	it	=> 2299161,		# greogian jd
	al  	=> 2419739,
	at  	=> 2299527,
	be  	=> 2299171,
	bg 	=> 2420995,
	cn    	=> 2419403,
	cz 	=> 2299620,
	dk 	=> 2342032,
	"no"  	=> 2342032,
	eg   	=> 2405890,
	ee 	=> 2421595,
	fi 	=> 2361390,
	se  	=> 2361390,
	fr  	=> 2299227,
	de      => 2299970,
	ge_pru  => 2309345,
	ge_pro  => 2342032,
	gb 	=> 2361222,
	us	=> 2361222,
	gr	=> 2423868,
	hu 	=> 2301004,
	jp	=> 2405160,
	lv	=> 2421595,
	"lt" 	=>2420499,
	lu 	=> 2299232,
	"nl"    => 2299232,
	nl_nor  => 2342318,
	pl	=> 2299161,
	pt 	=> 2299161,
	ro 	=> 2422063,
	ru	=> 2421639,
	es 	=> 2299161,
	ch_cat  => 2299604,
	ch 	=> 2342349,
	ch_gal  => 2350738,
	"tr" 	=> 2424882,
	yu 	=> 2421960 };

my $greorg = $wgr->{it};
my $debug  = 0;			# do no debug

use overload
'-'	=>	\&subtract;

sub new {
	my ($proto,$param) = @_;
	my $class = ref($proto) || $proto;
	my $self = {
		JULIAN	 	=>	undef,
		YEARM		=>	undef,
		MONTH		=>	undef,
		YEARW		=>	undef,
		WEEKOFYEAR	=>	undef,
		NTHOFMONTH	=>	undef,
		DAYOFMONTH	=>	undef,
		DAYOFYEAR	=>	undef,
		DAYOFWEEK	=>	undef,
		WEEKBEGIN	=>	1,		# monday
		WEEKEND		=>	7,		# friday
		GREORG		=>	\$greorg,	# to the global set
		FDOW		=>	\$FDOW, 		# to the local set
		DEBUG		=>	\$debug
	};

	bless($self,$class);
	if (ref($param) eq 'HASH') { $self = $self->initjulian($param); }
	print STDERR "Julian: new: \n" if ($debug);
	return $self;
}

sub initjulian
{
	my ($self,$param) = @_;

	my $el;

	foreach $el (keys %$param) {
		print STDERR "JULIAN: initjulian: $el->",$$param{$el},"\n" if ($debug);
		if ($el =~ /^julian$/i) {
			$self->julian($$param{$el});
		} elsif ($el =~ /^debug$/i) {
			${$self->{DEBUG}} = $$param{$el};
			print STDERR "Julian: Debug on\n" if ($debug);
		} elsif ($el =~ /^year$/i) {
			$self->year($$param{$el});
		} elsif ($el =~ /^month$/i) {
			$self->month($$param{$el});
		} elsif ($el =~ /^nthofmonth$/i) {
			$self->nthofmonth($$param{$el});
		} elsif ($el =~ /^day$/i) {
			$self->day($$param{$el});
		} elsif ($el =~ /^week$/i) {
			$self->week($$param{$el});
		} elsif ($el =~ /^dayofyear$/i) {
			$self->dayofyear($$param{$el});
		} elsif ($el =~ /^dayofweek$/i) {
			$self->dayofweek($$param{$el});
		} elsif ($el =~ /^FDOW$/i) {
			${$self->{FDOW}}=xx_FDOW($$param{$el});
		} elsif ($el =~ /^greorg$/i) {
			if (defined($$wgr{$$param{$el}})) {
				${$self->{GREORG}}	=$$wgr{$$param{$el}};
			}
		} elsif ($el =~ /^weekbegin$/i) {
			$self->weekbegin($$param{$el});
		} elsif ($el =~ /^weekend$/i) {
			$self->weekend($$param{$el});
		}
	}
	return $self;

}

sub julian
{
	my $self = shift;
	print STDERR "JULIAN: julian: @_\n" if ($debug);
	if (@_) {
		$self->{JULIAN} = shift;
		($self->{YEARM},$self->{MONTH},$self->{DAYOFMONTH}) =
			J_ymd($self->{JULIAN});
		($self->{YEARW},$self->{WEEKOFYEAR},$self->{DAYOFWEEK}) =
			J_ywd($self->{JULIAN});
		($self->{YEARM},$self->{DAYOFYEAR}) =
			J_yday($self->{JULIAN});
		$self->{NTHOFMONTH} = 	int(($self->{DAYOFMONTH}-1)/7) + 1;
	}
	return $self->{JULIAN};
}


sub year
{
	my $self = shift;
	print STDERR "JULIAN: year: @_\n" if ($debug);
	if (@_) {
		$self->{YEARM} = shift;
		if (	defined($self->{MONTH}) and
			defined($self->{DAYOFMONTH})) {
			$self->julian(ymd_J(   $self->{YEARM},
				        $self->{MONTH},
					$self->{DAYOFMONTH}));
		} elsif (defined($self->{MONTH}) and
			defined($self->{NTHOFMONTH}) and
			defined($self->{DAYOFWEEK})) {
			$self->julian(ymnd_J(   $self->{YEARM},
				        $self->{MONTH},
					$self->{NTHOFMONTH},
					$self->{DAYOFWEEK}));
		}
	}
	return $self->{YEARM};
}

sub month
{
	my $self = shift;
	print STDERR "JULIAN: month: @_\n" if ($debug);
	if (@_) {
		$self->{MONTH} = shift;
		if (	defined($self->{YEARM}) and
			defined($self->{DAYOFMONTH})) {
			$self->julian(ymd_J(   $self->{YEARM},
				        $self->{MONTH},
					$self->{DAYOFMONTH}));
		} elsif (defined($self->{YEARM}) and
			defined($self->{NTHOFMONTH}) and
			defined($self->{DAYOFWEEK})) {
			$self->julian(ymnd_J(   $self->{YEARM},
				        $self->{MONTH},
					$self->{NTHOFMONTH},
					$self->{DAYOFWEEK}));
		}

	}
	return $self->{MONTH};
}


sub nthofmonth
{
	my $self = shift;
	print STDERR "JULIAN: nthofmonth: @_\n" if ($debug);
	if (@_) {
		$self->{NTHOFMONTH} = shift;
		if (	defined($self->{YEARM}) and
			defined($self->{MONTH}) and
			defined($self->{DAYOFWEEK})) {
			$self->julian(ymnd_J(   $self->{YEARM},
				        $self->{MONTH},
					$self->{NTHOFMONTH},
					$self->{DAYOFWEEK}));
		}
	}
	return $self->{NTHOFMONTH};
}

sub day
{
	my $self = shift;
	print STDERR "JULIAN: day: @_\n" if ($debug);
	if (@_) {
		$self->{DAYOFMONTH} = shift;
		if (	defined($self->{YEARM}) and
			defined($self->{MONTH})) {
			$self->julian(ymd_J(   $self->{YEARM},
				        $self->{MONTH},
					$self->{DAYOFMONTH}));
		}
	}
	return $self->{DAYOFMONTH};
}

sub ymd
{
	my $self = shift;
	print STDERR "JULIAN: ymd: @_\n" if ($debug);
	if (@_) {
		($self->{YEARM},$self->{MONTH},$self->{DAYOFMONTH}) = @_;
		$self->julian(ymd_J(   $self->{YEARM},
				        $self->{MONTH},
					$self->{DAYOFMONTH}));
		
	}
	return ($self->{YEARM},$self->{MONTH},$self->{DAYOFMONTH});
}


sub week
{
	my $self = shift;
	print STDERR "JULIAN: week: @_\n" if ($debug);
	if (@_) {
		$self->{WEEKOFYEAR} = shift;
		if (	defined($self->{YEARM}) and
			defined($self->{DAYOFWEEK})) {
			$self->julian(ywd_J(   $self->{YEARM},
				        $self->{WEEKOFYEAR},
					$self->{DAYOFWEEK}));
		}
	}
	return $self->{WEEKOFYEAR};
}

sub yearw
{
	my $self = shift;
	print STDERR "JULIAN: yearw: @_\n" if ($debug);
	return $self->{YEARW};
}

sub ywd
{
	my $self = shift;
	print STDERR "JULIAN: ywd: @_\n" if ($debug);
	if (@_) {
		($self->{YEARW},$self->{WEEKOFYEAR},$self->{DAYOFWEEK}) = @_;
		$self->julian(ywd_J(   $self->{YEARW},
				        $self->{WEEKOFYEAR},
					$self->{DAYOFWEEK}));
		
	}
	return ($self->{YEARW},$self->{WEEKOFYEAR},$self->{DAYOFWEEK});
}

sub weekbegin
{
	my $self = shift;
	print STDERR "JULIAN: weekbegin: @_\n" if ($debug);
	if (@_) {
		if ($_[0] >= 1 and $_[0] <= 7) {
			$self->{WEEKBEGIN}=$_[0];
		}
	}
	return $self->{WEEKBEGIN};
}

sub weekend
{
	my $self = shift;
	print STDERR "JULIAN: weekend: @_\n" if ($debug);
	if (@_) {
		if ($_[0] >= 1 and $_[0] <= 7) {
			$self->{WEEKEND}=$_[0];
		}
	}
	return $self->{WEEKEND};
}

sub dayofweek
{
	my $self = shift;
	print STDERR "JULIAN: dayofweek: @_\n" if ($debug);
	if (@_) {
		$self->{DAYOFWEEK} = shift;
		if (	defined($self->{YEARM}) and
			defined($self->{WEEKOFYEAR})) {
			$self->julian(ywd_J(   $self->{YEARM},
				        $self->{WEEKOFYEAR},
					$self->{DAYOFWEEK}));
		} elsif (defined($self->{MONTH}) and
			defined($self->{NTHOFMONTH}) and
			defined($self->{YEARM})) {
			$self->julian(ymnd_J(   $self->{YEARM},
				        $self->{MONTH},
					$self->{NTHOFMONTH},
					$self->{DAYOFWEEK}));
		}
	}
	return $self->{DAYOFWEEK};
}

sub dayofyear
{
	my $self = shift;
	print STDERR "JULIAN: dayofyear: @_\n" if ($debug);
	if (@_) {
		$self->{DAYOFYEAR} = shift;
		if (	defined($self->{YEARM}) ) {
			$self->julian(yday_J(   $self->{YEARM},
					$self->{DAYOFYEAR}));
		}
	}
	return $self->{DAYOFYEAR};
}

sub subtract
{
	my($a,$b)=@_;
	print STDERR "JULIAN: $b - $a\n" if ($debug);
	my $v;
	if (defined($a->{JULIAN}) and defined($b->{JULIAN})) {
		$v = d_J_J($b->julian(),$a->julian(),$a->weekbegin(),$a->weekend());
	}
	$v;
}

sub add
{
	my $self = shift;
	my($addit,$type)=@_;
	print STDERR "JULIAN: +: $self + $addit, $type\n" if ($debug);
	my($jul);
	if (not ref($addit)) {
		if ($type eq "" or $type =~ /^d/i) {
			$jul = int_jd_ymd($self->julian(),$addit,$self->weekbegin(),$self->weekend());	
			$self->julian($jul);
		} elsif ($type =~ /^w/i) {
			$jul = int_jd_ymd($self->julian(),$addit*7,1,7);	
			$self->julian($jul);
		} elsif ($type  =~ /^m/i) {
			if (defined($self->month) and defined($self->year)) {
				my($m, $diff);
				$m = $self->month + $addit - 1; # use module function
				$diff = int($m/12); if ($m < 0) {$diff--; }
				$self->month(($m % 12) + 1);	
				$self->year($self->year + $diff);
			}
		} elsif ($type =~ /^y/i) {
			if (defined($self->year)) {
				$self->year($self->year + $addit);
			}
		}								
	}
	$self;
}


sub copy
{
	my $self = shift;
	print STDERR "JULIAN: copy: $self\n" if ($debug);
	my $d;
	$d = new Julian( {julian=>$self->julian,
			  year=>$self->year,
			  month=>$self->month,
			  day=>$self->day,
			  week=>$self->week,
			  dayofyear=>$self->dayofyear,
			  dayofweek=>$self->dayofweek,
			  weekbegin=>$self->weekbegin,
			  nthofmonth=>$self->nthofmonth,	
		          weekend=>$self->weekend} );
	return $d;
}

# normal routines

sub xx_FDOW
{
	print STDERR "JULIAN: xx_FDOW\n" if ($debug);
	int(8-shift) % 7;
}


sub xx_dayofweek
{
	my($jul,$j);
	$jul = shift;
	print STDERR "JULIAN: xx_dayofweek: $jul\n" if ($debug);

	$j = int(($jul + $FDOW) / 7);
	$jul - $j*7 + 1 + $FDOW;
}

sub c_greorg
{
	my($jul,$year,$month,$day);
	my($dayfb, $century);

	$jul = shift;
	print STDERR "JULIAN: c_greorg: $jul\n" if ($debug);

	if ($jul >= $greorg)
	{
		$dayfb = $jul - 1721119;
		$century = int(($dayfb * 4 - 1) / 146097);
		$jul += +$century - int($century/4) - 2;
	}
	$jul -= 1721117;
	$year = int(($jul * 4) / 1461);
	$day  = $jul - int(1461 * $year / 4);
	if ($day == 0) {	# bug found on 11/8/1999 by Vince Bono
		$year--;
		$day  = $jul - int(1461 * $year / 4);
	}
        $month = int(($day * 10 - 5) / 306);
	$day  -=  int((306 * $month + 5) / 10);
	if ($month < 10)
	{
		$month += 3;
	} else {
		$month -= 9;
		if ($month < 3) { $year++; }
	}
	($year,$month,$day);
}

sub xx_julian
{
	my($jul);
	my($year, $month, $day)=@_;
	print STDERR "JULIAN: xx_julian: $year,$month,$day\n" if ($debug);

	if ($month > 2) {
		$month -= 3;
	} else {
		$month += 9;
		$year--;
	}

	$jul =  $day
		+ int((306 * $month + 5) / 10)
		+ $year * 365 + int($year / 4)+
		1721117;
	if ($jul >= $greorg)
	{
		$jul += -int($year/100) + int($year/400) + 2;
	}
	($jul);
}

sub ymd_J
{
	xx_julian(@_);
}

sub ymnd_J
{
	my($year,$month,$nth,$wday)=@_;
	my($j,$diff);
	print STDERR "JULIAN: ymnd_J: $year,$month,$nth,$wday\n" if ($debug);
	
	$j=xx_julian($year,$month,1);
	$diff=$wday - xx_dayofweek($j);
	if ($diff < 0) {$diff +=7; }
	$j + ($nth - 1) * 7 + $diff;
}

sub yday_J
{
	my($year,$day)=@_;
	print STDERR "JULIAN: yday_J: $year,$day\n" if ($debug);
	(xx_julian($year,1,1) + $day - 1);
}

sub ywd_J
{
	my($year, $week, $day)=@_;
        my($jul, $dof11);

	$jul = xx_julian($year,1,1);
	$dof11 = xx_dayofweek($jul);
	$jul += $week * 7 + $day - $dof11;
	if ($dof11 < 5) { $jul -= 7; }
	($jul);
}

sub J_ymd
{
	c_greorg(shift);
}

sub J_yday
{
	my($jul)=@_;
	my($year,$day,$month);

	print STDERR "JULIAN: yday: $jul\n" if ($debug);

	($year,$month,$day)= c_greorg($jul);
	$day = $jul - xx_julian($year, 1, 1) + 1;
	($year,$day);
}

sub J_wknr
{
	my($jul,$year)=@_;
        my($week, $dayofwk);
	my($j11, $dof11, $dnr);

        $j11      = xx_julian($year, 1, 1);
	$dof11    = xx_dayofweek($j11);
	$dnr      = $jul - $j11 + 1;
	$dnr     += $dof11 - 2;
	$week     = int($dnr / 7);
	$dayofwk  = $dnr - $week * 7 + 1;
	if ($dof11 < 5) { ($week)++; }
        ($week, $dayofwk);
}

sub J_ywd
{
	my($jul)=@_;
	my($year, $week, $day);
	my($month);

	($year,$month,$day)=c_greorg($jul);
        ($week, $day)=J_wknr($jul,$year);
	if ($week == 0) {
		$year--;
		($week, $day)=J_wknr($jul,$year);
	} else {
		if ($week >= 53)
		{
                	if (xx_dayofweek(xx_julian($year + 1, 1, 1)) < 5)
			{
				$week = 1;
				$year++;
			}
		}
	}
	($year,$week,$day);
}

sub d_J_J
{
	my($jul1, $jul2, $week_b, $week_e)=@_;
	my($weeks, $exch);
	my($sign, $dj1, $dj2, $end_W, $beg_W);

	if ($jul1 < $jul2) {
		$sign = 1;
	} else {
		$sign = -1;
		$exch = $jul1;
		$jul1 = $jul2;
		$jul2 = $exch;
	}
	$dj1 = xx_dayofweek($jul1);
	$dj2 = xx_dayofweek($jul2);
	$weeks = int(($jul2 - $jul1) / 7);
	$weeks *= ($week_e - $week_b + 1);
	if ($dj1 <= $dj2)
	{
		if ($dj1 < $week_b) {
			$beg_W = $week_b;
		} else {
			$beg_W = $dj1;
		}
		if ($dj2 > $week_e) {
			$end_W = $week_e + 1;
		} else {
			$end_W = $dj2;
		}
		if ($dj2 < $week_b || $dj1 > $week_e) {
			$end_W = 0;
		} else {
			$end_W = $end_W - $beg_W;
		}
	}
	else
	{
		if ($dj1 < $week_b || $dj2 > $week_e) {
			$end_W = $week_e - $week_b + 1;
		} else {
			if ($dj1 > $week_e) {
				if ($dj2 < $week_b) {
					$end_W = 0;
				} else {
					$end_W = $dj2 - $week_b;
				}
			} else {
				if ($dj2 < $week_b) {
					$end_W = $week_e - $dj1;
				} else {
					$end_W = $week_e - $dj1 + 1 + $dj2 - $week_b;
				}
			}
		}
	}
	(($weeks + $end_W) * $sign);
}



# INTERVAL FROM JULIAN DATE DAYS ADDED TO DAT1


sub int_jd_ymd
{
	my($jul1, $addday,$week_b, $week_e)=@_;
	my($weeks,$diffday,$restday);
	my($dayofwk,$julian_rest, $days);

	$dayofwk = xx_dayofweek($jul1);
	$diffday = ($week_e - $week_b + 1);
	if ($diffday == 0) {$diffday = 0.0001; }	# very rare

        if ($addday >= 0)  {
            $weeks   = int($addday / $diffday);
            $restday = $addday - int($diffday * $weeks);
        } else {
            $weeks    = int(-$addday / $diffday ) + 1;
            $restday  = int($diffday * $weeks) + $addday;
            $weeks    = -$weeks;
	}

        if ($restday == 0) {
            $weeks--;
            $restday = int($diffday);
	}

        $julian_rest = $week_e - $dayofwk;
        if ($julian_rest < 0) {
              $days = $julian_rest;
        } else {
              if ($week_b > $dayofwk) {
                 $days = $week_b - $dayofwk + $restday - 1;
              } else {
                 $days = 0;
	      }
	}
 
        $julian_rest -= $restday;
      
        if ($julian_rest < 0) {
              $weeks++;
              $julian_rest = $restday - $diffday + $days;
        } else {
              if ($days == 0) {
                 $julian_rest = $restday;
              } else {
                 $julian_rest = $days;
	      }
	} 	
   
        $jul1 += (7 * $weeks + $julian_rest);



	return $jul1;
}

1;
__END__

=head1 NAME

Julian - Module to manipulate Calendar data using the Julian Date

=head1 SYNOPSIS

          use Julian;
          
          # Example 1
          # Create a new Date
           
              $dat = new Julian;
            
          # Fill it with year, month and day; 
             
              $dat->year(1998);
              $dat->month(10);
              $dat->day(24);
          
          # What's the weeknumber and the day of the week
          
              $week = $dat->week;		# contains the weeknumber
              $dofw = $dat->dayofweek;	# contains the dayofweeknumber 1=monday
          
          
          # Example 2
          # Create 2 different dates
          # dat1 and dat2
          
              $dat1 = new Julian( { year=>1998,
          			  month=>10,
          			  day=>24,
          			  weekbegin=>1,	# begin of the week monday
          			  weekend=>5	# end the week friday
          			 } );
          
              $dat2 = new Julian( { year=>1998,
          			  week=>12,
          			  dayofweek=>3});
              $diff = $dat1 - $dat2;	# what is the difference in working days
          
          
          # Example 3
          # Calculate the second tuesday in september in the year 1998
          #
          	$dat3 = new Julian( { 	year=>1998,
          			      dayofweek=>2,
          			      month=>9,
          			      nthofmonth=>2});
          
          	print "Year:  ",$dat3->year,"\n";
          	print "Month: ",$dat3->month,"\n";
          	print "Day:   ",$dat3->day,"\n";
          
          # Example 4
          # And add now 30 month to it
          #
          	$dat3->add(30,'months');
          
          	print "Year:  ",$dat3->year,"\n";
          	print "Month: ",$dat3->month,"\n";
          	print "Day:   ",$dat3->day,"\n";
          
          # Example 5
          # Calculate the day when knowing the year week and dayofweek number
          
          $dat4 = new Julian( { year=>1998,
          		      week=>40,
          		      dayofweek=>7} );
          	print "Year:  ",$dat4->year,"\n";
          	print "Month: ",$dat4->month,"\n";
          	print "Day:   ",$dat4->day,"\n";
          
      


=head1 DESCRIPTION

This module based on the Calendar FAQ, v. 1.7. from Claus Tondering.
It provides all kind of date manipulations including an overload of a subtraction between
two dates.

=head1 OVERVIEW

The Gregorian calendar is the one commonly used today. It was proposed by
Aloysius Lilius, a physician from Naples, and adopted by Pope Gregory XIII 
in accordance with instructions from the Council of Trent to correct for
errors in the older Julian Calendar. It was decreed by Pope Gregory in a papal
bull in February 1582.

In the Gregorian calendar, the tropical year is approximated as 365 97/400 days.

The Julian period (and the julian day number) must not be confused with the
Julian calendar.

The French scholar Joseph Justus Scaliger was interested in assigning a positive
number to every year without having to worry about BC/AD. He invented what is today 
known as the "Julian Period"

Scaliger's Julian period starts on 1 Janary 4713 BC (Julian Calendar) and lasts 
for 7880 year.

Remark: The Julian calendar started 45 BC. Before that date the people in Rom are
using an Roman calendar. But this calendar was a mess. So don't use date's before 45 BC.

=head1 CONSTRUCTOR

=over 4

=item new ([OPTIONS])

This is the constructor for a new Julian object. 

C<OPTIONS> are passed in a hash like fashion, using key and value pairs.
Possible options are:

B<Year> - The year number of the year 

B<Month> - The month number. 1 = January, 12 = December

B<Day>   - The day number within the month. From 1 till max 31.

B<Week>  - The week number within the year

B<DayofYear> - The Day of the Year. From 1 till max 366.

B<Dayofweek> - The Day of the week. From 1 till 7. (Monday till Sunday)

B<NthOfMonth> - The Nth week of the Month

B<Greorg> - When did the gregorian date starts in that country
	Possible entries are: (iso language code)


	it	al  	at	be 	bg 	cn    	cz 	dk 	
	no  	eg   	ee 	fi 	se  	fr  	de      ge_pru  
	ge_pro  gb 	us	gr	hu 	jp	lv	lt 	
	lu 	nl    nl_nor  	pl	pt 	ro 	ru	es 	
	ch_cat  ch 	ch_gal  tr 	yu 	


	_nor = nothern
	_cat = catholic
	_pro = protestant
	_gal = st_gallen
	_pru = prussia

by default: it (italy). (language codes are case sensitive)


B<Fdow> - First day of the week (by default is monday), Specify

		1 for monday
		2 for tuesday
		..
		7 for sunday

B<Weekbegin>	From what begin day of week do you want to count (in the subtract and
		add function)

B<Weekend>	Idem as in weekbegin

=back

=head1 METHODS

=over 4

=item year ([number])

To set/read the year number

=item month ([number])

To set/read the month number (1 to 12)

=item day ([number]) 

To set/read the day number in the month

=item nthofmonth ([number]) 

To set/read the nth week occurence from dayofweek in the current month

=item ymd ([number,number,number]) 

To set/read the year,month,day at once.

=item week ([number])

To set/read the week number

=item yearw

To read the year week number (in some case it's different from the year (week 1 of week 52 or 53

=item dayofweek ([number])

To set/read the dayofweeknumber (1 to 7)

=item ywd ([number,number,number]) 

To set/read the yearw,week,dayofweek at once.

=item dayofyear ([number])

To set/read the dayofyear

=item weekbegin ([number])

To set/read the week begins (nescessary for the subtract or add function) by default 1.

=item weekend ([number])

To set/read the week ends    (nescessary for the subtract or add function) by default 7.

=item subtract

It subtract two dates.
Use it with '-' sign

=item add ([number [,type]])

It add the number of days [type] to the date. When negative it is subtracting the 
number of days [type] from the date.
The type is optional. When not specified it is days. It could be: days, weeks, months or
years.
When calculating with the type days you could use the parameters weekbegin and weekend
	
=item copy ( date )

It copies a date.

=back


=head1 REPORTING BUGS

When reporting bugs/problems please include as much information as possible.
It may be difficult for me to reproduce the problem as almost every setup
is different.

A small script which yields the problem will probably be of help. It would
also be useful if this script was run with the extra options C<Debug => 1>
passed to the constructor, and the output sent with the bug report. 
If you cannot include a small script then please include a 
Debug trace from a run of your program which does yield the problem.

=head1 AUTHOR

Bert Tijhuis  

mailto: bert_tijhuis@wavin.com

=cut
