package NWS;
#  $Name:  $ 
#  $Id: NWS.pm,v 1.7 2001/06/07 15:42:32 ccadieux Exp $

use Util;
use System;
use CIM::Instance;

use System;
use NWS::Schema;

%MAP = (S => 'string', B => 'boolean', I => 'uint32', I64 => 'uint32', E => 'uint32', D => 'datetime', R => 'reference');

sub check_type {
  my($class, $type) = @_;
  return (index(",boolean,string,char16,uint8,sint8,uint16,sint16,uint32,sint32,uint64,sint64,datetime,real32,real64,", ",$type,") >= 0) ;
}


sub cim_today {
  my($class) = @_;
  return System->cim_today;
}

sub todayValue {
  my($class, $date) = @_ ;
  return  CIM::Value->new(Value => System->cim_today, Type => CIM::DataType::datetime);
}


sub location {
  my($class, $rep, $cim) = @_;
  my($l1);

  $cim = "NWS_Location" if (!$cim);

  $l1 = CIM::Instance->new($cim, [
                  [Name                 => $rep->get("location.customerName") ],
                  [PhysicalPosition     => $rep->get("location.hostId")],
                  [CustomerNo           => $rep->get("location.customerNo")],
                  [ContractNo           => $rep->get("location.contractNo")],
                  [SiteName             => $rep->get("location.siteName")],
                  [SiteAddress          => $rep->get("location.siteAddress")],
                  [SiteCity             => $rep->get("location.siteCity")],
                  [SiteState            => $rep->get("location.siteState")],
                  [SiteCountry          => $rep->get("location.siteCountry")],
                  [SiteZip              => $rep->get("location.siteZip")],
                  [SiteContact          => $rep->get("location.siteContact")],
                  [SiteEmail            => $rep->get("location.siteEmail")],
                  [Ticker               => $rep->get("location.ticker")],
                  [Production           => $rep->get("location.production")],
                  ]);

  return $l1;
}


1;
