package NWS::Host;
#  $Name:  $ 
#  $Id: Host.pm,v 1.5 2001/03/15 17:01:32 ccadieux Exp $

use Report;
use CIM::Instance;
use Data::Dumper;
use strict;
use Ilist;
use PDM;
use NWS;
sub revision {'$Revision: 1.5 $'}

sub newSystem {
  my ($class, $rep1) = @_;

  my($rep) = System->hostInfo();

  my($p1) = CIM::Instance->new('NWS_Host',[
                    [Name 				  => $rep->{hostid}     ],
                    [OtherIdentifyingInfo => ""], 
                    [HostId 			  => $rep->{hostid}    ],
                    [SysRevision          => $rep->{os}        ],
                    [Caption              => "Host"            ],
                    [IP                   => $rep->{ip}        ],
                    [HostName             => $rep->{hostname}  ],
                    [CPUCount             => $rep->{cpus}  ],
                    [MemorySize           => $rep->{memory}    ],
                    [Domain               => $rep->{domain}    ],
                    [HostInfo             => $rep->{hostinfo}  ],
                    [Model                => $rep->{model}     ],
                ]);

  my($p2) = CIM::Instance->new('CIM_OperatingSystem',[
                    [CSName 	 => $rep->{hostid}      ],
                    [Name   	 => $rep->{hostid}      ],
                    [OS          => $rep->{os}          ],
                    [Version     => $rep->{os_version}  ],
                    [CurrentTimeZone    => $rep->{tz}   ],
                    [TotalSwapSpaceSize => $rep->{swap} ],
                ]);
  my($site) = NWS->location($rep1, "NWS_Site");
 
  my($hostsite) = CIM::Instance->new('NWS_HostOnSite', [
                  [Host  => $p1],
                  [Site  => $site],
                  ]);
  

  my($a1) = CIM::Instance->new('CIM_RunningOS', [
                  [Dependent    => $p1],
                  [Antecedent   => $p2],
                  ]);

  my(@pil) = ($p1, $p2, $a1, $site, $hostsite);
  return Ilist->new(\@pil);

}

1;
