package SCH_Events;
#  $Name:  $ 
#  $Id: SCH_Events.pm,v 1.3 2001/02/16 19:32:49 ccadieux Exp $

sub revision {'$Revision: 1.3 $'}


%Schema = (

   NWS_Event        => [{ type => 'E',parent =>  0}, [
			[EventId          => S,K],
			[EventType        => S,K, CLASSNAME ],
			[EventTime        => D,0, NOW       ],
            [Version          => S,0, "1.1"     ],
			[FilterName       => S,0, "NWS"     ],
			[EventSourceType  => S,0, "rasagent"],
			[EventGroupId     => S,0, "NWS"     ],
			[DataType         => S,0, "text"    ],
			[Data			  => S,0, ""        ],
			[Description      => S,0, ""        ],
			[Actionable       => B,0 ,'FALSE'   ],
			]],

   ComponentAssoc       => [{type => 'A',parent =>  0}, [
             [whole     => R => 'Element'],
             [part      => R => 'Element'],
             [slot     =>  S],
               ]],


   NWS_ActionStartEvent => [{ type => 'E', parent => 'NWS_Event'}, [
			[ActionPerformed  => I],
			[Remote           => B],
			[InitiatedBy      => S],
			]],

   NWS_ActionEndEvent   => [{ type => 'E', parent => 'NWS_Event'}, [
			[ActionPerformed  => E,0],
			[CompletionStatus => E,0],
			[StartEventId     => S],
			]],

   NWS_ConfigurationStartEvent => [{ type => 'E', parent => 'NWS_ActionStartEvent'}, [
			[ConfigurationType      => I],
			[ConfigurationsSelected => S],
			]],

   NWS_ConfigurationEndEvent => [{ type => 'E', parent => 'NWS_ActionEndEvent'}, [
			    ]],

   NWS_DiagnosticActivationEvent  => [{ type => 'E', parent => 'NWS_ActionStartEvent'}, [
			[DiagnosticId       => S],
			[Version			=> S],
			[IsolationTechnique => S],
			]],

   NWS_DiagnosticTestSuiteStarted => [{type => 'E', parent => 'NWS_ActionStartEvent'}, [
			 [TestSuite          => S],
			 [TestSuiteType      => S],
			 [Online			 => B],
			 [Iterations         => I],
			    ]],

   NWS_DiagnosticTestStarted => [{type => 'E', parent => 'NWS_ActionStartEvent'}, [
			 [Test			   => S],
			 [TestType           => S],
			 [Online			 => B],
			 [Iterations         => I],
			    ]],

   NWS_DiagnosticDeactivationEvent => [{type => 'E', parent => 'NWS_ActionEndEvent'}, [
			 [DiagnosticId       => S],
			 [Version			=> S],
			 [Result			 => S],
			    ]],

   NWS_DiagnosticTestComplete      => [{type => 'E', parent => 'NWS_ActionEndEvent'}, [
			 [Test			   => S],
			 [TestType           => S],
			 [Status			 => S],
			 [FailureCode        => S],
			 [ExpectedResult     => S],
			 [ActualResult       => S],
			 [ConfidenceLevel    => S],
			    ]],

   NWS_DiagnosticTestSuiteComplete => [{ type => 'E', parent => 'NWS_ActionEndEvent'}, [
			 [TestSuite          => S],
			 [TestSuiteType      => S],
			 [FailureCode        => S],
			 [ExpectedResult     => S],
			 [ActualResult       => S],
			 [SessionLog         => S],
			 [ConfidenceLevel    => S],
			   ]],


  NWS_Agent => [{ type => 'O', parent => 'NWS_SoftwareElement'}, [
			 [IdentificationCode    => S, 0 , "RASAgent"],
			   ]],

  NWS_EventDetector   => [{type => 'A', parent => 0},[
			 [Event   => R, 'NWS_Event'],
			 [Agent   => R, 'NWS_Agent'],
			   ]],
        
  NWS_EventSoftwareSource => [{type => 'A', parent => 0},[
			 [Event   => R, 'NWS_Event'          ],
			 [Source  => R, 'NWS_SoftwareElement'],
			   ]],

  NWS_EventDeviceSource => [{type => 'A', parent => 0},[
			 [Event   => R, 'NWS_Event'        ],
			 [Source  => R, 'CIM_LogicalDevice'],
			   ]],
			 
   NWS_EventPertainsToLogicalDevice => [{type => 'A',parent =>  0}, [
			 [Event         => R => 'NWS_Event'],
			 [LogicalDevice => R => 'CIM_LogicalDevice'],
			  ]],

   NWS_EventPertainsToSystem => [{type => 'A',parent =>  0}, [
			 [Event      => R => 'NWS_Event'],
			 [Element    => R => 'CIM_UnitaryComputerSystem'],
			  ]],

   NWS_EventPertainsToPhysicalElement => [{type => 'A', parent =>  0}, [
			 [Event      => R => 'NWS_Event'],
			 [Element    => R => 'CIM_PhysicalElement']
			    ]],

   NWS_EventPertainsToSoftwareElement => [{type => 'A',parent =>  0}, [
			 [Event      => R => 'NWS_Event'],
			 [Element    => R => 'CIM_SoftwareElement']
			    ]],

   NWS_EventPertainsToLocation => [{type => 'A',parent =>  0}, [
			 [Event      => R => 'NWS_Event'],
			 [Element    => R => 'CIM_Location']
			    ]],
     

   CIM_AlertIndication  => [{type => 'E',parent =>  0}, [
			 [EventTime        => D, 0, NOW     ],
			 [FilterName       => S, 0, ""      ],
			 [Description      => S, 0, "Alert" ],
			 [Severity         => I, 0, 1       ],
			 [ProbableCause    => S],
			 [RecommendedAction=> S],
			    ]],

   NWS_AlertIndication  => [{type => 'E', parent => 'CIM_AlertIndication'}, [
			 [AlertType        => I, 0, "SRS" ],
			 [AlertId          => S, 1 ],
			    ]],

   NWS_AlertPertainsToEvent  => [{type => 'A',parent =>  0}, [
			 [Alert      => R => 'NWS_AlertIndication'],
			 [Event      => R => 'NWS_Event'],
			    ]],

   NWS_AlertPertainsToSystem => [{type => 'A',parent =>  0}, [
			 [Alert      => R => 'NWS_AlertIndication'],
			 [System     => R => 'CIM_UnitaryComputerSystem'],
			    ]],

   NWS_AlertPertainsToLogicalDevice => [{type => 'A',parent =>  0}, [
			 [Alert          => R => 'NWS_AlertIndication'],
			 [LogicalDevice  => R => 'CIM_LogicalDevice'],
			    ]],

   NWS_AlertSoftwareSource    => [{type => 'A',parent =>  0}, [
			 [Event          => R => 'NWS_Event'],
			 [Source         => R => 'NWS_SoftwareElement'],
			    ]],

   NWS_AlertDeviceSource    => [{type => 'A',parent =>  0}, [
			 [Event          => R => 'NWS_Event'],
			 [Source         => R => 'CIM_LogicalDevice'],
			    ]],
     
   NWS_HeartbeatEvent          => [{type => 'E', parent => 'NWS_Event'}, [
			 [Interval       => I],
			    ]],

   NWS_ThresholdEvent          => [{type => 'E', parent => 'NWS_Event'}, [
			 [Name			 => S],
			 [Value			=> I64],
			 [LimitMax         => I64],
			 [LimitMin         => I64],
			 [Rate			 => I64],
			    ]],

   NWS_CommunicationLostEvent    => [{type => 'E', parent => 'NWS_Event'}, [
			 [Method           => I],
			 [Timeout          => I64],
			    ]],

   NWS_CommunicationEstablishedEvent  => [{type => 'E', parent => 'NWS_Event'}, [
			 [Method           => I],
			   ]],

   NWS_StateChangeEvent        => [{type => 'E', parent => 'NWS_Event'}, [
			 [CurrentState     => I],
			 [PriorState       => I],
			    ]],


   NWS_PolicyChangeEvent       => [{type => 'E', parent => 'NWS_Event'}, [
			 [OldPolicy        => S],
			 [NewPolicy        => S],
			   ]],

   NWS_EventPertainsToContainer => [{type => 'A',parent =>  0}, [
			 [Event          => R => 'NWS_Event'],
			 [Association    => R => 'CIM_Container'],
			 [DiscoveryType  => S],
			    ]],


);

sub getSchema { return \%Schema }
          
1;
