package ORA;
#  $Name:  $ 
#  $Id: ORA.pm,v 1.2 2000/11/12 20:03:32 ccadieux Exp $

use Oraperl;

$errstr       = "";
$LDA          = undef;
$LDA_DNS      = undef;
$SAFE_SQL     = "select sysdate from dual";

sub login {
  my($DNS,$lda_p) = @_;
  my($O);
  $O = &ora_login("",$DNS,"") ;
  $LDA_DNS = $DNS;
  if (defined($O)) {
     $$lda_p = $O;
     $LDA = $lda_p;
     return $O;
  } else {
     $$lda_p = undef;
     $errstr = $ora_errstr;
     return undef;
  }
}


sub commit {
  my($O) = @_;
  &ora_commit($O);
}

sub rollback {
  my($O) = @_;
  &ora_rollback($O);
}
  
sub logoff {
  my($O) = @_;
  &ora_logoff($O);
}

sub open {
  my($O,$sql) = @_;
  my($O2, $csr);

  eval {$csr = &ora_open($O,$sql)};
  if (defined($csr)) {
    return $csr;
  } else {
    $errstr = $ora_errstr;
    eval {$csr = &ora_open($O, $SAFE_SQL)};
    if (!defined($csr)) {                        # really bad
       eval{ &ora_logoff($O) };
       $O2 = &ora_login("",$LDA_DNS,"");         # try to re-login
       if (defined($O2)) {
           $$LDA = $O2;
           if ($csr = &ora_open($O2,$sql)) {
              return $csr;
           } else {
              return undef;
           }
       } else {
           $errstr = "Cannot connect to Oracle DB";
           return undef;
       }
    }
    return undef;  # return cursor;
  }
}

sub do {
  my($O, $sql) = @_;
  if (&ora_do($O,$sql)) {
     return $O;
  } else {
     $errstr = $ora_errstr; 
     return undef;  # return cursor;
  }
}
sub ll {
  my($mess) = @_;
  open(OO,">>/home/is/ccadieux/WEB/CMGR/exe/log"); print OO "$mess\n"; close(OO);
}

sub close {
  my($O) = @_;
  &ora_close($O) if ($O);
}


sub fetch {
  my($CSR, @Results)= @_;
  if ($CSR) {
     return (&ora_fetch($CSR));
  } else {
     return ();
  }
}

sub build_insert {
  my($table,@f) = @_;
  my($sql, $x);
  $sql = "insert into $table values (";
  foreach $x (@f) {
     $x1 = $x; $x1 =~ s/'/''/g;
     if (substr($x1,0,1) eq "~") {
        $sql .= substr($x1,1) . ",";
     } else {
        $sql .= "'$x1',";
     }
  }
  chop($sql);
  $sql .= ")";
  $sql;
}

sub fetch_field_names {
  my($CSR)= @_;
  my(%h, @a,$x, $cnt);
  @a = &ora_titles($CSR);
  $cnt = 0;
  foreach $x (@a) {
     $h{$x} = $cnt;
     $cnt++;
  }
  return \%h;
}


sub fetch2 {
  my($CSR, $list)= @_;
  my(@f, @data, %r, $x);
  $list =~ s/to_char\([^\)]+\)\s+(\w+)/$1/sg;
  @f = split(/\s*,\s*/, $list);

  if (@data = &ora_fetch($CSR)) {
    for ($x=0; $x<= $#f; $x++) {
       $r{$f[$x]} = $data[$x];
    }
    return \%r;
  } else {
    return 0;
  }
}
sub fetch3 {
  my($CSR, $list)= @_;
  my(@f, @data, %r, $x, $i);
  $list =~ s/to_char\([^\)]+\)\s+(\w+)/$1/sg;
  @f = split(/\s*,\s*/, $list);

  if (@data = &ora_fetch($CSR)) {
    for ($x=0; $x<= $#f; $x++) {
       $i = $f[$x]; $i =~ s/\./_/;
       $r{$i} = $data[$x];
    }
    return \%r;
  } else {
    return 0;
  }
}
1;

