package PDM::Catalog;
use Data::Dumper;
use System;
use Util::Http;
use Util;

%CATALOG;

sub revision {'$Revision: 1.2 $'}

sub read {
 my($class) = @_;
 my($VAR1);

 $m = Util->findMaster();
 %CATALOG = ();
 my(@lines);

 if (!$m) {  # catalog is local
   my($file) = System->get_home() . "/DATA/Catalog";
   open(O, $file);
   while ($l = <O>) {
     chop($l);
     push(@lines, $l);
   }
   close(O);
 } else {  # get from the master if you are a slave
   $url = Util->makeUrl($m, "?GET=FILER&file=Catalog");
   $rc = Util::Http->get($url, 20);
   my($f2) = System->get_home() . "/DATA/Catalog.slave";
   if (!$rc) {
     if (open(O, $f2)) {
       while ($l = <O>) {
         chop($l);
         push(@lines, $l);
       }
       close(O);
     }
   } else {
     @lines = split(/\n/, $rc);
   }
 }
 foreach $l (@lines) {
   @a = split(/=/, $l);
   if ($a[0]) {
     $CATALOG{$a[1]}{$a[2]}{$a[0]} = $a[3];
   }
 }
}

sub write {
 my($class) = @_;

 $m = Util->findMaster();
 $wfile =  System->get_home() . "/DATA/Catalog";
 $wfile .= ".slave" if ($m);
 my($host) = System->hostname();

 my($out);
 if (open(O, ">$wfile")) {
   foreach $a1 (sort keys %CATALOG) {
      $p = $CATALOG{$a1};
      foreach $a2 (sort keys %$p) {
        $p2 = $p->{$a2};
        foreach $a3 (sort keys %$p2) {
           if ($a3) {
             $l = "$a3=$a1=$a2=$p2->{$a3}\n";
             $out .= $l if ($a3 eq $host);
             print O $l;
           }
        }
      }
   }
   close(O);
 }
 if ($m) {  # send also to the master
   $url =  Util->makeUrl($m, "?PUT=saveM&file=Catalog&prefix=$host");
   ($err, $resp) = Util::Http->post($url, $out);
 }
}



#
# code = n2w : name to wwn     e => wwn
# code = a2w : access to wwn   ip => wwn
#

sub set {
  my($class, $code, $name, $value) = @_;
  my($host) = System->hostname();

  my($v1) = $CATALOG{$code}{$name}{$host};
  $CATALOG{$code}{$name}{$host} = $value;
    
  $code2 = substr($code,2) . "2" . substr($code,0,1);

  if ($v1 && ($value ne $v1)) {
    delete($CATALOG{$code2}{$v1}{$host});
  }
  $CATALOG{$code2}{$value}{$host} = $name;

}

#
# n2w, w2n, a2w, w2a 
#
#  $host: *=any_host , blank=current_host
sub get {
  my($class, $code, $name, $host) = @_;
  if (!$host) {
    my($host) = System->hostname();
    return $CATALOG{$code}{$name}{$host} ;
  } elsif ($host eq "*") {
    $p = $CATALOG{$code}{$name};
    foreach $v (keys %$p){
       return $p->{$v};
       last;
    }   
  }
  return undef;
}


  

1;
