#
#  PAGING USAGE
#
#  $pp = Paging::new({perpage => 5, q => $q,
#                       templ => $templ, color => "white",
#                       go => "$this?GO=search_list&name=$q->{name}"});

#  while (@a = DB::fetch($csr)) {
#      $x = $pp->loop;
#      next if ($x eq "next");
#      last if ($x eq "last");
#      ...
#  }
#  ...
#  $paging = $pp->paging;
#

package Paging;

sub new {
  my($t) = @_;
  my($templ,$q);
  bless($t,'Paging');

  $q = $t->{q};
  $t->{color} = "blue" if ($t->{color} eq "");
  $q->{page} = 1 if ($q->{page} eq "");
  $t->{cnt} = 0;
  $t->{pcnt}  = ($q->{page} -1) * $t->{perpage};
  $t->{pcnt2} = $q->{page}  * $t->{perpage};
  $t->{more} = 0;
  $templ = $t->{templ};

  return $t;
}

sub loop {
  my($t) = @_;
  $t->{cnt}++;
  return "next" if ($t->{cnt} <= $t->{pcnt}) ;
  if ($t->{cnt} > $t->{pcnt2}) {
     $t->{more} = 1;
     return "last";
  }
  return 0;
}

sub paging {
  my($t) = @_;
  my($prev, $pp, $next,$del,$q);
  my($ppage,$del2,$npage, $print,$first);

  $del2 = ($t->{go} =~ /\?/) ? "&":"?";

  $q = $t->{q};
  if ($q->{page} > 1) {
      $ppage = $q->{page} - 1;
      $prev  = "<a href=$t->{go}${del2}page=$ppage><font color=$t->{color}>Previous</font></a>";
      if ($q->{page} > 2) {
        $first= "|&nbsp;<a href=$t->{go}${del2}page=1><font color=$t->{color}>First</font></a>&nbsp;";
      }
      $print = 1;
  } else {
      $prev = "<font color=$t->{color}>Previous</font>";
  }
  if ($t->{more}) {
      $npage = $q->{page} + 1;
      $next = "<a href=$t->{go}${del2}page=$npage><font color=$t->{color}>Next</font></a>";
      $print = 1;
  } else {
      $next = "<font color=$t->{color}>Next</font>";
  }
  if ($print) {
     $pp = "[&nbsp;$prev&nbsp|&nbsp;$next&nbsp;$first]&nbsp;&nbsp;" . 
            "<font color=$t->{color}>Page $q->{page}</font>";
  }
  $pp;
}

1;
