package SRSProvider; 
#  $Name:  $ 
#  $Id: SRSProvider.pm,v 1.12 2001/08/23 00:24:24 ccadieux Exp $

use PDM;
use Carp;
use Message;
use Util;
use strict;
use Util::Http;

use base 'Provider';
sub revision {'$Revision: 1.12 $'}
sub description {"SRS"}

sub new {
  my($self, $pdm)  = @_;

  my($p) = { pdm => $pdm };

  bless($p,'SRSProvider');
  return $p;
}

sub UPDATE {
  my($class, $q) = @_;
  my($active, $ip, $proxy, $to, $err, $name, $nat, $info);
  my($renv, $dev, $host,$notifs, $o);

  if ($q->{ACTION} eq "Update") {
    ($renv, $dev, $host,$notifs) = PDM::ConfigFile->read;

    $renv->{'pro.srs.active'} = $q->{active}? "Y":"N";
    $renv->{'pro.srs.ip'}     = $q->{ip};
    PDM::ConfigFile->write( $renv, $dev, $host,$notifs);

    $err = &main::info("Configuration updated!", "green");
  }

  ($renv, $dev, $host,$notifs) = PDM::ConfigFile->read;

  if ($renv->{'pro.srs.active'} eq "Y") {
    $active = "checked" ;
  } else {
    $info = "<font color=red><b>Inactive</b>";
  }

  $ip     = $renv->{'pro.srs.ip'};
  $nat    = $renv->{'pro.srs.nat'};

 $o =<<EOF;
<body bgcolor=$main'BGCOLOR>
$err
<form  method=get>
 <input type=hidden name=GO value=GUI::Providers::display>
 <input type=hidden name=option value=$q->{option}>
<center>
<table border=2 cellspacing=2 width=90% bgcolor=white><tr><td>
<table border=0 cellspacing=2 width=100%>
<tr>
<td colspan=2 bgcolor=#666699><b><font color=white>&nbsp;SRS Provider Information</td>

<tr><td bgcolor=$main'LIGHT align=right>Active:</td>
      <td><input type=checkbox name=active $active> $info

<tr><td bgcolor=$main'LIGHT align=right>IP Address:</td>
      <td><input type=text name=ip value=\"$ip\" size=60>


</table>
</table>
<b>

<input type=submit name=ACTION value="Update">
</form>
EOF
  return $o;

}

sub RUN {
  my($pro) = @_;
  my($notifs, $notif, $p, $ed, $id, $cat);
  my($pdm)   = $pro->{pdm};
  my($ed_desc, $email_text);
  my($edocs) = $pdm->getMessages;

  return if ($pdm->getEventCount == 0);

  my($renv, $devices, $hosts, $notifs) = PDM::ConfigFile->read();

  return if ($renv->{'pro.srs.active'}  ne "Y");
  return if ($pdm->getEventCount() == 0);
  $DB::single = 1;

  my $dtd   = $renv->{'pro.srs.ip'};
  $dtd = "http://$dtd" if (substr($dtd,0,4) ne "http");
  $dtd .= "/" if (substr($dtd,-1) ne "/");
  $dtd .= "srs_station_message.dtd";

  my $SEQ = PDM->getCacheHandle("srs_seq");

  my $HEAD =<<EOF;
<?xml version="1.0" encoding="US-ASCII" standalone="no"?>
<!DOCTYPE srs_station_message SYSTEM "$dtd">
EOF

  my($topo, $last_topo, $mess);
  my $LD =  System->get_home(). "/DATA/last_srs_topo";

  $topo = &srs_topo($devices, $hosts, $renv);
  if (open(O, $LD)) {
     my @a = <O>; close(O);
     $last_topo = join("", @a);
  }
  my $time = System->srs_time();
  my $ip = Util->name2ip($renv->{hostname});

  if ($topo ne $last_topo) {
     $SEQ->{seq}++;
     $mess =<<EOF;
$HEAD
<srs_station_message seq_no="$SEQ->{seq}" timestamp="$time" 
                      sourceIP="$ip" sourceName="RASAgent">
   $topo
</srs_station_message>
EOF
     my $err = $pro->send($renv, $mess);
     Debug->print2("  - SRSProvider: topology");
     if ($err) {
        Debug->err(SRS => "Cannot send:$err");
     } else {
       open(O, ">$LD");
       print O $topo;
       close(O);
     }
  }
  
  my($ev, $x, $alert, $severity, $al, $agent, $host, $desc);
  my($event_desc, $event_type, $source);
  my($event_id, $event_time);

  $DB::single = 1;
  my($srs) ;
  for ($x=0; $x <= $#$edocs; $x++) {
     $ed   = $edocs->[$x];
     next if ($ed->type() eq Message::TYPE_ALERT); # Skip alerts

     $ev       = $ed->instances(0);
     next if ($ev->propertyByName("Actionable")->value ne "TRUE") ;  # must be actionable

     $alert = $edocs->[$x+1];
     $al = $alert->instances(0);

#           RAS    SRS
#  warning  1      3
#  error    2      4/minor 5/major
#  down     3      5/major 6/critital
#
     $severity   = $al->propertyByName("Severity")->value() + 2 ;    # must have a severity
     next if (!$severity);
     $event_desc = $ev->propertyByName("Description")->value();
     $event_id   = $ev->propertyByName("EventId")->value();
     $event_time = $ev->propertyByName("EventTime")->value();
     $event_time = substr($event_time,0,8) . "." .  substr($event_time,8,6) . 
                   substr($event_time, -5,3);
     $event_type = $ev->propertyByName("EventType")->value();
     $agent      = $ed->instances(1);
     $host       = $ed->instances(4);
     $source     = $ev->propertyByName("SourceIP")->value();
     next if (!$source);
     $cat   = $ed->id("category"); #  or System->model();
        
     my($sys)  = $ed->instances(4);
     $sys = $ed->instances(8) if ($sys->type() eq "H");

     $SEQ->{seq}++;

     $srs =<<EOF;
$HEAD
 <srs_station_message seq_no="$SEQ->{seq}" timestamp="$time" 
                      sourceIP="$ip" sourceName="RASAgent">
    <alarm source="$source" provider="RASAGENT" module="rasagent" 
           alarm_id="$event_id" timestamp="$event_time" state="1" severity="$severity"
           type="$event_type">
          $event_desc
    </alarm>
 </srs_station_message>
EOF
     $pro->send($renv, $srs);
     Debug->print2("  - SRSProvider: alarm $event_desc ");
  }

}

sub send {
   my($pro, $renv, $mess) = @_;

   my($url) = $renv->{'pro.srs.ip'};

   $url = "http://$url" if (substr($url,0,4) ne "http");
   $url .= "/ETMessage/";

   if (Debug->level() >= 3) {
      open(O, ">>/tmp/srs.xml");
      print O "url=$url\n";
      print O $mess;
      print O "\n--------------------------------------------\n";
      close(O);
   }
   my($err, $value) = Util::Http->post($url, $mess, 20);

   $err .= ": $value" if ($err);
   return $err;
}

sub srs_topo {
  my($devices, $hosts, $renv) = @_;
  my(%H,%G);
  foreach my $d (@$devices) {
     if ($d->{type} eq "t3") {
         $G{t3} .=<<EOF;
      <node action="ADD" address="$d->{ipno}" name="$d->{name}" 
             model="t3"   serial="$d->{wwn}"/>
EOF
     } elsif ($d->{type} eq "switch") {
         $G{switch} .=<<EOF;
      <node action="ADD" address="$d->{ipno}" name="$d->{name}" 
             model="switch" serial="$d->{wwn}"/>
EOF
     } else {
         if (!$G{$d->{host}}) {
            my($d_ip, $d_host);

            $d_host = $d->{host} || System->hostname();
            $d_ip = Util->name2ip($d_host);

            $G{$d->{host}} .=<<EOF;
      <node action="ADD" address="$d_ip" name="$d_host" model="SUNW" serial="">
EOF
         }
         $G{$d->{host}} .=<<EOF;
        <module name="$d->{name}" vendor="SUN" model="$d->{type}" 
                     serial="$d->{serial}" version="1.0" description="$d->{type}">
        </module>
EOF
     }
  }
  my $out =<<EOF;
<topology type="FULL">
  <provider name="RASAGENT" vendor="SUN Microsystems" version="2.1"
            description="Network Storage Agent"/>
EOF
  my %N = (t3 => "SAN_T3", switch => "SAN_Switch");
  foreach my $x (keys %G) {
     if ($x eq "t3" || $x eq "switch") {
        $out .= "    <group name=\"$N{$x}\" type=\"$x\">\n$G{$x}\n    </group>\n";
     }
  }
  foreach my $x (keys %G) {
     if ($x ne "t3" && $x ne "switch") {
        $out .= "$G{$x}      </node>\n";
     }
  }
  $out .= "</topology>\n";
  return $out;
}

  
1;
