package Util::Socket;

use Socket;

#
# Util::Socket->send("data", {timeout => 60, ans_len => 100)});
#

sub sendMessage {
  my($class, $url, $data, $arg) = @_;

  my($ip, $port) = split(/:/ , $url);
  my($rlen) = $arg->{ans_len} || 100;
  my($to)   = $arg->{timeout};
  if (!$port) {
    return ("Invalid Port", undef);
  }

  my ($remote, $iaddr, $paddr, $proto, $line);

  $remote  = $ip;
  if (!($iaddr = inet_aton($remote))) {
      return ("Util::Socket inet_aton failed $!", undef);
  }
  $paddr   = sockaddr_in($port, $iaddr);

  $proto   = getprotobyname('tcp');
  if (!socket(SOCK, PF_INET, SOCK_STREAM, $proto)) {
      return ("Util::Soclet socket failed: $!", undef);
  }
  if (!connect(SOCK, $paddr)) {
      return ("Util::Socket connect failed: $!", undef);
  }
  my($len) = length($data);
  my($current) = 0;
  while ($current < $len) {
    $l = send(SOCK, substr($data,$current) , 0);
    if (!defined($l)) {
       return ("Util::Socket send Error: $!", undef);
    }
    $current += $l;
  }
  my($ans);
  if ($to) {
    eval {
      local $SIG{ALRM} = sub { die "alarm\n" };
      alarm $to;
      recv(SOCK, $ans, $rlen,0);
    };
    alarm 0;
    close (SOCK);
    if ($@) {
       if ($@ eq "alarm\n") {
          return ("Util::Socket recv timeout: $@", undef);
       } else {
          return ("Util::Socket recv error: $@", undef);
       }
    }
  } else {
    recv(SOCK, $ans, $rlen,0);
    close (SOCK);
  }

  return (undef, $ans);
}
  
1;
