sub read_config {
  my($file) = @_;
  my($renv, $devices, @F) ;

  if (open(O, $file)) {
    while ($l = <O>) {
      push(@F, $l);
    }
    close(O);
    ($renv, $devices) = &parse_config(\@F);
    return ($renv, $devices);
  } else {
    print "Cannot read Configuration file $file: $! \n";
    exit;
  }
}

sub parse_config {
  my($F) = @_;
  my($x, $section, $k);
  my(%renv, @devices, %last);

  $section = -1;
  for ($x=0; $x <= $#$F; $x++) {
      $l = $F->[$x];
      next if (substr($l,0,1) eq "#" || $l =~ /^ *$/);
      if ($l =~ /\[(.*)\]/) {
        $section++;
        $devices[$section]{_name} = $1;
      } elsif ($l =~ /^(\w+)= *(.*)$/) {
        if ($section == -1) {
          $renv{$1} = $2;
        } else {
          if ($devices[$section]{$1}) {
             $last{"$section $1"}++;
             $k = $1 . $last{"$section $1"};
             $devices[$section]{$k} = $2;
          } else {
             $devices[$section]{$1} = $2;
             $last{"$section $1"} = 1;
          }
        }
      }
  }
  return (\%renv, \@devices);
}

1;


